/* PlaybackManager.c generated by valac 0.44.7, the Vala compiler
 * generated from PlaybackManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Corentin Noël <corentin@elementary.io>
 */

#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <gee.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gst/gst.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>

#define NOISE_TYPE_PLAYBACK_MANAGER (noise_playback_manager_get_type ())
#define NOISE_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager))
#define NOISE_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManagerClass))
#define NOISE_IS_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_PLAYBACK_MANAGER))
#define NOISE_IS_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_PLAYBACK_MANAGER))
#define NOISE_PLAYBACK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManagerClass))

typedef struct _NoisePlaybackManager NoisePlaybackManager;
typedef struct _NoisePlaybackManagerClass NoisePlaybackManagerClass;
typedef struct _NoisePlaybackManagerPrivate NoisePlaybackManagerPrivate;

#define NOISE_TYPE_HISTORY_PLAYLIST (noise_history_playlist_get_type ())
#define NOISE_HISTORY_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_HISTORY_PLAYLIST, NoiseHistoryPlaylist))
#define NOISE_HISTORY_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_HISTORY_PLAYLIST, NoiseHistoryPlaylistClass))
#define NOISE_IS_HISTORY_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_HISTORY_PLAYLIST))
#define NOISE_IS_HISTORY_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_HISTORY_PLAYLIST))
#define NOISE_HISTORY_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_HISTORY_PLAYLIST, NoiseHistoryPlaylistClass))

typedef struct _NoiseHistoryPlaylist NoiseHistoryPlaylist;
typedef struct _NoiseHistoryPlaylistClass NoiseHistoryPlaylistClass;

#define NOISE_TYPE_STREAMER (noise_streamer_get_type ())
#define NOISE_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_STREAMER, NoiseStreamer))
#define NOISE_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_STREAMER, NoiseStreamerClass))
#define NOISE_IS_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_STREAMER))
#define NOISE_IS_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_STREAMER))
#define NOISE_STREAMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_STREAMER, NoiseStreamerClass))

typedef struct _NoiseStreamer NoiseStreamer;
typedef struct _NoiseStreamerClass NoiseStreamerClass;
enum  {
	NOISE_PLAYBACK_MANAGER_0_PROPERTY,
	NOISE_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY,
	NOISE_PLAYBACK_MANAGER_PLAYING_PROPERTY,
	NOISE_PLAYBACK_MANAGER_VOLUME_PROPERTY,
	NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY,
	NOISE_PLAYBACK_MANAGER_NUM_PROPERTIES
};
static GParamSpec* noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block10Data Block10Data;
#define _g_free0(var) (var = (g_free (var), NULL))

#define NOISE_TYPE_LIBRARY_WINDOW (noise_library_window_get_type ())
#define NOISE_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindow))
#define NOISE_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))
#define NOISE_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))

typedef struct _NoiseLibraryWindow NoiseLibraryWindow;
typedef struct _NoiseLibraryWindowClass NoiseLibraryWindowClass;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
enum  {
	NOISE_PLAYBACK_MANAGER_CHANGING_PLAYER_SIGNAL,
	NOISE_PLAYBACK_MANAGER_MEDIA_PLAYED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_PLAYBACK_STOPPED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_PLAYBACK_STARTED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_PLAYBACK_PAUSED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_PLAYER_CHANGED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_QUEUE_CLEARED_SIGNAL,
	NOISE_PLAYBACK_MANAGER_NUM_SIGNALS
};
static guint noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_NUM_SIGNALS] = {0};

struct _NoisePlaybackManager {
	GObject parent_instance;
	NoisePlaybackManagerPrivate * priv;
	NoiseStaticPlaylist* queue_playlist;
	NoiseHistoryPlaylist* history_playlist;
	NoiseStreamer* file_player;
	NoisePlayback* player;
};

struct _NoisePlaybackManagerClass {
	GObjectClass parent_class;
};

struct _NoisePlaybackManagerPrivate {
	GeeTreeSet* playbacks;
	GRecMutex __lock_playbacks;
	GeeHashMap* _current;
	GeeHashMap* _current_shuffled;
	gint _current_index;
	gint _current_shuffled_index;
	gboolean _playing;
	gdouble saved_volume;
	gboolean _playing_queued_song;
	NoiseMedia* _current_media;
};

struct _Block10Data {
	int _ref_count_;
	NoisePlaybackManager* self;
	NoiseMedia* m;
};

static gint NoisePlaybackManager_private_offset;
static gpointer noise_playback_manager_parent_class = NULL;

GType noise_playback_manager_get_type (void) G_GNUC_CONST;
GType noise_history_playlist_get_type (void) G_GNUC_CONST;
GType noise_streamer_get_type (void) G_GNUC_CONST;
void noise_playback_manager_add_playback (NoisePlaybackManager* self,
                                          NoisePlayback* playback);
void noise_playback_manager_queue_media (NoisePlaybackManager* self,
                                         GeeCollection* to_queue);
static void noise_playback_manager_add_to_current (NoisePlaybackManager* self,
                                            NoiseMedia* m);
static void noise_playback_manager_reshuffle (NoisePlaybackManager* self);
void noise_playback_manager_unqueue_media (NoisePlaybackManager* self,
                                           GeeCollection* to_unqueue);
static NoiseMedia* noise_playback_manager_poll_queue (NoisePlaybackManager* self);
void noise_playback_manager_clear_queue (NoisePlaybackManager* self);
void noise_playback_manager_set_current_index (NoisePlaybackManager* self,
                                               gint value);
NoiseMedia* noise_playback_manager_media_from_current_index (NoisePlaybackManager* self,
                                                             gint index_in_current);
GeeCollection* noise_playback_manager_get_current_media_list (NoisePlaybackManager* self);
void noise_playback_manager_set_repeat_mode (NoisePlaybackManager* self,
                                             NoiseSettingsRepeat mode);
void noise_playback_manager_set_shuffle_mode (NoisePlaybackManager* self,
                                              NoiseSettingsShuffle mode);
NoiseMedia* noise_playback_manager_get_current_media (NoisePlaybackManager* self);
NoiseMedia* noise_playback_manager_get_next (NoisePlaybackManager* self,
                                             gboolean play);
static NoiseLibrary* noise_playback_manager_get_library (NoisePlaybackManager* self);
void noise_playback_manager_stop_playback (NoisePlaybackManager* self);
void noise_playback_manager_play_media (NoisePlaybackManager* self,
                                        NoiseMedia* m);
NoiseMedia* noise_playback_manager_get_previous (NoisePlaybackManager* self,
                                                 gboolean play);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void noise_playback_manager_set_current_media (NoisePlaybackManager* self,
                                               NoiseMedia* value);
void noise_playback_manager_set_volume (NoisePlaybackManager* self,
                                        gdouble value);
void noise_playback_manager_change_gains_thread (NoisePlaybackManager* self);
gboolean noise_playback_manager_get_playing (NoisePlaybackManager* self);
GSettings* noise_app_get_saved_state (void);
static gboolean __lambda33_ (Block10Data* _data10_);
static gboolean ___lambda33__gsource_func (gpointer self);
static void noise_playback_manager_set_playing (NoisePlaybackManager* self,
                                         gboolean value);
void noise_playback_manager_start_playback (NoisePlaybackManager* self);
GType noise_library_window_get_type (void) G_GNUC_CONST;
NoiseLibraryWindow* noise_app_get_main_window (void);
GSimpleActionGroup* noise_library_window_get_actions (NoiseLibraryWindow* self);
#define NOISE_LIBRARY_WINDOW_ACTION_PLAY "action_play"
static GVariant* _variant_new4 (gboolean value);
void noise_playback_manager_pause_playback (NoisePlaybackManager* self);
static GVariant* _variant_new5 (gboolean value);
NoisePlaybackManager* noise_playback_manager_new (void);
NoisePlaybackManager* noise_playback_manager_construct (GType object_type);
gint noise_playback_manager_get_current_index (NoisePlaybackManager* self);
gdouble noise_playback_manager_get_volume (NoisePlaybackManager* self);
static void g_cclosure_user_marshal_VOID__INT64 (GClosure * closure,
                                          GValue * return_value,
                                          guint n_param_values,
                                          const GValue * param_values,
                                          gpointer invocation_hint,
                                          gpointer marshal_data);
static GObject * noise_playback_manager_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
NoiseHistoryPlaylist* noise_history_playlist_new (void);
NoiseHistoryPlaylist* noise_history_playlist_construct (GType object_type);
NoiseStreamer* noise_streamer_new (void);
NoiseStreamer* noise_streamer_construct (GType object_type);
static void noise_playback_manager_finalize (GObject * obj);
static void _vala_noise_playback_manager_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_noise_playback_manager_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

static inline gpointer
noise_playback_manager_get_instance_private (NoisePlaybackManager* self)
{
	return G_STRUCT_MEMBER_P (self, NoisePlaybackManager_private_offset);
}

void
noise_playback_manager_add_playback (NoisePlaybackManager* self,
                                     NoisePlayback* playback)
{
	GeeTreeSet* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (playback != NULL);
	_tmp0_ = self->priv->playbacks;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, playback);
}

void
noise_playback_manager_queue_media (NoisePlaybackManager* self,
                                    GeeCollection* to_queue)
{
	gint _tmp0_;
	gint _tmp1_;
	NoiseStaticPlaylist* _tmp10_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (to_queue != NULL);
	_tmp0_ = gee_collection_get_size (to_queue);
	_tmp1_ = _tmp0_;
	if (_tmp1_ < 1) {
		return;
	}
	{
		GeeIterator* _q_it = NULL;
		GeeIterator* _tmp2_;
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) to_queue);
		_q_it = _tmp2_;
		while (TRUE) {
			GeeIterator* _tmp3_;
			NoiseMedia* q = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			NoiseMedia* _tmp6_;
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			NoiseMedia* _tmp9_;
			_tmp3_ = _q_it;
			if (!gee_iterator_next (_tmp3_)) {
				break;
			}
			_tmp4_ = _q_it;
			_tmp5_ = gee_iterator_get (_tmp4_);
			q = (NoiseMedia*) _tmp5_;
			_tmp6_ = q;
			_tmp7_ = noise_media_get_title (_tmp6_);
			_tmp8_ = _tmp7_;
			g_debug ("PlaybackManager.vala:126: QUEUED: %s", _tmp8_);
			_tmp9_ = q;
			noise_playback_manager_add_to_current (self, _tmp9_);
			_g_object_unref0 (q);
		}
		_g_object_unref0 (_q_it);
	}
	_tmp10_ = self->queue_playlist;
	noise_playlist_add_medias ((NoisePlaylist*) _tmp10_, to_queue);
	noise_playback_manager_reshuffle (self);
}

void
noise_playback_manager_unqueue_media (NoisePlaybackManager* self,
                                      GeeCollection* to_unqueue)
{
	NoiseStaticPlaylist* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (to_unqueue != NULL);
	_tmp0_ = self->queue_playlist;
	noise_playlist_remove_medias ((NoisePlaylist*) _tmp0_, to_unqueue);
}

static NoiseMedia*
noise_playback_manager_poll_queue (NoisePlaybackManager* self)
{
	NoiseMedia* result = NULL;
	NoiseMedia* m = NULL;
	NoiseStaticPlaylist* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	gpointer _tmp3_;
	NoiseStaticPlaylist* _tmp4_;
	GeeArrayList* _tmp5_;
	GeeArrayList* _tmp6_;
	gpointer _tmp7_;
	NoiseMedia* _tmp8_;
	GeeLinkedList* unqueued = NULL;
	GeeLinkedList* _tmp9_;
	NoiseStaticPlaylist* _tmp10_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->queue_playlist;
	_tmp1_ = noise_playlist_get_medias ((NoisePlaylist*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = gee_abstract_list_get ((GeeAbstractList*) _tmp2_, 0);
	m = (NoiseMedia*) _tmp3_;
	_tmp4_ = self->queue_playlist;
	_tmp5_ = noise_playlist_get_medias ((NoisePlaylist*) _tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp6_, 0);
	_tmp8_ = (NoiseMedia*) _tmp7_;
	_g_object_unref0 (_tmp8_);
	_tmp9_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	unqueued = _tmp9_;
	gee_abstract_collection_add ((GeeAbstractCollection*) unqueued, m);
	_tmp10_ = self->queue_playlist;
	g_signal_emit_by_name ((NoisePlaylist*) _tmp10_, "media-removed", (GeeCollection*) unqueued);
	result = m;
	_g_object_unref0 (unqueued);
	return result;
}

void
noise_playback_manager_clear_queue (NoisePlaybackManager* self)
{
	NoiseStaticPlaylist* _tmp0_;
	GeeHashMap* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->queue_playlist;
	noise_playlist_clear ((NoisePlaylist*) _tmp0_);
	_tmp1_ = self->priv->_current;
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp1_);
	noise_playback_manager_set_current_index (self, 0);
	noise_playback_manager_reshuffle (self);
}

NoiseMedia*
noise_playback_manager_media_from_current_index (NoisePlaybackManager* self,
                                                 gint index_in_current)
{
	NoiseMedia* result = NULL;
	NoiseSettingsMain* _tmp0_;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsShuffle _tmp2_;
	NoiseSettingsShuffle _tmp3_;
	gboolean _tmp4_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = noise_settings_main_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = noise_settings_main_get_shuffle_mode (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp3_ == NOISE_SETTINGS_SHUFFLE_OFF;
	_g_object_unref0 (_tmp1_);
	if (_tmp4_) {
		GeeHashMap* _tmp5_;
		gpointer _tmp6_;
		_tmp5_ = self->priv->_current;
		_tmp6_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp5_, (gpointer) ((gintptr) index_in_current));
		result = (NoiseMedia*) _tmp6_;
		return result;
	} else {
		GeeHashMap* _tmp7_;
		gpointer _tmp8_;
		_tmp7_ = self->priv->_current_shuffled;
		_tmp8_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp7_, (gpointer) ((gintptr) index_in_current));
		result = (NoiseMedia*) _tmp8_;
		return result;
	}
}

GeeCollection*
noise_playback_manager_get_current_media_list (NoisePlaybackManager* self)
{
	GeeCollection* result = NULL;
	NoiseSettingsMain* _tmp0_;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsShuffle _tmp2_;
	NoiseSettingsShuffle _tmp3_;
	gboolean _tmp4_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = noise_settings_main_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = noise_settings_main_get_shuffle_mode (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp3_ == NOISE_SETTINGS_SHUFFLE_OFF;
	_g_object_unref0 (_tmp1_);
	if (_tmp4_) {
		GeeHashMap* _tmp5_;
		GeeCollection* _tmp6_;
		GeeCollection* _tmp7_;
		_tmp5_ = self->priv->_current_shuffled;
		_tmp6_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp5_);
		_tmp7_ = _tmp6_;
		result = _tmp7_;
		return result;
	} else {
		GeeHashMap* _tmp8_;
		GeeCollection* _tmp9_;
		GeeCollection* _tmp10_;
		_tmp8_ = self->priv->_current;
		_tmp9_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp8_);
		_tmp10_ = _tmp9_;
		result = _tmp10_;
		return result;
	}
}

static void
noise_playback_manager_add_to_current (NoisePlaybackManager* self,
                                       NoiseMedia* m)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (m != NULL);
	_tmp0_ = self->priv->_current;
	_tmp1_ = self->priv->_current;
	_tmp2_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp1_);
	_tmp3_ = _tmp2_;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp0_, (gpointer) ((gintptr) _tmp3_), m);
}

void
noise_playback_manager_set_repeat_mode (NoisePlaybackManager* self,
                                        NoiseSettingsRepeat mode)
{
	NoiseSettingsMain* main_settings = NULL;
	NoiseSettingsMain* _tmp0_;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsRepeat _tmp2_;
	NoiseSettingsRepeat _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = noise_settings_main_get_default ();
	main_settings = _tmp0_;
	_tmp1_ = main_settings;
	_tmp2_ = noise_settings_main_get_repeat_mode (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ != mode) {
		NoiseSettingsMain* _tmp4_;
		_tmp4_ = main_settings;
		noise_settings_main_set_repeat_mode (_tmp4_, mode);
	}
	_g_object_unref0 (main_settings);
}

void
noise_playback_manager_set_shuffle_mode (NoisePlaybackManager* self,
                                         NoiseSettingsShuffle mode)
{
	NoiseSettingsMain* main_settings = NULL;
	NoiseSettingsMain* _tmp0_;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsShuffle _tmp2_;
	NoiseSettingsShuffle _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = noise_settings_main_get_default ();
	main_settings = _tmp0_;
	_tmp1_ = main_settings;
	_tmp2_ = noise_settings_main_get_shuffle_mode (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ != mode) {
		NoiseSettingsMain* _tmp4_;
		_tmp4_ = main_settings;
		noise_settings_main_set_shuffle_mode (_tmp4_, mode);
		noise_playback_manager_reshuffle (self);
	}
	_g_object_unref0 (main_settings);
}

/**
    * Regenerate the shuffled queue if needed
    */
static void
noise_playback_manager_reshuffle (NoisePlaybackManager* self)
{
	GeeHashMap* _tmp0_;
	NoiseSettingsMain* main_settings = NULL;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsMain* _tmp2_;
	NoiseSettingsShuffle _tmp3_;
	NoiseSettingsShuffle _tmp4_;
	g_return_if_fail (self != NULL);
	g_debug ("PlaybackManager.vala:194: Reshuffling");
	_tmp0_ = self->priv->_current_shuffled;
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp0_);
	self->priv->_current_shuffled_index = 0;
	_tmp1_ = noise_settings_main_get_default ();
	main_settings = _tmp1_;
	_tmp2_ = main_settings;
	_tmp3_ = noise_settings_main_get_shuffle_mode (_tmp2_);
	_tmp4_ = _tmp3_;
	if (_tmp4_ == NOISE_SETTINGS_SHUFFLE_OFF) {
		NoiseMedia* _tmp5_;
		_tmp5_ = self->priv->_current_media;
		if (_tmp5_ != NULL) {
			{
				gint i = 0;
				i = 0;
				{
					gboolean _tmp6_ = FALSE;
					_tmp6_ = TRUE;
					while (TRUE) {
						GeeHashMap* _tmp7_;
						gint _tmp8_;
						gint _tmp9_;
						GeeHashMap* _tmp10_;
						gpointer _tmp11_;
						NoiseMedia* _tmp12_;
						NoiseMedia* _tmp13_;
						gboolean _tmp14_;
						if (!_tmp6_) {
							i = i + 1;
						}
						_tmp6_ = FALSE;
						_tmp7_ = self->priv->_current;
						_tmp8_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp7_);
						_tmp9_ = _tmp8_;
						if (!(i < _tmp9_)) {
							break;
						}
						_tmp10_ = self->priv->_current;
						_tmp11_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp10_, (gpointer) ((gintptr) i));
						_tmp12_ = (NoiseMedia*) _tmp11_;
						_tmp13_ = self->priv->_current_media;
						_tmp14_ = _tmp12_ == _tmp13_;
						_g_object_unref0 (_tmp12_);
						if (_tmp14_) {
							self->priv->_current_index = i;
							_g_object_unref0 (main_settings);
							return;
						}
					}
				}
			}
		} else {
			self->priv->_current_index = 0;
		}
	} else {
		NoiseSettingsMain* _tmp15_;
		NoiseSettingsShuffle _tmp16_;
		NoiseSettingsShuffle _tmp17_;
		_tmp15_ = main_settings;
		_tmp16_ = noise_settings_main_get_shuffle_mode (_tmp15_);
		_tmp17_ = _tmp16_;
		if (_tmp17_ == NOISE_SETTINGS_SHUFFLE_ALL) {
			GeeLinkedList* temp = NULL;
			GeeLinkedList* _tmp18_;
			gboolean current_media_found = FALSE;
			gboolean _tmp32_ = FALSE;
			NoiseMedia* _tmp33_;
			_tmp18_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
			temp = _tmp18_;
			current_media_found = FALSE;
			{
				GeeIterator* _m_it = NULL;
				GeeHashMap* _tmp19_;
				GeeCollection* _tmp20_;
				GeeCollection* _tmp21_;
				GeeCollection* _tmp22_;
				GeeIterator* _tmp23_;
				GeeIterator* _tmp24_;
				_tmp19_ = self->priv->_current;
				_tmp20_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp19_);
				_tmp21_ = _tmp20_;
				_tmp22_ = _tmp21_;
				_tmp23_ = gee_iterable_iterator ((GeeIterable*) _tmp22_);
				_tmp24_ = _tmp23_;
				_g_object_unref0 (_tmp22_);
				_m_it = _tmp24_;
				while (TRUE) {
					GeeIterator* _tmp25_;
					NoiseMedia* m = NULL;
					GeeIterator* _tmp26_;
					gpointer _tmp27_;
					NoiseMedia* _tmp28_;
					NoiseMedia* _tmp29_;
					_tmp25_ = _m_it;
					if (!gee_iterator_next (_tmp25_)) {
						break;
					}
					_tmp26_ = _m_it;
					_tmp27_ = gee_iterator_get (_tmp26_);
					m = (NoiseMedia*) _tmp27_;
					_tmp28_ = self->priv->_current_media;
					_tmp29_ = m;
					if (_tmp28_ != _tmp29_) {
						GeeLinkedList* _tmp30_;
						NoiseMedia* _tmp31_;
						_tmp30_ = temp;
						_tmp31_ = m;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp30_, _tmp31_);
					} else {
						current_media_found = TRUE;
					}
					_g_object_unref0 (m);
				}
				_g_object_unref0 (_m_it);
			}
			_tmp33_ = self->priv->_current_media;
			if (_tmp33_ != NULL) {
				_tmp32_ = current_media_found;
			} else {
				_tmp32_ = FALSE;
			}
			if (_tmp32_) {
				GeeHashMap* _tmp34_;
				NoiseMedia* _tmp35_;
				_tmp34_ = self->priv->_current_shuffled;
				_tmp35_ = self->priv->_current_media;
				gee_abstract_map_set ((GeeAbstractMap*) _tmp34_, (gpointer) ((gintptr) 0), _tmp35_);
			} else {
				gboolean _tmp36_ = FALSE;
				NoiseMedia* _tmp37_;
				_tmp37_ = self->priv->_current_media;
				if (_tmp37_ != NULL) {
					GeeHashMap* _tmp38_;
					gint _tmp39_;
					gint _tmp40_;
					_tmp38_ = self->priv->_current;
					_tmp39_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp38_);
					_tmp40_ = _tmp39_;
					_tmp36_ = _tmp40_ != 0;
				} else {
					_tmp36_ = FALSE;
				}
				if (_tmp36_) {
					GeeHashMap* _tmp41_;
					GeeHashMap* _tmp42_;
					gpointer _tmp43_;
					NoiseMedia* _tmp44_;
					_tmp41_ = self->priv->_current_shuffled;
					_tmp42_ = self->priv->_current;
					_tmp43_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp42_, (gpointer) ((gintptr) 0));
					_tmp44_ = (NoiseMedia*) _tmp43_;
					gee_abstract_map_set ((GeeAbstractMap*) _tmp41_, (gpointer) ((gintptr) 0), _tmp44_);
					_g_object_unref0 (_tmp44_);
				}
			}
			{
				gint _tmp45_ = 0;
				NoiseMedia* _tmp46_;
				gint i = 0;
				_tmp46_ = self->priv->_current_media;
				if (_tmp46_ == NULL) {
					_tmp45_ = 0;
				} else {
					_tmp45_ = 1;
				}
				i = _tmp45_;
				{
					gboolean _tmp47_ = FALSE;
					_tmp47_ = TRUE;
					while (TRUE) {
						GeeHashMap* _tmp49_;
						gint _tmp50_;
						gint _tmp51_;
						gint n_media = 0;
						GeeLinkedList* _tmp52_;
						gint _tmp53_;
						gint _tmp54_;
						gint random = 0;
						GeeHashMap* _tmp55_;
						GeeLinkedList* _tmp56_;
						gpointer _tmp57_;
						NoiseMedia* _tmp58_;
						GeeLinkedList* _tmp59_;
						GeeLinkedList* _tmp60_;
						gpointer _tmp61_;
						NoiseMedia* _tmp62_;
						if (!_tmp47_) {
							gint _tmp48_;
							_tmp48_ = i;
							i = _tmp48_ + 1;
						}
						_tmp47_ = FALSE;
						_tmp49_ = self->priv->_current;
						_tmp50_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp49_);
						_tmp51_ = _tmp50_;
						if (!(i < _tmp51_)) {
							break;
						}
						_tmp52_ = temp;
						_tmp53_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp52_);
						_tmp54_ = _tmp53_;
						n_media = _tmp54_;
						if (n_media == 0) {
							break;
						}
						random = (gint) g_random_int_range ((gint32) 0, (gint32) n_media);
						_tmp55_ = self->priv->_current_shuffled;
						_tmp56_ = temp;
						_tmp57_ = gee_abstract_list_get ((GeeAbstractList*) _tmp56_, random);
						_tmp58_ = (NoiseMedia*) _tmp57_;
						gee_abstract_map_set ((GeeAbstractMap*) _tmp55_, (gpointer) ((gintptr) i), _tmp58_);
						_g_object_unref0 (_tmp58_);
						_tmp59_ = temp;
						_tmp60_ = temp;
						_tmp61_ = gee_abstract_list_get ((GeeAbstractList*) _tmp60_, random);
						_tmp62_ = (NoiseMedia*) _tmp61_;
						gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp59_, _tmp62_);
						_g_object_unref0 (_tmp62_);
					}
				}
			}
			_g_object_unref0 (temp);
		}
	}
	_g_object_unref0 (main_settings);
}

NoiseMedia*
noise_playback_manager_get_next (NoisePlaybackManager* self,
                                 gboolean play)
{
	NoiseMedia* result = NULL;
	NoiseMedia* rv = NULL;
	NoiseSettingsMain* main_settings = NULL;
	NoiseSettingsMain* _tmp0_;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsShuffle _tmp2_;
	NoiseSettingsShuffle _tmp3_;
	NoiseStaticPlaylist* _tmp159_;
	GeeArrayList* _tmp160_;
	GeeArrayList* _tmp161_;
	NoiseMedia* _tmp162_;
	g_return_val_if_fail (self != NULL, NULL);
	rv = NULL;
	_tmp0_ = noise_settings_main_get_default ();
	main_settings = _tmp0_;
	_tmp1_ = main_settings;
	_tmp2_ = noise_settings_main_get_shuffle_mode (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ != NOISE_SETTINGS_SHUFFLE_OFF) {
		GeeHashMap* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		GeeHashMap* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
		NoiseMedia* _tmp17_;
		_tmp4_ = self->priv->_current_shuffled;
		_tmp5_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp4_);
		_tmp6_ = _tmp5_;
		g_debug ("PlaybackManager.vala:255: Shuffled size: %d", _tmp6_);
		_tmp7_ = self->priv->_current_shuffled;
		_tmp8_ = gee_map_get_is_empty ((GeeMap*) _tmp7_);
		_tmp9_ = _tmp8_;
		if (_tmp9_) {
			GeeHashMap* _tmp10_;
			gboolean _tmp11_;
			gboolean _tmp12_;
			_tmp10_ = self->priv->_current;
			_tmp11_ = gee_map_get_is_empty ((GeeMap*) _tmp10_);
			_tmp12_ = _tmp11_;
			if (_tmp12_) {
				NoiseLibrary* _tmp13_;
				NoiseLibrary* _tmp14_;
				GeeCollection* _tmp15_;
				GeeCollection* _tmp16_;
				_tmp13_ = noise_playback_manager_get_library (self);
				_tmp14_ = _tmp13_;
				_tmp15_ = noise_library_get_medias (_tmp14_);
				_tmp16_ = _tmp15_;
				noise_playback_manager_queue_media (self, _tmp16_);
				_g_object_unref0 (_tmp16_);
			}
			noise_playback_manager_reshuffle (self);
		}
		self->priv->_playing_queued_song = FALSE;
		_tmp17_ = self->priv->_current_media;
		if (_tmp17_ == NULL) {
			GeeHashMap* _tmp18_;
			gpointer _tmp19_;
			self->priv->_current_shuffled_index = 0;
			_tmp18_ = self->priv->_current_shuffled;
			_tmp19_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp18_, (gpointer) ((gintptr) 0));
			_g_object_unref0 (rv);
			rv = (NoiseMedia*) _tmp19_;
		} else {
			NoiseSettingsMain* _tmp20_;
			NoiseSettingsRepeat _tmp21_;
			NoiseSettingsRepeat _tmp22_;
			_tmp20_ = main_settings;
			_tmp21_ = noise_settings_main_get_repeat_mode (_tmp20_);
			_tmp22_ = _tmp21_;
			if (_tmp22_ == NOISE_SETTINGS_REPEAT_MEDIA) {
				GeeHashMap* _tmp23_;
				gpointer _tmp24_;
				_tmp23_ = self->priv->_current_shuffled;
				_tmp24_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp23_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
				_g_object_unref0 (rv);
				rv = (NoiseMedia*) _tmp24_;
			} else {
				GeeHashMap* _tmp25_;
				gint _tmp26_;
				gint _tmp27_;
				_tmp25_ = self->priv->_current_shuffled;
				_tmp26_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp25_);
				_tmp27_ = _tmp26_;
				if (self->priv->_current_shuffled_index == (_tmp27_ - 1)) {
					NoiseSettingsMain* _tmp28_;
					NoiseSettingsRepeat _tmp29_;
					NoiseSettingsRepeat _tmp30_;
					GeeHashMap* _tmp31_;
					gpointer _tmp32_;
					_tmp28_ = main_settings;
					_tmp29_ = noise_settings_main_get_repeat_mode (_tmp28_);
					_tmp30_ = _tmp29_;
					if (_tmp30_ == NOISE_SETTINGS_REPEAT_ALL) {
						self->priv->_current_shuffled_index = 0;
					} else {
						if (play) {
							noise_playback_manager_stop_playback (self);
						}
						result = NULL;
						_g_object_unref0 (main_settings);
						_g_object_unref0 (rv);
						return result;
					}
					_tmp31_ = self->priv->_current_shuffled;
					_tmp32_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp31_, (gpointer) ((gintptr) 0));
					_g_object_unref0 (rv);
					rv = (NoiseMedia*) _tmp32_;
				} else {
					gboolean _tmp33_ = FALSE;
					if (self->priv->_current_shuffled_index >= 0) {
						GeeHashMap* _tmp34_;
						gint _tmp35_;
						gint _tmp36_;
						_tmp34_ = self->priv->_current_shuffled;
						_tmp35_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp34_);
						_tmp36_ = _tmp35_;
						_tmp33_ = self->priv->_current_shuffled_index < (_tmp36_ - 1);
					} else {
						_tmp33_ = FALSE;
					}
					if (_tmp33_) {
						NoiseMedia* next_current = NULL;
						GeeHashMap* _tmp37_;
						gpointer _tmp38_;
						NoiseMedia* now_current = NULL;
						GeeHashMap* _tmp39_;
						gpointer _tmp40_;
						gboolean _tmp41_ = FALSE;
						NoiseSettingsMain* _tmp42_;
						NoiseSettingsRepeat _tmp43_;
						NoiseSettingsRepeat _tmp44_;
						GeeHashMap* _tmp82_;
						gpointer _tmp83_;
						_tmp37_ = self->priv->_current_shuffled;
						_tmp38_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp37_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index + 1)));
						next_current = (NoiseMedia*) _tmp38_;
						_tmp39_ = self->priv->_current_shuffled;
						_tmp40_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp39_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
						now_current = (NoiseMedia*) _tmp40_;
						_tmp42_ = main_settings;
						_tmp43_ = noise_settings_main_get_repeat_mode (_tmp42_);
						_tmp44_ = _tmp43_;
						if (_tmp44_ == NOISE_SETTINGS_REPEAT_ARTIST) {
							NoiseMedia* _tmp45_;
							const gchar* _tmp46_;
							const gchar* _tmp47_;
							NoiseMedia* _tmp48_;
							const gchar* _tmp49_;
							const gchar* _tmp50_;
							_tmp45_ = next_current;
							_tmp46_ = noise_media_get_artist (_tmp45_);
							_tmp47_ = _tmp46_;
							_tmp48_ = now_current;
							_tmp49_ = noise_media_get_artist (_tmp48_);
							_tmp50_ = _tmp49_;
							_tmp41_ = g_strcmp0 (_tmp47_, _tmp50_) != 0;
						} else {
							_tmp41_ = FALSE;
						}
						if (_tmp41_) {
							while (TRUE) {
								GeeHashMap* _tmp51_;
								gpointer _tmp52_;
								NoiseMedia* _tmp53_;
								const gchar* _tmp54_;
								const gchar* _tmp55_;
								NoiseMedia* _tmp56_;
								const gchar* _tmp57_;
								const gchar* _tmp58_;
								gboolean _tmp59_;
								gint _tmp60_;
								_tmp51_ = self->priv->_current_shuffled;
								_tmp52_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp51_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index - 1)));
								_tmp53_ = (NoiseMedia*) _tmp52_;
								_tmp54_ = noise_media_get_artist (_tmp53_);
								_tmp55_ = _tmp54_;
								_tmp56_ = self->priv->_current_media;
								_tmp57_ = noise_media_get_artist (_tmp56_);
								_tmp58_ = _tmp57_;
								_tmp59_ = !(g_strcmp0 (_tmp55_, _tmp58_) == 0);
								_g_object_unref0 (_tmp53_);
								if (_tmp59_) {
									break;
								}
								_tmp60_ = self->priv->_current_shuffled_index;
								self->priv->_current_shuffled_index = _tmp60_ - 1;
							}
						} else {
							gboolean _tmp61_ = FALSE;
							NoiseSettingsMain* _tmp62_;
							NoiseSettingsRepeat _tmp63_;
							NoiseSettingsRepeat _tmp64_;
							_tmp62_ = main_settings;
							_tmp63_ = noise_settings_main_get_repeat_mode (_tmp62_);
							_tmp64_ = _tmp63_;
							if (_tmp64_ == NOISE_SETTINGS_REPEAT_ALBUM) {
								NoiseMedia* _tmp65_;
								const gchar* _tmp66_;
								const gchar* _tmp67_;
								NoiseMedia* _tmp68_;
								const gchar* _tmp69_;
								const gchar* _tmp70_;
								_tmp65_ = next_current;
								_tmp66_ = noise_media_get_album (_tmp65_);
								_tmp67_ = _tmp66_;
								_tmp68_ = now_current;
								_tmp69_ = noise_media_get_album (_tmp68_);
								_tmp70_ = _tmp69_;
								_tmp61_ = g_strcmp0 (_tmp67_, _tmp70_) != 0;
							} else {
								_tmp61_ = FALSE;
							}
							if (_tmp61_) {
								while (TRUE) {
									GeeHashMap* _tmp71_;
									gpointer _tmp72_;
									NoiseMedia* _tmp73_;
									const gchar* _tmp74_;
									const gchar* _tmp75_;
									NoiseMedia* _tmp76_;
									const gchar* _tmp77_;
									const gchar* _tmp78_;
									gboolean _tmp79_;
									gint _tmp80_;
									_tmp71_ = self->priv->_current_shuffled;
									_tmp72_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp71_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index - 1)));
									_tmp73_ = (NoiseMedia*) _tmp72_;
									_tmp74_ = noise_media_get_album (_tmp73_);
									_tmp75_ = _tmp74_;
									_tmp76_ = self->priv->_current_media;
									_tmp77_ = noise_media_get_album (_tmp76_);
									_tmp78_ = _tmp77_;
									_tmp79_ = !(g_strcmp0 (_tmp75_, _tmp78_) == 0);
									_g_object_unref0 (_tmp73_);
									if (_tmp79_) {
										break;
									}
									_tmp80_ = self->priv->_current_shuffled_index;
									self->priv->_current_shuffled_index = _tmp80_ - 1;
								}
							} else {
								gint _tmp81_;
								_tmp81_ = self->priv->_current_shuffled_index;
								self->priv->_current_shuffled_index = _tmp81_ + 1;
							}
						}
						_tmp82_ = self->priv->_current_shuffled;
						_tmp83_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp82_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
						_g_object_unref0 (rv);
						rv = (NoiseMedia*) _tmp83_;
						_g_object_unref0 (now_current);
						_g_object_unref0 (next_current);
					} else {
						GeeHashMap* _tmp84_;
						gpointer _tmp85_;
						self->priv->_current_shuffled_index = 0;
						noise_playback_manager_set_shuffle_mode (self, NOISE_SETTINGS_SHUFFLE_ALL);
						_tmp84_ = self->priv->_current_shuffled;
						_tmp85_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp84_, (gpointer) ((gintptr) 0));
						_g_object_unref0 (rv);
						rv = (NoiseMedia*) _tmp85_;
					}
				}
			}
		}
	} else {
		NoiseMedia* _tmp86_;
		self->priv->_playing_queued_song = FALSE;
		_tmp86_ = self->priv->_current_media;
		if (_tmp86_ == NULL) {
			GeeHashMap* _tmp87_;
			gpointer _tmp88_;
			self->priv->_current_index = 0;
			_tmp87_ = self->priv->_current;
			_tmp88_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp87_, (gpointer) ((gintptr) 0));
			_g_object_unref0 (rv);
			rv = (NoiseMedia*) _tmp88_;
		} else {
			NoiseSettingsMain* _tmp89_;
			NoiseSettingsRepeat _tmp90_;
			NoiseSettingsRepeat _tmp91_;
			_tmp89_ = main_settings;
			_tmp90_ = noise_settings_main_get_repeat_mode (_tmp89_);
			_tmp91_ = _tmp90_;
			if (_tmp91_ == NOISE_SETTINGS_REPEAT_MEDIA) {
				GeeHashMap* _tmp92_;
				gpointer _tmp93_;
				_tmp92_ = self->priv->_current;
				_tmp93_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp92_, (gpointer) ((gintptr) self->priv->_current_index));
				_g_object_unref0 (rv);
				rv = (NoiseMedia*) _tmp93_;
			} else {
				GeeHashMap* _tmp94_;
				gint _tmp95_;
				gint _tmp96_;
				_tmp94_ = self->priv->_current;
				_tmp95_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp94_);
				_tmp96_ = _tmp95_;
				if (self->priv->_current_index == (_tmp96_ - 1)) {
					NoiseSettingsMain* _tmp97_;
					NoiseSettingsRepeat _tmp98_;
					NoiseSettingsRepeat _tmp99_;
					GeeHashMap* _tmp100_;
					gpointer _tmp101_;
					_tmp97_ = main_settings;
					_tmp98_ = noise_settings_main_get_repeat_mode (_tmp97_);
					_tmp99_ = _tmp98_;
					if (_tmp99_ == NOISE_SETTINGS_REPEAT_ALL) {
						self->priv->_current_index = 0;
					} else {
						if (play) {
							noise_playback_manager_stop_playback (self);
						}
						result = NULL;
						_g_object_unref0 (main_settings);
						_g_object_unref0 (rv);
						return result;
					}
					_tmp100_ = self->priv->_current;
					_tmp101_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp100_, (gpointer) ((gintptr) 0));
					_g_object_unref0 (rv);
					rv = (NoiseMedia*) _tmp101_;
				} else {
					gboolean _tmp102_ = FALSE;
					if (self->priv->_current_index >= 0) {
						GeeHashMap* _tmp103_;
						gint _tmp104_;
						gint _tmp105_;
						_tmp103_ = self->priv->_current;
						_tmp104_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp103_);
						_tmp105_ = _tmp104_;
						_tmp102_ = self->priv->_current_index < (_tmp105_ - 1);
					} else {
						_tmp102_ = FALSE;
					}
					if (_tmp102_) {
						NoiseMedia* next_current = NULL;
						GeeHashMap* _tmp106_;
						gpointer _tmp107_;
						NoiseMedia* now_current = NULL;
						GeeHashMap* _tmp108_;
						gpointer _tmp109_;
						gboolean _tmp110_ = FALSE;
						NoiseSettingsMain* _tmp111_;
						NoiseSettingsRepeat _tmp112_;
						NoiseSettingsRepeat _tmp113_;
						GeeHashMap* _tmp151_;
						gpointer _tmp152_;
						_tmp106_ = self->priv->_current;
						_tmp107_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp106_, (gpointer) ((gintptr) (self->priv->_current_index + 1)));
						next_current = (NoiseMedia*) _tmp107_;
						_tmp108_ = self->priv->_current;
						_tmp109_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp108_, (gpointer) ((gintptr) self->priv->_current_index));
						now_current = (NoiseMedia*) _tmp109_;
						_tmp111_ = main_settings;
						_tmp112_ = noise_settings_main_get_repeat_mode (_tmp111_);
						_tmp113_ = _tmp112_;
						if (_tmp113_ == NOISE_SETTINGS_REPEAT_ARTIST) {
							NoiseMedia* _tmp114_;
							const gchar* _tmp115_;
							const gchar* _tmp116_;
							NoiseMedia* _tmp117_;
							const gchar* _tmp118_;
							const gchar* _tmp119_;
							_tmp114_ = next_current;
							_tmp115_ = noise_media_get_artist (_tmp114_);
							_tmp116_ = _tmp115_;
							_tmp117_ = now_current;
							_tmp118_ = noise_media_get_artist (_tmp117_);
							_tmp119_ = _tmp118_;
							_tmp110_ = g_strcmp0 (_tmp116_, _tmp119_) != 0;
						} else {
							_tmp110_ = FALSE;
						}
						if (_tmp110_) {
							while (TRUE) {
								GeeHashMap* _tmp120_;
								gpointer _tmp121_;
								NoiseMedia* _tmp122_;
								const gchar* _tmp123_;
								const gchar* _tmp124_;
								NoiseMedia* _tmp125_;
								const gchar* _tmp126_;
								const gchar* _tmp127_;
								gboolean _tmp128_;
								gint _tmp129_;
								_tmp120_ = self->priv->_current;
								_tmp121_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp120_, (gpointer) ((gintptr) (self->priv->_current_index - 1)));
								_tmp122_ = (NoiseMedia*) _tmp121_;
								_tmp123_ = noise_media_get_artist (_tmp122_);
								_tmp124_ = _tmp123_;
								_tmp125_ = self->priv->_current_media;
								_tmp126_ = noise_media_get_artist (_tmp125_);
								_tmp127_ = _tmp126_;
								_tmp128_ = !(g_strcmp0 (_tmp124_, _tmp127_) == 0);
								_g_object_unref0 (_tmp122_);
								if (_tmp128_) {
									break;
								}
								_tmp129_ = self->priv->_current_index;
								self->priv->_current_index = _tmp129_ - 1;
							}
						} else {
							gboolean _tmp130_ = FALSE;
							NoiseSettingsMain* _tmp131_;
							NoiseSettingsRepeat _tmp132_;
							NoiseSettingsRepeat _tmp133_;
							_tmp131_ = main_settings;
							_tmp132_ = noise_settings_main_get_repeat_mode (_tmp131_);
							_tmp133_ = _tmp132_;
							if (_tmp133_ == NOISE_SETTINGS_REPEAT_ALBUM) {
								NoiseMedia* _tmp134_;
								const gchar* _tmp135_;
								const gchar* _tmp136_;
								NoiseMedia* _tmp137_;
								const gchar* _tmp138_;
								const gchar* _tmp139_;
								_tmp134_ = next_current;
								_tmp135_ = noise_media_get_album (_tmp134_);
								_tmp136_ = _tmp135_;
								_tmp137_ = now_current;
								_tmp138_ = noise_media_get_album (_tmp137_);
								_tmp139_ = _tmp138_;
								_tmp130_ = g_strcmp0 (_tmp136_, _tmp139_) != 0;
							} else {
								_tmp130_ = FALSE;
							}
							if (_tmp130_) {
								while (TRUE) {
									GeeHashMap* _tmp140_;
									gpointer _tmp141_;
									NoiseMedia* _tmp142_;
									const gchar* _tmp143_;
									const gchar* _tmp144_;
									NoiseMedia* _tmp145_;
									const gchar* _tmp146_;
									const gchar* _tmp147_;
									gboolean _tmp148_;
									gint _tmp149_;
									_tmp140_ = self->priv->_current;
									_tmp141_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp140_, (gpointer) ((gintptr) (self->priv->_current_index - 1)));
									_tmp142_ = (NoiseMedia*) _tmp141_;
									_tmp143_ = noise_media_get_album (_tmp142_);
									_tmp144_ = _tmp143_;
									_tmp145_ = self->priv->_current_media;
									_tmp146_ = noise_media_get_album (_tmp145_);
									_tmp147_ = _tmp146_;
									_tmp148_ = !(g_strcmp0 (_tmp144_, _tmp147_) == 0);
									_g_object_unref0 (_tmp142_);
									if (_tmp148_) {
										break;
									}
									_tmp149_ = self->priv->_current_index;
									self->priv->_current_index = _tmp149_ - 1;
								}
							} else {
								gint _tmp150_;
								_tmp150_ = self->priv->_current_index;
								self->priv->_current_index = _tmp150_ + 1;
							}
						}
						_tmp151_ = self->priv->_current;
						_tmp152_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp151_, (gpointer) ((gintptr) self->priv->_current_index));
						_g_object_unref0 (rv);
						rv = (NoiseMedia*) _tmp152_;
						_g_object_unref0 (now_current);
						_g_object_unref0 (next_current);
					} else {
						NoiseLibrary* _tmp153_;
						NoiseLibrary* _tmp154_;
						GeeCollection* _tmp155_;
						GeeCollection* _tmp156_;
						GeeHashMap* _tmp157_;
						gpointer _tmp158_;
						_tmp153_ = noise_playback_manager_get_library (self);
						_tmp154_ = _tmp153_;
						_tmp155_ = noise_library_get_medias (_tmp154_);
						_tmp156_ = _tmp155_;
						noise_playback_manager_queue_media (self, _tmp156_);
						_g_object_unref0 (_tmp156_);
						self->priv->_current_index = 0;
						_tmp157_ = self->priv->_current;
						_tmp158_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp157_, (gpointer) ((gintptr) 0));
						_g_object_unref0 (rv);
						rv = (NoiseMedia*) _tmp158_;
					}
				}
			}
		}
	}
	_tmp159_ = self->queue_playlist;
	_tmp160_ = noise_playlist_get_medias ((NoisePlaylist*) _tmp159_);
	_tmp161_ = _tmp160_;
	_tmp162_ = rv;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp161_, _tmp162_)) {
		self->priv->_playing_queued_song = TRUE;
	}
	if (play) {
		NoiseMedia* _tmp163_;
		_tmp163_ = rv;
		noise_playback_manager_play_media (self, _tmp163_);
	}
	result = rv;
	_g_object_unref0 (main_settings);
	return result;
}

NoiseMedia*
noise_playback_manager_get_previous (NoisePlaybackManager* self,
                                     gboolean play)
{
	NoiseMedia* result = NULL;
	NoiseMedia* rv = NULL;
	NoiseSettingsMain* main_settings = NULL;
	NoiseSettingsMain* _tmp0_;
	NoiseSettingsMain* _tmp1_;
	NoiseSettingsShuffle _tmp2_;
	NoiseSettingsShuffle _tmp3_;
	NoiseStaticPlaylist* _tmp173_;
	GeeArrayList* _tmp174_;
	GeeArrayList* _tmp175_;
	NoiseMedia* _tmp176_;
	g_return_val_if_fail (self != NULL, NULL);
	rv = NULL;
	_tmp0_ = noise_settings_main_get_default ();
	main_settings = _tmp0_;
	_tmp1_ = main_settings;
	_tmp2_ = noise_settings_main_get_shuffle_mode (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ != NOISE_SETTINGS_SHUFFLE_OFF) {
		GeeHashMap* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		NoiseMedia* _tmp14_;
		_tmp4_ = self->priv->_current_shuffled;
		_tmp5_ = gee_map_get_is_empty ((GeeMap*) _tmp4_);
		_tmp6_ = _tmp5_;
		if (_tmp6_) {
			GeeHashMap* _tmp7_;
			gboolean _tmp8_;
			gboolean _tmp9_;
			_tmp7_ = self->priv->_current;
			_tmp8_ = gee_map_get_is_empty ((GeeMap*) _tmp7_);
			_tmp9_ = _tmp8_;
			if (_tmp9_) {
				NoiseLibrary* _tmp10_;
				NoiseLibrary* _tmp11_;
				GeeCollection* _tmp12_;
				GeeCollection* _tmp13_;
				_tmp10_ = noise_playback_manager_get_library (self);
				_tmp11_ = _tmp10_;
				_tmp12_ = noise_library_get_medias (_tmp11_);
				_tmp13_ = _tmp12_;
				noise_playback_manager_queue_media (self, _tmp13_);
				_g_object_unref0 (_tmp13_);
			}
			noise_playback_manager_reshuffle (self);
		}
		self->priv->_playing_queued_song = FALSE;
		_tmp14_ = self->priv->_current_media;
		if (_tmp14_ == NULL) {
			GeeHashMap* _tmp15_;
			gint _tmp16_;
			gint _tmp17_;
			GeeHashMap* _tmp18_;
			gpointer _tmp19_;
			_tmp15_ = self->priv->_current_shuffled;
			_tmp16_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp15_);
			_tmp17_ = _tmp16_;
			self->priv->_current_shuffled_index = _tmp17_ - 1;
			_tmp18_ = self->priv->_current_shuffled;
			_tmp19_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp18_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
			_g_object_unref0 (rv);
			rv = (NoiseMedia*) _tmp19_;
		} else {
			NoiseSettingsMain* _tmp20_;
			NoiseSettingsRepeat _tmp21_;
			NoiseSettingsRepeat _tmp22_;
			_tmp20_ = main_settings;
			_tmp21_ = noise_settings_main_get_repeat_mode (_tmp20_);
			_tmp22_ = _tmp21_;
			if (_tmp22_ == NOISE_SETTINGS_REPEAT_MEDIA) {
				GeeHashMap* _tmp23_;
				gpointer _tmp24_;
				_tmp23_ = self->priv->_current_shuffled;
				_tmp24_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp23_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
				_g_object_unref0 (rv);
				rv = (NoiseMedia*) _tmp24_;
			} else {
				if (self->priv->_current_shuffled_index == 0) {
					NoiseSettingsMain* _tmp25_;
					NoiseSettingsRepeat _tmp26_;
					NoiseSettingsRepeat _tmp27_;
					GeeHashMap* _tmp31_;
					gpointer _tmp32_;
					_tmp25_ = main_settings;
					_tmp26_ = noise_settings_main_get_repeat_mode (_tmp25_);
					_tmp27_ = _tmp26_;
					if (_tmp27_ == NOISE_SETTINGS_REPEAT_ALL) {
						GeeHashMap* _tmp28_;
						gint _tmp29_;
						gint _tmp30_;
						_tmp28_ = self->priv->_current_shuffled;
						_tmp29_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp28_);
						_tmp30_ = _tmp29_;
						self->priv->_current_shuffled_index = _tmp30_ - 1;
					} else {
						noise_playback_manager_stop_playback (self);
						result = NULL;
						_g_object_unref0 (main_settings);
						_g_object_unref0 (rv);
						return result;
					}
					_tmp31_ = self->priv->_current_shuffled;
					_tmp32_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp31_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
					_g_object_unref0 (rv);
					rv = (NoiseMedia*) _tmp32_;
				} else {
					gboolean _tmp33_ = FALSE;
					if (self->priv->_current_shuffled_index > 0) {
						GeeHashMap* _tmp34_;
						gint _tmp35_;
						gint _tmp36_;
						_tmp34_ = self->priv->_current_shuffled;
						_tmp35_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp34_);
						_tmp36_ = _tmp35_;
						_tmp33_ = self->priv->_current_shuffled_index < _tmp36_;
					} else {
						_tmp33_ = FALSE;
					}
					if (_tmp33_) {
						gboolean _tmp37_ = FALSE;
						NoiseSettingsMain* _tmp38_;
						NoiseSettingsRepeat _tmp39_;
						NoiseSettingsRepeat _tmp40_;
						GeeHashMap* _tmp83_;
						gpointer _tmp84_;
						_tmp38_ = main_settings;
						_tmp39_ = noise_settings_main_get_repeat_mode (_tmp38_);
						_tmp40_ = _tmp39_;
						if (_tmp40_ == NOISE_SETTINGS_REPEAT_ARTIST) {
							GeeHashMap* _tmp41_;
							gpointer _tmp42_;
							NoiseMedia* _tmp43_;
							const gchar* _tmp44_;
							const gchar* _tmp45_;
							GeeHashMap* _tmp46_;
							gpointer _tmp47_;
							NoiseMedia* _tmp48_;
							const gchar* _tmp49_;
							const gchar* _tmp50_;
							_tmp41_ = self->priv->_current_shuffled;
							_tmp42_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp41_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index - 1)));
							_tmp43_ = (NoiseMedia*) _tmp42_;
							_tmp44_ = noise_media_get_artist (_tmp43_);
							_tmp45_ = _tmp44_;
							_tmp46_ = self->priv->_current_shuffled;
							_tmp47_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp46_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
							_tmp48_ = (NoiseMedia*) _tmp47_;
							_tmp49_ = noise_media_get_artist (_tmp48_);
							_tmp50_ = _tmp49_;
							_tmp37_ = g_strcmp0 (_tmp45_, _tmp50_) != 0;
							_g_object_unref0 (_tmp48_);
							_g_object_unref0 (_tmp43_);
						} else {
							_tmp37_ = FALSE;
						}
						if (_tmp37_) {
							while (TRUE) {
								GeeHashMap* _tmp51_;
								gpointer _tmp52_;
								NoiseMedia* _tmp53_;
								const gchar* _tmp54_;
								const gchar* _tmp55_;
								NoiseMedia* _tmp56_;
								const gchar* _tmp57_;
								const gchar* _tmp58_;
								gboolean _tmp59_;
								_tmp51_ = self->priv->_current_shuffled;
								_tmp52_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp51_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index + 1)));
								_tmp53_ = (NoiseMedia*) _tmp52_;
								_tmp54_ = noise_media_get_artist (_tmp53_);
								_tmp55_ = _tmp54_;
								_tmp56_ = self->priv->_current_media;
								_tmp57_ = noise_media_get_artist (_tmp56_);
								_tmp58_ = _tmp57_;
								_tmp59_ = !(g_strcmp0 (_tmp55_, _tmp58_) == 0);
								_g_object_unref0 (_tmp53_);
								if (_tmp59_) {
									break;
								}
								self->priv->_current_shuffled_index = self->priv->_current_shuffled_index + 1;
							}
						} else {
							gboolean _tmp60_ = FALSE;
							NoiseSettingsMain* _tmp61_;
							NoiseSettingsRepeat _tmp62_;
							NoiseSettingsRepeat _tmp63_;
							_tmp61_ = main_settings;
							_tmp62_ = noise_settings_main_get_repeat_mode (_tmp61_);
							_tmp63_ = _tmp62_;
							if (_tmp63_ == NOISE_SETTINGS_REPEAT_ALBUM) {
								GeeHashMap* _tmp64_;
								gpointer _tmp65_;
								NoiseMedia* _tmp66_;
								const gchar* _tmp67_;
								const gchar* _tmp68_;
								GeeHashMap* _tmp69_;
								gpointer _tmp70_;
								NoiseMedia* _tmp71_;
								const gchar* _tmp72_;
								const gchar* _tmp73_;
								_tmp64_ = self->priv->_current_shuffled;
								_tmp65_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp64_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index - 1)));
								_tmp66_ = (NoiseMedia*) _tmp65_;
								_tmp67_ = noise_media_get_album (_tmp66_);
								_tmp68_ = _tmp67_;
								_tmp69_ = self->priv->_current_shuffled;
								_tmp70_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp69_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
								_tmp71_ = (NoiseMedia*) _tmp70_;
								_tmp72_ = noise_media_get_album (_tmp71_);
								_tmp73_ = _tmp72_;
								_tmp60_ = g_strcmp0 (_tmp68_, _tmp73_) != 0;
								_g_object_unref0 (_tmp71_);
								_g_object_unref0 (_tmp66_);
							} else {
								_tmp60_ = FALSE;
							}
							if (_tmp60_) {
								while (TRUE) {
									GeeHashMap* _tmp74_;
									gpointer _tmp75_;
									NoiseMedia* _tmp76_;
									const gchar* _tmp77_;
									const gchar* _tmp78_;
									NoiseMedia* _tmp79_;
									const gchar* _tmp80_;
									const gchar* _tmp81_;
									gboolean _tmp82_;
									_tmp74_ = self->priv->_current_shuffled;
									_tmp75_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp74_, (gpointer) ((gintptr) (self->priv->_current_shuffled_index + 1)));
									_tmp76_ = (NoiseMedia*) _tmp75_;
									_tmp77_ = noise_media_get_album (_tmp76_);
									_tmp78_ = _tmp77_;
									_tmp79_ = self->priv->_current_media;
									_tmp80_ = noise_media_get_album (_tmp79_);
									_tmp81_ = _tmp80_;
									_tmp82_ = !(g_strcmp0 (_tmp78_, _tmp81_) == 0);
									_g_object_unref0 (_tmp76_);
									if (_tmp82_) {
										break;
									}
									self->priv->_current_shuffled_index = self->priv->_current_shuffled_index + 1;
								}
							} else {
								self->priv->_current_shuffled_index = self->priv->_current_shuffled_index - 1;
							}
						}
						_tmp83_ = self->priv->_current_shuffled;
						_tmp84_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp83_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
						_g_object_unref0 (rv);
						rv = (NoiseMedia*) _tmp84_;
					} else {
						GeeHashMap* _tmp85_;
						gint _tmp86_;
						gint _tmp87_;
						GeeHashMap* _tmp88_;
						gpointer _tmp89_;
						_tmp85_ = self->priv->_current_shuffled;
						_tmp86_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp85_);
						_tmp87_ = _tmp86_;
						self->priv->_current_shuffled_index = _tmp87_ - 1;
						_tmp88_ = self->priv->_current_shuffled;
						_tmp89_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp88_, (gpointer) ((gintptr) self->priv->_current_shuffled_index));
						_g_object_unref0 (rv);
						rv = (NoiseMedia*) _tmp89_;
					}
				}
			}
		}
	} else {
		NoiseMedia* _tmp90_;
		self->priv->_playing_queued_song = FALSE;
		_tmp90_ = self->priv->_current_media;
		if (_tmp90_ == NULL) {
			GeeHashMap* _tmp91_;
			gint _tmp92_;
			gint _tmp93_;
			GeeHashMap* _tmp94_;
			gpointer _tmp95_;
			_tmp91_ = self->priv->_current;
			_tmp92_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp91_);
			_tmp93_ = _tmp92_;
			self->priv->_current_index = _tmp93_ - 1;
			_tmp94_ = self->priv->_current;
			_tmp95_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp94_, (gpointer) ((gintptr) self->priv->_current_index));
			_g_object_unref0 (rv);
			rv = (NoiseMedia*) _tmp95_;
		} else {
			NoiseSettingsMain* _tmp96_;
			NoiseSettingsRepeat _tmp97_;
			NoiseSettingsRepeat _tmp98_;
			_tmp96_ = main_settings;
			_tmp97_ = noise_settings_main_get_repeat_mode (_tmp96_);
			_tmp98_ = _tmp97_;
			if (_tmp98_ == NOISE_SETTINGS_REPEAT_MEDIA) {
				GeeHashMap* _tmp99_;
				gpointer _tmp100_;
				_tmp99_ = self->priv->_current;
				_tmp100_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp99_, (gpointer) ((gintptr) self->priv->_current_index));
				_g_object_unref0 (rv);
				rv = (NoiseMedia*) _tmp100_;
			} else {
				if (self->priv->_current_index == 0) {
					NoiseSettingsMain* _tmp101_;
					NoiseSettingsRepeat _tmp102_;
					NoiseSettingsRepeat _tmp103_;
					GeeHashMap* _tmp107_;
					gpointer _tmp108_;
					_tmp101_ = main_settings;
					_tmp102_ = noise_settings_main_get_repeat_mode (_tmp101_);
					_tmp103_ = _tmp102_;
					if (_tmp103_ == NOISE_SETTINGS_REPEAT_ALL) {
						GeeHashMap* _tmp104_;
						gint _tmp105_;
						gint _tmp106_;
						_tmp104_ = self->priv->_current;
						_tmp105_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp104_);
						_tmp106_ = _tmp105_;
						self->priv->_current_index = _tmp106_ - 1;
					} else {
						noise_playback_manager_stop_playback (self);
						result = NULL;
						_g_object_unref0 (main_settings);
						_g_object_unref0 (rv);
						return result;
					}
					_tmp107_ = self->priv->_current;
					_tmp108_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp107_, (gpointer) ((gintptr) self->priv->_current_index));
					_g_object_unref0 (rv);
					rv = (NoiseMedia*) _tmp108_;
				} else {
					gboolean _tmp109_ = FALSE;
					if (self->priv->_current_index > 0) {
						GeeHashMap* _tmp110_;
						gint _tmp111_;
						gint _tmp112_;
						_tmp110_ = self->priv->_current;
						_tmp111_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp110_);
						_tmp112_ = _tmp111_;
						_tmp109_ = self->priv->_current_index < _tmp112_;
					} else {
						_tmp109_ = FALSE;
					}
					if (_tmp109_) {
						gboolean _tmp113_ = FALSE;
						NoiseSettingsMain* _tmp114_;
						NoiseSettingsRepeat _tmp115_;
						NoiseSettingsRepeat _tmp116_;
						GeeHashMap* _tmp162_;
						gpointer _tmp163_;
						_tmp114_ = main_settings;
						_tmp115_ = noise_settings_main_get_repeat_mode (_tmp114_);
						_tmp116_ = _tmp115_;
						if (_tmp116_ == NOISE_SETTINGS_REPEAT_ARTIST) {
							GeeHashMap* _tmp117_;
							gpointer _tmp118_;
							NoiseMedia* _tmp119_;
							const gchar* _tmp120_;
							const gchar* _tmp121_;
							GeeHashMap* _tmp122_;
							gpointer _tmp123_;
							NoiseMedia* _tmp124_;
							const gchar* _tmp125_;
							const gchar* _tmp126_;
							_tmp117_ = self->priv->_current;
							_tmp118_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp117_, (gpointer) ((gintptr) (self->priv->_current_index - 1)));
							_tmp119_ = (NoiseMedia*) _tmp118_;
							_tmp120_ = noise_media_get_artist (_tmp119_);
							_tmp121_ = _tmp120_;
							_tmp122_ = self->priv->_current;
							_tmp123_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp122_, (gpointer) ((gintptr) self->priv->_current_index));
							_tmp124_ = (NoiseMedia*) _tmp123_;
							_tmp125_ = noise_media_get_artist (_tmp124_);
							_tmp126_ = _tmp125_;
							_tmp113_ = g_strcmp0 (_tmp121_, _tmp126_) != 0;
							_g_object_unref0 (_tmp124_);
							_g_object_unref0 (_tmp119_);
						} else {
							_tmp113_ = FALSE;
						}
						if (_tmp113_) {
							while (TRUE) {
								GeeHashMap* _tmp127_;
								gpointer _tmp128_;
								NoiseMedia* _tmp129_;
								const gchar* _tmp130_;
								const gchar* _tmp131_;
								NoiseMedia* _tmp132_;
								const gchar* _tmp133_;
								const gchar* _tmp134_;
								gboolean _tmp135_;
								gint _tmp136_;
								_tmp127_ = self->priv->_current;
								_tmp128_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp127_, (gpointer) ((gintptr) (self->priv->_current_index + 1)));
								_tmp129_ = (NoiseMedia*) _tmp128_;
								_tmp130_ = noise_media_get_artist (_tmp129_);
								_tmp131_ = _tmp130_;
								_tmp132_ = self->priv->_current_media;
								_tmp133_ = noise_media_get_artist (_tmp132_);
								_tmp134_ = _tmp133_;
								_tmp135_ = !(g_strcmp0 (_tmp131_, _tmp134_) == 0);
								_g_object_unref0 (_tmp129_);
								if (_tmp135_) {
									break;
								}
								_tmp136_ = self->priv->_current_index;
								self->priv->_current_index = _tmp136_ + 1;
							}
						} else {
							gboolean _tmp137_ = FALSE;
							NoiseSettingsMain* _tmp138_;
							NoiseSettingsRepeat _tmp139_;
							NoiseSettingsRepeat _tmp140_;
							_tmp138_ = main_settings;
							_tmp139_ = noise_settings_main_get_repeat_mode (_tmp138_);
							_tmp140_ = _tmp139_;
							if (_tmp140_ == NOISE_SETTINGS_REPEAT_ALBUM) {
								GeeHashMap* _tmp141_;
								gpointer _tmp142_;
								NoiseMedia* _tmp143_;
								const gchar* _tmp144_;
								const gchar* _tmp145_;
								GeeHashMap* _tmp146_;
								gpointer _tmp147_;
								NoiseMedia* _tmp148_;
								const gchar* _tmp149_;
								const gchar* _tmp150_;
								_tmp141_ = self->priv->_current;
								_tmp142_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp141_, (gpointer) ((gintptr) (self->priv->_current_index - 1)));
								_tmp143_ = (NoiseMedia*) _tmp142_;
								_tmp144_ = noise_media_get_album (_tmp143_);
								_tmp145_ = _tmp144_;
								_tmp146_ = self->priv->_current;
								_tmp147_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp146_, (gpointer) ((gintptr) self->priv->_current_index));
								_tmp148_ = (NoiseMedia*) _tmp147_;
								_tmp149_ = noise_media_get_album (_tmp148_);
								_tmp150_ = _tmp149_;
								_tmp137_ = g_strcmp0 (_tmp145_, _tmp150_) != 0;
								_g_object_unref0 (_tmp148_);
								_g_object_unref0 (_tmp143_);
							} else {
								_tmp137_ = FALSE;
							}
							if (_tmp137_) {
								while (TRUE) {
									GeeHashMap* _tmp151_;
									gpointer _tmp152_;
									NoiseMedia* _tmp153_;
									const gchar* _tmp154_;
									const gchar* _tmp155_;
									NoiseMedia* _tmp156_;
									const gchar* _tmp157_;
									const gchar* _tmp158_;
									gboolean _tmp159_;
									gint _tmp160_;
									_tmp151_ = self->priv->_current;
									_tmp152_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp151_, (gpointer) ((gintptr) (self->priv->_current_index + 1)));
									_tmp153_ = (NoiseMedia*) _tmp152_;
									_tmp154_ = noise_media_get_album (_tmp153_);
									_tmp155_ = _tmp154_;
									_tmp156_ = self->priv->_current_media;
									_tmp157_ = noise_media_get_album (_tmp156_);
									_tmp158_ = _tmp157_;
									_tmp159_ = !(g_strcmp0 (_tmp155_, _tmp158_) == 0);
									_g_object_unref0 (_tmp153_);
									if (_tmp159_) {
										break;
									}
									_tmp160_ = self->priv->_current_index;
									self->priv->_current_index = _tmp160_ + 1;
								}
							} else {
								gint _tmp161_;
								_tmp161_ = self->priv->_current_index;
								self->priv->_current_index = _tmp161_ - 1;
							}
						}
						_tmp162_ = self->priv->_current;
						_tmp163_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp162_, (gpointer) ((gintptr) self->priv->_current_index));
						_g_object_unref0 (rv);
						rv = (NoiseMedia*) _tmp163_;
					} else {
						NoiseLibrary* _tmp164_;
						NoiseLibrary* _tmp165_;
						GeeCollection* _tmp166_;
						GeeCollection* _tmp167_;
						GeeHashMap* _tmp168_;
						gint _tmp169_;
						gint _tmp170_;
						GeeHashMap* _tmp171_;
						gpointer _tmp172_;
						_tmp164_ = noise_playback_manager_get_library (self);
						_tmp165_ = _tmp164_;
						_tmp166_ = noise_library_get_medias (_tmp165_);
						_tmp167_ = _tmp166_;
						noise_playback_manager_queue_media (self, _tmp167_);
						_g_object_unref0 (_tmp167_);
						_tmp168_ = self->priv->_current;
						_tmp169_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp168_);
						_tmp170_ = _tmp169_;
						self->priv->_current_index = _tmp170_ - 1;
						_tmp171_ = self->priv->_current;
						_tmp172_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp171_, (gpointer) ((gintptr) self->priv->_current_index));
						_g_object_unref0 (rv);
						rv = (NoiseMedia*) _tmp172_;
					}
				}
			}
		}
	}
	_tmp173_ = self->queue_playlist;
	_tmp174_ = noise_playlist_get_medias ((NoisePlaylist*) _tmp173_);
	_tmp175_ = _tmp174_;
	_tmp176_ = rv;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp175_, _tmp176_)) {
		self->priv->_playing_queued_song = TRUE;
	}
	if (play) {
		NoiseMedia* _tmp177_;
		_tmp177_ = rv;
		noise_playback_manager_play_media (self, _tmp177_);
	}
	result = rv;
	_g_object_unref0 (main_settings);
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
	g_atomic_int_inc (&_data10_->_ref_count_);
	return _data10_;
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
		NoisePlaybackManager* self;
		self = _data10_->self;
		_g_object_unref0 (_data10_->m);
		_g_object_unref0 (self);
		g_slice_free (Block10Data, _data10_);
	}
}

static gboolean
__lambda33_ (Block10Data* _data10_)
{
	NoisePlaybackManager* self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	self = _data10_->self;
	if (_data10_->m != NULL) {
		NoiseMedia* _tmp1_;
		_tmp1_ = self->priv->_current_media;
		_tmp0_ = _tmp1_ == _data10_->m;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		NoiseHistoryPlaylist* _tmp2_;
		guint player_duration_s = 0U;
		NoisePlayback* _tmp3_;
		_tmp2_ = self->history_playlist;
		noise_playlist_add_media ((NoisePlaylist*) _tmp2_, _data10_->m);
		_tmp3_ = self->player;
		player_duration_s = (guint) (noise_playback_get_duration (_tmp3_) / NOISE_TIME_UTILS_NANO_INV);
		if (player_duration_s > ((guint) 1)) {
			gint delta_s = 0;
			guint _tmp4_;
			guint _tmp5_;
			_tmp4_ = noise_media_get_length (_data10_->m);
			_tmp5_ = _tmp4_;
			delta_s = ((gint) player_duration_s) - ((gint) (_tmp5_ / NOISE_TIME_UTILS_MILI_INV));
			if (fabs ((gdouble) delta_s) > ((gdouble) 3)) {
				NoiseLibrary* _tmp6_;
				NoiseLibrary* _tmp7_;
				noise_media_set_length (_data10_->m, (guint) (player_duration_s * NOISE_TIME_UTILS_MILI_INV));
				_tmp6_ = noise_playback_manager_get_library (self);
				_tmp7_ = _tmp6_;
				noise_library_update_media (_tmp7_, _data10_->m, FALSE, FALSE);
			}
		}
	}
	result = FALSE;
	return result;
}

static gboolean
___lambda33__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda33_ (self);
	return result;
}

void
noise_playback_manager_play_media (NoisePlaybackManager* self,
                                   NoiseMedia* m)
{
	Block10Data* _data10_;
	NoiseMedia* _tmp0_;
	gint64 old_id = 0LL;
	NoiseMedia* _tmp1_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gboolean found = FALSE;
	GFile* _tmp41_;
	GFile* _tmp42_;
	NoisePlayback* _tmp52_;
	gboolean _tmp53_;
	gboolean _tmp55_ = FALSE;
	gint64 _tmp56_;
	gint64 _tmp57_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (m != NULL);
	_data10_ = g_slice_new0 (Block10Data);
	_data10_->_ref_count_ = 1;
	_data10_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (m);
	_g_object_unref0 (_data10_->m);
	_data10_->m = _tmp0_;
	old_id = (gint64) -1;
	_tmp1_ = self->priv->_current_media;
	if (_tmp1_ != NULL) {
		NoiseMedia* _tmp2_;
		gint64 _tmp3_;
		gint64 _tmp4_;
		_tmp2_ = self->priv->_current_media;
		_tmp3_ = noise_media_get_rowid (_tmp2_);
		_tmp4_ = _tmp3_;
		old_id = _tmp4_;
	}
	noise_playback_manager_set_current_media (self, _data10_->m);
	_tmp5_ = noise_media_get_location_unknown (_data10_->m);
	_tmp6_ = _tmp5_;
	if (_tmp6_) {
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GFile* _tmp10_;
		GFile* _tmp11_;
		gboolean _tmp12_;
		_tmp7_ = noise_media_get_uri (_data10_->m);
		_tmp8_ = _tmp7_;
		_tmp9_ = _tmp8_;
		_tmp10_ = g_file_new_for_uri (_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = g_file_query_exists (_tmp11_, NULL);
		_g_object_unref0 (_tmp11_);
		_g_free0 (_tmp9_);
		if (_tmp12_) {
			noise_media_set_location_unknown (_data10_->m, FALSE);
			noise_media_set_unique_status_image (_data10_->m, NULL);
		} else {
			noise_playback_manager_stop_playback (self);
			block10_data_unref (_data10_);
			_data10_ = NULL;
			return;
		}
	}
	found = FALSE;
	{
		GeeTreeSet* _tmp13_;
		_tmp13_ = self->priv->playbacks;
		g_rec_mutex_lock (&self->priv->__lock_playbacks);
		{
			{
				GeeIterator* _playback_it = NULL;
				GeeTreeSet* _tmp14_;
				GeeIterator* _tmp15_;
				_tmp14_ = self->priv->playbacks;
				_tmp15_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp14_);
				_playback_it = _tmp15_;
				while (TRUE) {
					GeeIterator* _tmp16_;
					NoisePlayback* playback = NULL;
					GeeIterator* _tmp17_;
					gpointer _tmp18_;
					_tmp16_ = _playback_it;
					if (!gee_iterator_next (_tmp16_)) {
						break;
					}
					_tmp17_ = _playback_it;
					_tmp18_ = gee_iterator_get (_tmp17_);
					playback = (NoisePlayback*) _tmp18_;
					{
						GeeIterator* _supported_uri_it = NULL;
						NoisePlayback* _tmp19_;
						GeeCollection* _tmp20_;
						GeeCollection* _tmp21_;
						GeeIterator* _tmp22_;
						GeeIterator* _tmp23_;
						_tmp19_ = playback;
						_tmp20_ = noise_playback_get_supported_uri (_tmp19_);
						_tmp21_ = _tmp20_;
						_tmp22_ = gee_iterable_iterator ((GeeIterable*) _tmp21_);
						_tmp23_ = _tmp22_;
						_g_object_unref0 (_tmp21_);
						_supported_uri_it = _tmp23_;
						while (TRUE) {
							GeeIterator* _tmp24_;
							gchar* supported_uri = NULL;
							GeeIterator* _tmp25_;
							gpointer _tmp26_;
							gchar* _tmp27_;
							gchar* _tmp28_;
							gchar* _tmp29_;
							const gchar* _tmp30_;
							gboolean _tmp31_;
							_tmp24_ = _supported_uri_it;
							if (!gee_iterator_next (_tmp24_)) {
								break;
							}
							_tmp25_ = _supported_uri_it;
							_tmp26_ = gee_iterator_get (_tmp25_);
							supported_uri = (gchar*) _tmp26_;
							_tmp27_ = noise_media_get_uri (_data10_->m);
							_tmp28_ = _tmp27_;
							_tmp29_ = _tmp28_;
							_tmp30_ = supported_uri;
							_tmp31_ = g_str_has_prefix (_tmp29_, _tmp30_);
							_g_free0 (_tmp29_);
							if (_tmp31_) {
								NoisePlayback* _tmp32_;
								NoisePlayback* _tmp33_;
								NoisePlayback* _tmp34_;
								NoisePlayback* _tmp35_;
								_tmp32_ = self->player;
								self->priv->saved_volume = noise_playback_get_volume (_tmp32_);
								g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_CHANGING_PLAYER_SIGNAL], 0);
								_tmp33_ = self->player;
								noise_playback_set_state (_tmp33_, GST_STATE_NULL);
								found = TRUE;
								_tmp34_ = playback;
								_tmp35_ = _g_object_ref0 (_tmp34_);
								_g_object_unref0 (self->player);
								self->player = _tmp35_;
								noise_playback_manager_set_volume (self, self->priv->saved_volume);
								g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYER_CHANGED_SIGNAL], 0);
								_g_free0 (supported_uri);
								break;
							}
							_g_free0 (supported_uri);
						}
						_g_object_unref0 (_supported_uri_it);
					}
					if (found == TRUE) {
						break;
					}
				}
				_g_object_unref0 (_playback_it);
			}
		}
		__finally19:
		{
			GeeTreeSet* _tmp36_;
			_tmp36_ = self->priv->playbacks;
			g_rec_mutex_unlock (&self->priv->__lock_playbacks);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			block10_data_unref (_data10_);
			_data10_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	if (!found) {
		GThemedIcon* _tmp37_;
		GThemedIcon* _tmp38_;
		NoiseMedia* _tmp39_;
		NoiseMedia* _tmp40_;
		_tmp37_ = (GThemedIcon*) g_themed_icon_new ("process-error-symbolic");
		_tmp38_ = _tmp37_;
		noise_media_set_unique_status_image (_data10_->m, (GIcon*) _tmp38_);
		_g_object_unref0 (_tmp38_);
		_tmp39_ = noise_playback_manager_get_next (self, TRUE);
		_tmp40_ = _tmp39_;
		_g_object_unref0 (_tmp40_);
		block10_data_unref (_data10_);
		_data10_ = NULL;
		return;
	}
	_tmp41_ = noise_media_get_file (_data10_->m);
	_tmp42_ = _tmp41_;
	if (!g_file_query_exists (_tmp42_, NULL)) {
		GThemedIcon* _tmp43_;
		GThemedIcon* _tmp44_;
		NoiseMedia* _tmp45_;
		NoiseMedia* _tmp46_;
		_tmp43_ = (GThemedIcon*) g_themed_icon_new ("process-error-symbolic");
		_tmp44_ = _tmp43_;
		noise_media_set_unique_status_image (_data10_->m, (GIcon*) _tmp44_);
		_g_object_unref0 (_tmp44_);
		noise_media_set_location_unknown (_data10_->m, TRUE);
		_tmp45_ = noise_playback_manager_get_next (self, TRUE);
		_tmp46_ = _tmp45_;
		_g_object_unref0 (_tmp46_);
		block10_data_unref (_data10_);
		_data10_ = NULL;
		return;
	} else {
		gboolean _tmp47_ = FALSE;
		gboolean _tmp48_;
		gboolean _tmp49_;
		_tmp48_ = noise_media_get_location_unknown (_data10_->m);
		_tmp49_ = _tmp48_;
		if (_tmp49_) {
			GIcon* _tmp50_;
			GIcon* _tmp51_;
			_tmp50_ = noise_media_get_unique_status_image (_data10_->m);
			_tmp51_ = _tmp50_;
			_tmp47_ = _tmp51_ != NULL;
		} else {
			_tmp47_ = FALSE;
		}
		if (_tmp47_) {
			noise_media_set_unique_status_image (_data10_->m, NULL);
			noise_media_set_location_unknown (_data10_->m, FALSE);
		}
	}
	noise_playback_manager_change_gains_thread (self);
	_tmp52_ = self->player;
	noise_playback_set_media (_tmp52_, _data10_->m);
	_tmp53_ = self->priv->_playing;
	if (!_tmp53_) {
		NoisePlayback* _tmp54_;
		_tmp54_ = self->player;
		noise_playback_pause (_tmp54_);
	}
	_tmp56_ = noise_media_get_rowid (_data10_->m);
	_tmp57_ = _tmp56_;
	if (_tmp57_ >= ((gint64) 0)) {
		NoiseSettingsMain* _tmp58_;
		NoiseSettingsMain* _tmp59_;
		_tmp58_ = noise_settings_main_get_default ();
		_tmp59_ = _tmp58_;
		_tmp55_ = !noise_settings_main_privacy_mode_enabled (_tmp59_);
		_g_object_unref0 (_tmp59_);
	} else {
		_tmp55_ = FALSE;
	}
	if (_tmp55_) {
		GSettings* _tmp60_;
		GSettings* _tmp61_;
		gint64 _tmp62_;
		gint64 _tmp63_;
		_tmp60_ = noise_app_get_saved_state ();
		_tmp61_ = _tmp60_;
		_tmp62_ = noise_media_get_rowid (_data10_->m);
		_tmp63_ = _tmp62_;
		g_settings_set_int64 (_tmp61_, "last-media-playing", _tmp63_);
	}
	if (_data10_->m != NULL) {
		g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_MEDIA_PLAYED_SIGNAL], 0, _data10_->m);
	}
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 1000, ___lambda33__gsource_func, block10_data_ref (_data10_), block10_data_unref);
	block10_data_unref (_data10_);
	_data10_ = NULL;
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

void
noise_playback_manager_change_gains_thread (NoisePlaybackManager* self)
{
	NoiseSettingsEqualizer* equalizer_settings = NULL;
	NoiseSettingsEqualizer* _tmp0_;
	NoiseSettingsEqualizer* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = noise_settings_equalizer_get_default ();
	equalizer_settings = _tmp0_;
	_tmp1_ = equalizer_settings;
	_tmp2_ = noise_settings_equalizer_get_equalizer_enabled (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		gboolean automatic_enabled = FALSE;
		NoiseSettingsEqualizer* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		gchar* selected_preset = NULL;
		NoiseSettingsEqualizer* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp4_ = equalizer_settings;
		_tmp5_ = noise_settings_equalizer_get_auto_switch_preset (_tmp4_);
		_tmp6_ = _tmp5_;
		automatic_enabled = _tmp6_;
		_tmp7_ = equalizer_settings;
		_tmp8_ = noise_settings_equalizer_get_selected_preset (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp10_ = g_strdup (_tmp9_);
		selected_preset = _tmp10_;
		{
			GeeIterator* _p_it = NULL;
			NoiseSettingsEqualizer* _tmp11_;
			GeeCollection* _tmp12_;
			GeeCollection* _tmp13_;
			GeeIterator* _tmp14_;
			GeeIterator* _tmp15_;
			_tmp11_ = equalizer_settings;
			_tmp12_ = noise_settings_equalizer_get_presets (_tmp11_);
			_tmp13_ = _tmp12_;
			_tmp14_ = gee_iterable_iterator ((GeeIterable*) _tmp13_);
			_tmp15_ = _tmp14_;
			_g_object_unref0 (_tmp13_);
			_p_it = _tmp15_;
			while (TRUE) {
				GeeIterator* _tmp16_;
				NoiseEqualizerPreset* p = NULL;
				GeeIterator* _tmp17_;
				gpointer _tmp18_;
				gboolean _tmp19_ = FALSE;
				NoiseEqualizerPreset* _tmp20_;
				_tmp16_ = _p_it;
				if (!gee_iterator_next (_tmp16_)) {
					break;
				}
				_tmp17_ = _p_it;
				_tmp18_ = gee_iterator_get (_tmp17_);
				p = (NoiseEqualizerPreset*) _tmp18_;
				_tmp20_ = p;
				if (_tmp20_ != NULL) {
					NoiseMedia* _tmp21_;
					_tmp21_ = self->priv->_current_media;
					_tmp19_ = _tmp21_ != NULL;
				} else {
					_tmp19_ = FALSE;
				}
				if (_tmp19_) {
					gchar* preset_name = NULL;
					NoiseEqualizerPreset* _tmp22_;
					const gchar* _tmp23_;
					const gchar* _tmp24_;
					gchar* _tmp25_;
					gchar* media_genre = NULL;
					NoiseMedia* _tmp26_;
					const gchar* _tmp27_;
					const gchar* _tmp28_;
					gchar* _tmp29_;
					gboolean _tmp30_ = FALSE;
					const gchar* _tmp31_;
					const gchar* _tmp32_;
					gboolean match_genre = FALSE;
					gboolean _tmp35_ = FALSE;
					gboolean _tmp36_ = FALSE;
					_tmp22_ = p;
					_tmp23_ = noise_equalizer_preset_get_name (_tmp22_);
					_tmp24_ = _tmp23_;
					_tmp25_ = g_utf8_strdown (_tmp24_, (gssize) -1);
					preset_name = _tmp25_;
					_tmp26_ = self->priv->_current_media;
					_tmp27_ = noise_media_get_genre (_tmp26_);
					_tmp28_ = _tmp27_;
					_tmp29_ = g_utf8_strdown (_tmp28_, (gssize) -1);
					media_genre = _tmp29_;
					_tmp31_ = media_genre;
					_tmp32_ = preset_name;
					if (string_contains (_tmp31_, _tmp32_)) {
						_tmp30_ = TRUE;
					} else {
						const gchar* _tmp33_;
						const gchar* _tmp34_;
						_tmp33_ = preset_name;
						_tmp34_ = media_genre;
						_tmp30_ = string_contains (_tmp33_, _tmp34_);
					}
					match_genre = _tmp30_;
					if (automatic_enabled) {
						_tmp36_ = match_genre;
					} else {
						_tmp36_ = FALSE;
					}
					if (_tmp36_) {
						_tmp35_ = TRUE;
					} else {
						gboolean _tmp37_ = FALSE;
						if (!automatic_enabled) {
							NoiseEqualizerPreset* _tmp38_;
							const gchar* _tmp39_;
							const gchar* _tmp40_;
							const gchar* _tmp41_;
							_tmp38_ = p;
							_tmp39_ = noise_equalizer_preset_get_name (_tmp38_);
							_tmp40_ = _tmp39_;
							_tmp41_ = selected_preset;
							_tmp37_ = g_strcmp0 (_tmp40_, _tmp41_) == 0;
						} else {
							_tmp37_ = FALSE;
						}
						_tmp35_ = _tmp37_;
					}
					if (_tmp35_) {
						{
							gint i = 0;
							i = 0;
							{
								gboolean _tmp42_ = FALSE;
								_tmp42_ = TRUE;
								while (TRUE) {
									NoisePlayback* _tmp44_;
									NoiseEqualizerPreset* _tmp45_;
									if (!_tmp42_) {
										gint _tmp43_;
										_tmp43_ = i;
										i = _tmp43_ + 1;
									}
									_tmp42_ = FALSE;
									if (!(i < 10)) {
										break;
									}
									_tmp44_ = self->player;
									_tmp45_ = p;
									noise_playback_set_equalizer_gain (_tmp44_, i, noise_equalizer_preset_get_gain (_tmp45_, i));
								}
							}
						}
						_g_free0 (media_genre);
						_g_free0 (preset_name);
						_g_object_unref0 (p);
						_g_object_unref0 (_p_it);
						_g_free0 (selected_preset);
						_g_object_unref0 (equalizer_settings);
						return;
					}
					_g_free0 (media_genre);
					_g_free0 (preset_name);
				}
				_g_object_unref0 (p);
			}
			_g_object_unref0 (_p_it);
		}
		{
			GeeIterator* _p_it = NULL;
			GeeCollection* _tmp46_;
			GeeCollection* _tmp47_;
			GeeIterator* _tmp48_;
			GeeIterator* _tmp49_;
			_tmp46_ = noise_equalizer_get_default_presets ();
			_tmp47_ = _tmp46_;
			_tmp48_ = gee_iterable_iterator ((GeeIterable*) _tmp47_);
			_tmp49_ = _tmp48_;
			_g_object_unref0 (_tmp47_);
			_p_it = _tmp49_;
			while (TRUE) {
				GeeIterator* _tmp50_;
				NoiseEqualizerPreset* p = NULL;
				GeeIterator* _tmp51_;
				gpointer _tmp52_;
				gboolean _tmp53_ = FALSE;
				NoiseEqualizerPreset* _tmp54_;
				_tmp50_ = _p_it;
				if (!gee_iterator_next (_tmp50_)) {
					break;
				}
				_tmp51_ = _p_it;
				_tmp52_ = gee_iterator_get (_tmp51_);
				p = (NoiseEqualizerPreset*) _tmp52_;
				_tmp54_ = p;
				if (_tmp54_ != NULL) {
					NoiseMedia* _tmp55_;
					_tmp55_ = self->priv->_current_media;
					_tmp53_ = _tmp55_ != NULL;
				} else {
					_tmp53_ = FALSE;
				}
				if (_tmp53_) {
					gchar* preset_name = NULL;
					NoiseEqualizerPreset* _tmp56_;
					const gchar* _tmp57_;
					const gchar* _tmp58_;
					gchar* _tmp59_;
					gchar* media_genre = NULL;
					NoiseMedia* _tmp60_;
					const gchar* _tmp61_;
					const gchar* _tmp62_;
					gchar* _tmp63_;
					gboolean _tmp64_ = FALSE;
					const gchar* _tmp65_;
					const gchar* _tmp66_;
					gboolean match_genre = FALSE;
					gboolean _tmp69_ = FALSE;
					gboolean _tmp70_ = FALSE;
					_tmp56_ = p;
					_tmp57_ = noise_equalizer_preset_get_name (_tmp56_);
					_tmp58_ = _tmp57_;
					_tmp59_ = g_utf8_strdown (_tmp58_, (gssize) -1);
					preset_name = _tmp59_;
					_tmp60_ = self->priv->_current_media;
					_tmp61_ = noise_media_get_genre (_tmp60_);
					_tmp62_ = _tmp61_;
					_tmp63_ = g_utf8_strdown (_tmp62_, (gssize) -1);
					media_genre = _tmp63_;
					_tmp65_ = media_genre;
					_tmp66_ = preset_name;
					if (string_contains (_tmp65_, _tmp66_)) {
						_tmp64_ = TRUE;
					} else {
						const gchar* _tmp67_;
						const gchar* _tmp68_;
						_tmp67_ = preset_name;
						_tmp68_ = media_genre;
						_tmp64_ = string_contains (_tmp67_, _tmp68_);
					}
					match_genre = _tmp64_;
					if (automatic_enabled) {
						_tmp70_ = match_genre;
					} else {
						_tmp70_ = FALSE;
					}
					if (_tmp70_) {
						_tmp69_ = TRUE;
					} else {
						gboolean _tmp71_ = FALSE;
						if (!automatic_enabled) {
							NoiseEqualizerPreset* _tmp72_;
							const gchar* _tmp73_;
							const gchar* _tmp74_;
							const gchar* _tmp75_;
							_tmp72_ = p;
							_tmp73_ = noise_equalizer_preset_get_name (_tmp72_);
							_tmp74_ = _tmp73_;
							_tmp75_ = selected_preset;
							_tmp71_ = g_strcmp0 (_tmp74_, _tmp75_) == 0;
						} else {
							_tmp71_ = FALSE;
						}
						_tmp69_ = _tmp71_;
					}
					if (_tmp69_) {
						{
							gint i = 0;
							i = 0;
							{
								gboolean _tmp76_ = FALSE;
								_tmp76_ = TRUE;
								while (TRUE) {
									NoisePlayback* _tmp78_;
									NoiseEqualizerPreset* _tmp79_;
									if (!_tmp76_) {
										gint _tmp77_;
										_tmp77_ = i;
										i = _tmp77_ + 1;
									}
									_tmp76_ = FALSE;
									if (!(i < 10)) {
										break;
									}
									_tmp78_ = self->player;
									_tmp79_ = p;
									noise_playback_set_equalizer_gain (_tmp78_, i, noise_equalizer_preset_get_gain (_tmp79_, i));
								}
							}
						}
						_g_free0 (media_genre);
						_g_free0 (preset_name);
						_g_object_unref0 (p);
						_g_object_unref0 (_p_it);
						_g_free0 (selected_preset);
						_g_object_unref0 (equalizer_settings);
						return;
					}
					_g_free0 (media_genre);
					_g_free0 (preset_name);
				}
				_g_object_unref0 (p);
			}
			_g_object_unref0 (_p_it);
		}
		_g_free0 (selected_preset);
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp80_ = FALSE;
			_tmp80_ = TRUE;
			while (TRUE) {
				NoisePlayback* _tmp81_;
				if (!_tmp80_) {
					i = i + 1;
				}
				_tmp80_ = FALSE;
				if (!(i < 10)) {
					break;
				}
				_tmp81_ = self->player;
				noise_playback_set_equalizer_gain (_tmp81_, i, 0);
			}
		}
	}
	_g_object_unref0 (equalizer_settings);
}

void
noise_playback_manager_stop_playback (NoisePlaybackManager* self)
{
	NoisePlayback* _tmp0_;
	gint64 was_playing = 0LL;
	NoiseMedia* _tmp1_;
	NoiseSettingsMain* _tmp5_;
	NoiseSettingsMain* _tmp6_;
	gboolean _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->player;
	noise_playback_pause (_tmp0_);
	noise_playback_manager_set_playing (self, FALSE);
	was_playing = (gint64) 0;
	_tmp1_ = self->priv->_current_media;
	if (_tmp1_ != NULL) {
		NoiseMedia* _tmp2_;
		gint64 _tmp3_;
		gint64 _tmp4_;
		_tmp2_ = self->priv->_current_media;
		_tmp3_ = noise_media_get_rowid (_tmp2_);
		_tmp4_ = _tmp3_;
		was_playing = _tmp4_;
	}
	_tmp5_ = noise_settings_main_get_default ();
	_tmp6_ = _tmp5_;
	_tmp7_ = !noise_settings_main_privacy_mode_enabled (_tmp6_);
	_g_object_unref0 (_tmp6_);
	if (_tmp7_) {
		GSettings* _tmp8_;
		GSettings* _tmp9_;
		_tmp8_ = noise_app_get_saved_state ();
		_tmp9_ = _tmp8_;
		g_settings_set_int64 (_tmp9_, "last-media-playing", (gint64) 0);
	}
	noise_playback_manager_set_current_media (self, NULL);
	g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_STOPPED_SIGNAL], 0, was_playing);
}

static GVariant*
_variant_new4 (gboolean value)
{
	return g_variant_ref_sink (g_variant_new_boolean (value));
}

void
noise_playback_manager_start_playback (NoisePlaybackManager* self)
{
	NoisePlayback* _tmp0_;
	NoiseLibraryWindow* _tmp1_;
	NoiseLibraryWindow* _tmp2_;
	GSimpleActionGroup* _tmp3_;
	GSimpleActionGroup* _tmp4_;
	GAction* _tmp5_;
	GVariant* _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->player;
	noise_playback_play (_tmp0_);
	noise_playback_manager_set_playing (self, TRUE);
	_tmp1_ = noise_app_get_main_window ();
	_tmp2_ = _tmp1_;
	_tmp3_ = noise_library_window_get_actions (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_action_map_lookup_action ((GActionMap*) _tmp4_, NOISE_LIBRARY_WINDOW_ACTION_PLAY);
	_tmp6_ = _variant_new4 (TRUE);
	g_simple_action_set_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, g_simple_action_get_type (), GSimpleAction), _tmp6_);
	_g_variant_unref0 (_tmp6_);
	g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_STARTED_SIGNAL], 0);
}

static GVariant*
_variant_new5 (gboolean value)
{
	return g_variant_ref_sink (g_variant_new_boolean (value));
}

void
noise_playback_manager_pause_playback (NoisePlaybackManager* self)
{
	NoisePlayback* _tmp0_;
	NoiseLibraryWindow* _tmp1_;
	NoiseLibraryWindow* _tmp2_;
	GSimpleActionGroup* _tmp3_;
	GSimpleActionGroup* _tmp4_;
	GAction* _tmp5_;
	GVariant* _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->player;
	noise_playback_pause (_tmp0_);
	noise_playback_manager_set_playing (self, FALSE);
	_tmp1_ = noise_app_get_main_window ();
	_tmp2_ = _tmp1_;
	_tmp3_ = noise_library_window_get_actions (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_action_map_lookup_action ((GActionMap*) _tmp4_, NOISE_LIBRARY_WINDOW_ACTION_PLAY);
	_tmp6_ = _variant_new5 (FALSE);
	g_simple_action_set_state (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, g_simple_action_get_type (), GSimpleAction), _tmp6_);
	_g_variant_unref0 (_tmp6_);
	g_signal_emit (self, noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_PAUSED_SIGNAL], 0);
}

NoisePlaybackManager*
noise_playback_manager_construct (GType object_type)
{
	NoisePlaybackManager * self = NULL;
	self = (NoisePlaybackManager*) g_object_new (object_type, NULL);
	return self;
}

NoisePlaybackManager*
noise_playback_manager_new (void)
{
	return noise_playback_manager_construct (NOISE_TYPE_PLAYBACK_MANAGER);
}

static NoiseLibrary*
noise_playback_manager_get_library (NoisePlaybackManager* self)
{
	NoiseLibrary* result;
	NoiseLibrariesManager* _tmp0_;
	NoiseLibrary* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = noise_libraries_manager;
	_tmp1_ = _tmp0_->local_library;
	result = _tmp1_;
	return result;
}

gint
noise_playback_manager_get_current_index (NoisePlaybackManager* self)
{
	gint result;
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_current_shuffled;
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == 0) {
		result = self->priv->_current_index;
		return result;
	} else {
		result = self->priv->_current_shuffled_index;
		return result;
	}
}

void
noise_playback_manager_set_current_index (NoisePlaybackManager* self,
                                          gint value)
{
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_if_fail (self != NULL);
	g_debug ("PlaybackManager.vala:72: Current index: %d", value);
	_tmp0_ = self->priv->_current_shuffled;
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == 0) {
		self->priv->_current_index = value;
	} else {
		self->priv->_current_shuffled_index = value;
	}
	g_object_notify_by_pspec ((GObject *) self, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY]);
}

gboolean
noise_playback_manager_get_playing (NoisePlaybackManager* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_playing;
	return result;
}

static void
noise_playback_manager_set_playing (NoisePlaybackManager* self,
                                    gboolean value)
{
	g_return_if_fail (self != NULL);
	if (noise_playback_manager_get_playing (self) != value) {
		self->priv->_playing = value;
		g_object_notify_by_pspec ((GObject *) self, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_PLAYING_PROPERTY]);
	}
}

gdouble
noise_playback_manager_get_volume (NoisePlaybackManager* self)
{
	gdouble result;
	NoisePlayback* _tmp0_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->player;
	result = noise_playback_get_volume (_tmp0_);
	return result;
}

void
noise_playback_manager_set_volume (NoisePlaybackManager* self,
                                   gdouble value)
{
	NoisePlayback* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->saved_volume = value;
	_tmp0_ = self->player;
	noise_playback_set_volume (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_VOLUME_PROPERTY]);
}

NoiseMedia*
noise_playback_manager_get_current_media (NoisePlaybackManager* self)
{
	NoiseMedia* result;
	NoiseMedia* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_current_media;
	result = _tmp0_;
	return result;
}

static void
noise_playback_manager_set_current_media (NoisePlaybackManager* self,
                                          NoiseMedia* value)
{
	g_return_if_fail (self != NULL);
	if (noise_playback_manager_get_current_media (self) != value) {
		NoiseMedia* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_current_media);
		self->priv->_current_media = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY]);
	}
}

static void
g_cclosure_user_marshal_VOID__INT64 (GClosure * closure,
                                     GValue * return_value,
                                     guint n_param_values,
                                     const GValue * param_values,
                                     gpointer invocation_hint,
                                     gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT64) (gpointer data1, gint64 arg_1, gpointer data2);
	register GMarshalFunc_VOID__INT64 callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 2);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__INT64) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_int64 (param_values + 1), data2);
}

static GObject *
noise_playback_manager_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NoisePlaybackManager * self;
	NoiseHistoryPlaylist* _tmp0_;
	NoiseStaticPlaylist* _tmp1_;
	NoiseStaticPlaylist* _tmp2_;
	NoiseStaticPlaylist* _tmp3_;
	NoiseStaticPlaylist* _tmp4_;
	NoiseStaticPlaylist* _tmp5_;
	NoiseStaticPlaylist* _tmp6_;
	GThemedIcon* _tmp7_;
	NoiseStreamer* _tmp8_;
	GeeTreeSet* _tmp9_;
	NoiseStreamer* _tmp10_;
	NoiseStreamer* _tmp11_;
	NoisePlayback* _tmp12_;
	parent_class = G_OBJECT_CLASS (noise_playback_manager_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager);
	_tmp0_ = noise_history_playlist_new ();
	_g_object_unref0 (self->history_playlist);
	self->history_playlist = _tmp0_;
	_tmp1_ = noise_static_playlist_new ();
	_g_object_unref0 (self->queue_playlist);
	self->queue_playlist = _tmp1_;
	_tmp2_ = self->queue_playlist;
	noise_playlist_set_name ((NoisePlaylist*) _tmp2_, C_ ("Name of the playlist", "Queue"));
	_tmp3_ = self->queue_playlist;
	noise_static_playlist_set_read_only (_tmp3_, TRUE);
	_tmp4_ = self->queue_playlist;
	noise_static_playlist_set_allow_duplicate (_tmp4_, TRUE);
	_tmp5_ = self->queue_playlist;
	noise_static_playlist_set_show_badge (_tmp5_, TRUE);
	_tmp6_ = self->queue_playlist;
	_tmp7_ = (GThemedIcon*) g_themed_icon_new ("playlist-queue");
	_g_object_unref0 (((NoisePlaylist*) _tmp6_)->icon);
	((NoisePlaylist*) _tmp6_)->icon = (GIcon*) _tmp7_;
	_tmp8_ = noise_streamer_new ();
	_g_object_unref0 (self->file_player);
	self->file_player = _tmp8_;
	_tmp9_ = self->priv->playbacks;
	_tmp10_ = self->file_player;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, (NoisePlayback*) _tmp10_);
	_tmp11_ = self->file_player;
	_tmp12_ = _g_object_ref0 ((NoisePlayback*) _tmp11_);
	_g_object_unref0 (self->player);
	self->player = _tmp12_;
	return obj;
}

static void
noise_playback_manager_class_init (NoisePlaybackManagerClass * klass,
                                   gpointer klass_data)
{
	noise_playback_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NoisePlaybackManager_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_playback_manager_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_playback_manager_set_property;
	G_OBJECT_CLASS (klass)->constructor = noise_playback_manager_constructor;
	G_OBJECT_CLASS (klass)->finalize = noise_playback_manager_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY] = g_param_spec_int ("current-index", "current-index", "current-index", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_PLAYBACK_MANAGER_PLAYING_PROPERTY, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_PLAYING_PROPERTY] = g_param_spec_boolean ("playing", "playing", "playing", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_PLAYBACK_MANAGER_VOLUME_PROPERTY, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_VOLUME_PROPERTY] = g_param_spec_double ("volume", "volume", "volume", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY, noise_playback_manager_properties[NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY] = g_param_spec_object ("current-media", "current-media", "current-media", NOISE_TYPE_MEDIA, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_CHANGING_PLAYER_SIGNAL] = g_signal_new ("changing-player", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_MEDIA_PLAYED_SIGNAL] = g_signal_new ("media-played", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, NOISE_TYPE_MEDIA);
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_STOPPED_SIGNAL] = g_signal_new ("playback-stopped", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT64, G_TYPE_NONE, 1, G_TYPE_INT64);
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_STARTED_SIGNAL] = g_signal_new ("playback-started", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYBACK_PAUSED_SIGNAL] = g_signal_new ("playback-paused", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_PLAYER_CHANGED_SIGNAL] = g_signal_new ("player-changed", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	noise_playback_manager_signals[NOISE_PLAYBACK_MANAGER_QUEUE_CLEARED_SIGNAL] = g_signal_new ("queue-cleared", NOISE_TYPE_PLAYBACK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
noise_playback_manager_instance_init (NoisePlaybackManager * self,
                                      gpointer klass)
{
	GeeTreeSet* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	self->priv = noise_playback_manager_get_instance_private (self);
	g_rec_mutex_init (&self->priv->__lock_playbacks);
	_tmp0_ = gee_tree_set_new (NOISE_TYPE_PLAYBACK, NULL, NULL, NULL, NULL, NULL);
	self->priv->playbacks = _tmp0_;
	_tmp1_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	self->priv->_current = _tmp1_;
	_tmp2_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	self->priv->_current_shuffled = _tmp2_;
	self->priv->_playing = FALSE;
	self->priv->saved_volume = (gdouble) 1;
}

static void
noise_playback_manager_finalize (GObject * obj)
{
	NoisePlaybackManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager);
	g_rec_mutex_clear (&self->priv->__lock_playbacks);
	_g_object_unref0 (self->priv->playbacks);
	_g_object_unref0 (self->priv->_current);
	_g_object_unref0 (self->priv->_current_shuffled);
	_g_object_unref0 (self->queue_playlist);
	_g_object_unref0 (self->history_playlist);
	_g_object_unref0 (self->file_player);
	_g_object_unref0 (self->player);
	_g_object_unref0 (self->priv->_current_media);
	G_OBJECT_CLASS (noise_playback_manager_parent_class)->finalize (obj);
}

/**
* Manages song playback, queue, repeating and shuffling
*
* Finds the appropriate {@link Noise.Playback} to play a media
*/
GType
noise_playback_manager_get_type (void)
{
	static volatile gsize noise_playback_manager_type_id__volatile = 0;
	if (g_once_init_enter (&noise_playback_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoisePlaybackManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_playback_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoisePlaybackManager), 0, (GInstanceInitFunc) noise_playback_manager_instance_init, NULL };
		GType noise_playback_manager_type_id;
		noise_playback_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "NoisePlaybackManager", &g_define_type_info, 0);
		NoisePlaybackManager_private_offset = g_type_add_instance_private (noise_playback_manager_type_id, sizeof (NoisePlaybackManagerPrivate));
		g_once_init_leave (&noise_playback_manager_type_id__volatile, noise_playback_manager_type_id);
	}
	return noise_playback_manager_type_id__volatile;
}

static void
_vala_noise_playback_manager_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	NoisePlaybackManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager);
	switch (property_id) {
		case NOISE_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY:
		g_value_set_int (value, noise_playback_manager_get_current_index (self));
		break;
		case NOISE_PLAYBACK_MANAGER_PLAYING_PROPERTY:
		g_value_set_boolean (value, noise_playback_manager_get_playing (self));
		break;
		case NOISE_PLAYBACK_MANAGER_VOLUME_PROPERTY:
		g_value_set_double (value, noise_playback_manager_get_volume (self));
		break;
		case NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY:
		g_value_set_object (value, noise_playback_manager_get_current_media (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_noise_playback_manager_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	NoisePlaybackManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager);
	switch (property_id) {
		case NOISE_PLAYBACK_MANAGER_CURRENT_INDEX_PROPERTY:
		noise_playback_manager_set_current_index (self, g_value_get_int (value));
		break;
		case NOISE_PLAYBACK_MANAGER_PLAYING_PROPERTY:
		noise_playback_manager_set_playing (self, g_value_get_boolean (value));
		break;
		case NOISE_PLAYBACK_MANAGER_VOLUME_PROPERTY:
		noise_playback_manager_set_volume (self, g_value_get_double (value));
		break;
		case NOISE_PLAYBACK_MANAGER_CURRENT_MEDIA_PROPERTY:
		noise_playback_manager_set_current_media (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

