/* GenericList.c generated by valac 0.44.7, the Vala compiler
 * generated from GenericList.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>,
 *              Victor Eduardo <victoreduardm@gmail.com>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gee.h>
#include "io.elementary.music-core.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>

#define NOISE_TYPE_GENERIC_LIST (noise_generic_list_get_type ())
#define NOISE_GENERIC_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_GENERIC_LIST, NoiseGenericList))
#define NOISE_GENERIC_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_GENERIC_LIST, NoiseGenericListClass))
#define NOISE_IS_GENERIC_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_GENERIC_LIST))
#define NOISE_IS_GENERIC_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_GENERIC_LIST))
#define NOISE_GENERIC_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_GENERIC_LIST, NoiseGenericListClass))

typedef struct _NoiseGenericList NoiseGenericList;
typedef struct _NoiseGenericListClass NoiseGenericListClass;
typedef struct _NoiseGenericListPrivate NoiseGenericListPrivate;
typedef enum  {
	NOISE_LIST_COLUMN_ICON = 0,
	NOISE_LIST_COLUMN_NUMBER,
	NOISE_LIST_COLUMN_TRACK,
	NOISE_LIST_COLUMN_TITLE,
	NOISE_LIST_COLUMN_LENGTH,
	NOISE_LIST_COLUMN_ARTIST,
	NOISE_LIST_COLUMN_ALBUM,
	NOISE_LIST_COLUMN_ALBUM_ARTIST,
	NOISE_LIST_COLUMN_COMPOSER,
	NOISE_LIST_COLUMN_GENRE,
	NOISE_LIST_COLUMN_YEAR,
	NOISE_LIST_COLUMN_GROUPING,
	NOISE_LIST_COLUMN_BITRATE,
	NOISE_LIST_COLUMN_RATING,
	NOISE_LIST_COLUMN_PLAY_COUNT,
	NOISE_LIST_COLUMN_SKIP_COUNT,
	NOISE_LIST_COLUMN_DATE_ADDED,
	NOISE_LIST_COLUMN_LAST_PLAYED,
	NOISE_LIST_COLUMN_BPM,
	NOISE_LIST_COLUMN_FILE_LOCATION,
	NOISE_LIST_COLUMN_FILE_SIZE,
	NOISE_LIST_COLUMN_N_COLUMNS
} NoiseListColumn;

#define NOISE_TYPE_LIST_COLUMN (noise_list_column_get_type ())

#define NOISE_TYPE_FAST_MODEL (noise_fast_model_get_type ())
#define NOISE_FAST_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_FAST_MODEL, NoiseFastModel))
#define NOISE_FAST_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_FAST_MODEL, NoiseFastModelClass))
#define NOISE_IS_FAST_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_FAST_MODEL))
#define NOISE_IS_FAST_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_FAST_MODEL))
#define NOISE_FAST_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_FAST_MODEL, NoiseFastModelClass))

typedef struct _NoiseFastModel NoiseFastModel;
typedef struct _NoiseFastModelClass NoiseFastModelClass;

#define NOISE_TYPE_CELL_DATA_FUNCTION_HELPER (noise_cell_data_function_helper_get_type ())
#define NOISE_CELL_DATA_FUNCTION_HELPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_CELL_DATA_FUNCTION_HELPER, NoiseCellDataFunctionHelper))
#define NOISE_CELL_DATA_FUNCTION_HELPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_CELL_DATA_FUNCTION_HELPER, NoiseCellDataFunctionHelperClass))
#define NOISE_IS_CELL_DATA_FUNCTION_HELPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_CELL_DATA_FUNCTION_HELPER))
#define NOISE_IS_CELL_DATA_FUNCTION_HELPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_CELL_DATA_FUNCTION_HELPER))
#define NOISE_CELL_DATA_FUNCTION_HELPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_CELL_DATA_FUNCTION_HELPER, NoiseCellDataFunctionHelperClass))

typedef struct _NoiseCellDataFunctionHelper NoiseCellDataFunctionHelper;
typedef struct _NoiseCellDataFunctionHelperClass NoiseCellDataFunctionHelperClass;

#define NOISE_TYPE_TREE_VIEW_SETUP (noise_tree_view_setup_get_type ())
#define NOISE_TREE_VIEW_SETUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_TREE_VIEW_SETUP, NoiseTreeViewSetup))
#define NOISE_TREE_VIEW_SETUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_TREE_VIEW_SETUP, NoiseTreeViewSetupClass))
#define NOISE_IS_TREE_VIEW_SETUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_TREE_VIEW_SETUP))
#define NOISE_IS_TREE_VIEW_SETUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_TREE_VIEW_SETUP))
#define NOISE_TREE_VIEW_SETUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_TREE_VIEW_SETUP, NoiseTreeViewSetupClass))

typedef struct _NoiseTreeViewSetup NoiseTreeViewSetup;
typedef struct _NoiseTreeViewSetupClass NoiseTreeViewSetupClass;

#define NOISE_TYPE_VIEW_WRAPPER (noise_view_wrapper_get_type ())
#define NOISE_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapper))
#define NOISE_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapperClass))
#define NOISE_IS_VIEW_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_VIEW_WRAPPER))
#define NOISE_IS_VIEW_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_VIEW_WRAPPER))
#define NOISE_VIEW_WRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_VIEW_WRAPPER, NoiseViewWrapperClass))

typedef struct _NoiseViewWrapper NoiseViewWrapper;
typedef struct _NoiseViewWrapperClass NoiseViewWrapperClass;
typedef gint (*NoiseGenericListSortCompareFunc) (gint sort_column_id, GtkSortType sort_direction, NoiseMedia* a, NoiseMedia* b, gint index_a, gint index_b, gpointer user_data);
typedef void (*NoiseGenericListViewSearchFunc) (const gchar* search, GeeArrayList* table, GeeArrayList* showing, gpointer user_data);
enum  {
	NOISE_GENERIC_LIST_0_PROPERTY,
	NOISE_GENERIC_LIST_COLUMNS_PROPERTY,
	NOISE_GENERIC_LIST_RESEARCH_NEEDED_PROPERTY,
	NOISE_GENERIC_LIST_IS_CURRENT_LIST_PROPERTY,
	NOISE_GENERIC_LIST_PLAYLIST_PROPERTY,
	NOISE_GENERIC_LIST_TVS_PROPERTY,
	NOISE_GENERIC_LIST_HINT_PROPERTY,
	NOISE_GENERIC_LIST_PARENT_WRAPPER_PROPERTY,
	NOISE_GENERIC_LIST_NUM_PROPERTIES
};
static GParamSpec* noise_generic_list_properties[NOISE_GENERIC_LIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _noise_cell_data_function_helper_unref0(var) ((var == NULL) ? NULL : (var = (noise_cell_data_function_helper_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef enum  {
	NOISE_VIEW_WRAPPER_HINT_NONE,
	NOISE_VIEW_WRAPPER_HINT_MUSIC,
	NOISE_VIEW_WRAPPER_HINT_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_READ_ONLY_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_SMART_PLAYLIST,
	NOISE_VIEW_WRAPPER_HINT_CDROM,
	NOISE_VIEW_WRAPPER_HINT_DEVICE,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIO,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_PODCAST,
	NOISE_VIEW_WRAPPER_HINT_DEVICE_AUDIOBOOK,
	NOISE_VIEW_WRAPPER_HINT_NETWORK_DEVICE,
	NOISE_VIEW_WRAPPER_HINT_ALBUM_LIST,
	NOISE_VIEW_WRAPPER_HINT_QUEUE
} NoiseViewWrapperHint;

#define NOISE_VIEW_WRAPPER_TYPE_HINT (noise_view_wrapper_hint_get_type ())

#define NOISE_TYPE_PLAYBACK_MANAGER (noise_playback_manager_get_type ())
#define NOISE_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManager))
#define NOISE_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManagerClass))
#define NOISE_IS_PLAYBACK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_PLAYBACK_MANAGER))
#define NOISE_IS_PLAYBACK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_PLAYBACK_MANAGER))
#define NOISE_PLAYBACK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_PLAYBACK_MANAGER, NoisePlaybackManagerClass))

typedef struct _NoisePlaybackManager NoisePlaybackManager;
typedef struct _NoisePlaybackManagerClass NoisePlaybackManagerClass;

#define NOISE_TYPE_LIBRARY_WINDOW (noise_library_window_get_type ())
#define NOISE_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindow))
#define NOISE_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))
#define NOISE_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))

typedef struct _NoiseLibraryWindow NoiseLibraryWindow;
typedef struct _NoiseLibraryWindowClass NoiseLibraryWindowClass;
typedef struct _NoiseGenericListMediaPlayedData NoiseGenericListMediaPlayedData;

#define NOISE_TYPE_LOCAL_LIBRARY (noise_local_library_get_type ())
#define NOISE_LOCAL_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LOCAL_LIBRARY, NoiseLocalLibrary))
#define NOISE_LOCAL_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LOCAL_LIBRARY, NoiseLocalLibraryClass))
#define NOISE_IS_LOCAL_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LOCAL_LIBRARY))
#define NOISE_IS_LOCAL_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LOCAL_LIBRARY))
#define NOISE_LOCAL_LIBRARY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LOCAL_LIBRARY, NoiseLocalLibraryClass))

typedef struct _NoiseLocalLibrary NoiseLocalLibrary;
typedef struct _NoiseLocalLibraryClass NoiseLocalLibraryClass;
typedef struct _NoiseLocalLibraryPrivate NoiseLocalLibraryPrivate;
typedef struct _NoiseLibraryWindowPrivate NoiseLibraryWindowPrivate;
typedef struct _NoisePlaybackManagerPrivate NoisePlaybackManagerPrivate;

#define NOISE_TYPE_HISTORY_PLAYLIST (noise_history_playlist_get_type ())
#define NOISE_HISTORY_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_HISTORY_PLAYLIST, NoiseHistoryPlaylist))
#define NOISE_HISTORY_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_HISTORY_PLAYLIST, NoiseHistoryPlaylistClass))
#define NOISE_IS_HISTORY_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_HISTORY_PLAYLIST))
#define NOISE_IS_HISTORY_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_HISTORY_PLAYLIST))
#define NOISE_HISTORY_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_HISTORY_PLAYLIST, NoiseHistoryPlaylistClass))

typedef struct _NoiseHistoryPlaylist NoiseHistoryPlaylist;
typedef struct _NoiseHistoryPlaylistClass NoiseHistoryPlaylistClass;

#define NOISE_TYPE_STREAMER (noise_streamer_get_type ())
#define NOISE_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_STREAMER, NoiseStreamer))
#define NOISE_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_STREAMER, NoiseStreamerClass))
#define NOISE_IS_STREAMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_STREAMER))
#define NOISE_IS_STREAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_STREAMER))
#define NOISE_STREAMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_STREAMER, NoiseStreamerClass))

typedef struct _NoiseStreamer NoiseStreamer;
typedef struct _NoiseStreamerClass NoiseStreamerClass;

#define NOISE_TYPE_LIST_VIEW (noise_list_view_get_type ())
#define NOISE_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LIST_VIEW, NoiseListView))
#define NOISE_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LIST_VIEW, NoiseListViewClass))
#define NOISE_IS_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LIST_VIEW))
#define NOISE_IS_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LIST_VIEW))
#define NOISE_LIST_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LIST_VIEW, NoiseListViewClass))

typedef struct _NoiseListView NoiseListView;
typedef struct _NoiseListViewClass NoiseListViewClass;

#define NOISE_TYPE_MUSIC_LIST_VIEW (noise_music_list_view_get_type ())
#define NOISE_MUSIC_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_MUSIC_LIST_VIEW, NoiseMusicListView))
#define NOISE_MUSIC_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_MUSIC_LIST_VIEW, NoiseMusicListViewClass))
#define NOISE_IS_MUSIC_LIST_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_MUSIC_LIST_VIEW))
#define NOISE_IS_MUSIC_LIST_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_MUSIC_LIST_VIEW))
#define NOISE_MUSIC_LIST_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_MUSIC_LIST_VIEW, NoiseMusicListViewClass))

typedef struct _NoiseMusicListView NoiseMusicListView;
typedef struct _NoiseMusicListViewClass NoiseMusicListViewClass;
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
typedef GValue* (*NoiseFastModelValueReturnFunc) (gint row, gint column, GObject* o, gpointer user_data);
enum  {
	NOISE_GENERIC_LIST_IMPORT_REQUESTED_SIGNAL,
	NOISE_GENERIC_LIST_ROWS_REORDERED_SIGNAL,
	NOISE_GENERIC_LIST_NUM_SIGNALS
};
static guint noise_generic_list_signals[NOISE_GENERIC_LIST_NUM_SIGNALS] = {0};

struct _NoiseGenericList {
	GtkTreeView parent_instance;
	NoiseGenericListPrivate * priv;
	NoiseFastModel* fm;
	GeeArrayList* table;
	GeeArrayList* showing;
	gint sort_column_id;
	GtkSortType sort_direction;
	gboolean dragging;
	NoiseCellDataFunctionHelper* cell_data_helper;
};

struct _NoiseGenericListClass {
	GtkTreeViewClass parent_class;
	void (*add_column) (NoiseGenericList* self, GtkTreeViewColumn* column, NoiseListColumn type);
	void (*mediaRemoveClicked) (NoiseGenericList* self);
};

struct _NoiseGenericListPrivate {
	GeeList* _columns;
	gboolean _research_needed;
	gboolean _is_current_list;
	NoisePlaylist* _playlist;
	NoiseTreeViewSetup* _tvs;
	NoiseViewWrapper* _parent_wrapper;
	NoiseGenericListSortCompareFunc compare_func;
	gpointer compare_func_target;
	NoiseGenericListViewSearchFunc search_func;
	gpointer search_func_target;
};

struct _NoiseGenericListMediaPlayedData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	NoiseGenericList* self;
	NoiseMedia* m;
};

struct _NoiseLocalLibrary {
	NoiseLibrary parent_instance;
	NoiseLocalLibraryPrivate * priv;
	NoiseStaticPlaylist* p_music;
};

struct _NoiseLocalLibraryClass {
	NoiseLibraryClass parent_class;
};

struct _NoiseLibraryWindow {
	GtkWindow parent_instance;
	NoiseLibraryWindowPrivate * priv;
	GeeHashMap* match_playlists;
};

struct _NoiseLibraryWindowClass {
	GtkWindowClass parent_class;
	void (*playback_stopped) (NoiseLibraryWindow* self, gint64 was_playing);
	void (*play_media) (NoiseLibraryWindow* self, gboolean inhibit_notifications);
	void (*play_next_media) (NoiseLibraryWindow* self, gboolean inhibit_notifications);
	void (*play_previous_media) (NoiseLibraryWindow* self, gboolean inhibit_notifications);
	void (*action_import) (NoiseLibraryWindow* self);
	void (*end_of_stream) (NoiseLibraryWindow* self);
	void (*error_occured) (NoiseLibraryWindow* self);
	void (*current_position_update) (NoiseLibraryWindow* self, gint64 position);
	void (*dragReceived) (NoiseLibraryWindow* self, GdkDragContext* context, gint x, gint y, GtkSelectionData* data, guint info, guint timestamp);
};

struct _NoisePlaybackManager {
	GObject parent_instance;
	NoisePlaybackManagerPrivate * priv;
	NoiseStaticPlaylist* queue_playlist;
	NoiseHistoryPlaylist* history_playlist;
	NoiseStreamer* file_player;
	NoisePlayback* player;
};

struct _NoisePlaybackManagerClass {
	GObjectClass parent_class;
};

static gint NoiseGenericList_private_offset;
static gpointer noise_generic_list_parent_class = NULL;

GType noise_generic_list_get_type (void) G_GNUC_CONST;
GType noise_list_column_get_type (void) G_GNUC_CONST;
GType noise_fast_model_get_type (void) G_GNUC_CONST;
gpointer noise_cell_data_function_helper_ref (gpointer instance);
void noise_cell_data_function_helper_unref (gpointer instance);
GParamSpec* noise_param_spec_cell_data_function_helper (const gchar* name,
                                                        const gchar* nick,
                                                        const gchar* blurb,
                                                        GType object_type,
                                                        GParamFlags flags);
void noise_value_set_cell_data_function_helper (GValue* value,
                                                gpointer v_object);
void noise_value_take_cell_data_function_helper (GValue* value,
                                                 gpointer v_object);
gpointer noise_value_get_cell_data_function_helper (const GValue* value);
GType noise_cell_data_function_helper_get_type (void) G_GNUC_CONST;
GType noise_tree_view_setup_get_type (void) G_GNUC_CONST;
GType noise_view_wrapper_get_type (void) G_GNUC_CONST;
#define NOISE_GENERIC_LIST_OPTIMAL_COLUMN -2
NoiseGenericList* noise_generic_list_construct (GType object_type,
                                                NoiseViewWrapper* view_wrapper,
                                                NoiseTreeViewSetup* tvs);
void noise_generic_list_add_column (NoiseGenericList* self,
                                    GtkTreeViewColumn* column,
                                    NoiseListColumn type);
static void noise_generic_list_real_add_column (NoiseGenericList* self,
                                         GtkTreeViewColumn* column,
                                         NoiseListColumn type);
void noise_generic_list_mediaRemoveClicked (NoiseGenericList* self);
static void noise_generic_list_real_mediaRemoveClicked (NoiseGenericList* self);
void noise_generic_list_set_media (NoiseGenericList* self,
                                   GeeCollection* to_add);
void noise_generic_list_set_table (NoiseGenericList* self,
                                   GeeArrayList* table,
                                   gboolean do_resort);
void noise_generic_list_scroll_to_current_media (NoiseGenericList* self,
                                                 gboolean unfilter_if_not_found);
void noise_generic_list_set_fixed_column_width (NoiseGenericList* self,
                                                GtkWidget* treeview,
                                                GtkTreeViewColumn* column,
                                                GtkCellRendererText* renderer,
                                                gchar** strings,
                                                gint strings_length1,
                                                gint padding);
static NoiseMedia* noise_generic_list_get_media_from_index (NoiseGenericList* self,
                                                     gint index);
NoiseMedia* noise_generic_list_get_object_from_index (NoiseGenericList* self,
                                                      gint index);
void noise_generic_list_on_rating_cell_changed (NoiseGenericList* self,
                                                gint new_rating,
                                                GtkWidget* widget,
                                                const gchar* path);
NoiseViewWrapper* noise_generic_list_get_parent_wrapper (NoiseGenericList* self);
NoiseLibrary* noise_view_wrapper_get_library (NoiseViewWrapper* self);
static void noise_generic_list_on_rows_reordered (NoiseGenericList* self);
gboolean noise_generic_list_get_is_current_list (NoiseGenericList* self);
void noise_generic_list_set_as_current_list (NoiseGenericList* self,
                                             NoiseMedia* m);
static void noise_generic_list_real_row_activated (GtkTreeView* base,
                                            GtkTreePath* path,
                                            GtkTreeViewColumn* column);
GType noise_view_wrapper_hint_get_type (void) G_GNUC_CONST;
NoiseViewWrapperHint noise_generic_list_get_hint (NoiseGenericList* self);
GType noise_playback_manager_get_type (void) G_GNUC_CONST;
NoisePlaybackManager* noise_app_get_player (void);
void noise_playback_manager_set_current_index (NoisePlaybackManager* self,
                                               gint value);
void noise_playback_manager_play_media (NoisePlaybackManager* self,
                                        NoiseMedia* m);
gboolean noise_playback_manager_get_playing (NoisePlaybackManager* self);
GType noise_library_window_get_type (void) G_GNUC_CONST;
NoiseLibraryWindow* noise_app_get_main_window (void);
void noise_library_window_play_media (NoiseLibraryWindow* self,
                                      gboolean inhibit_notifications);
static void noise_generic_list_media_played_data_free (gpointer _data);
static void noise_generic_list_media_played_async_ready_wrapper (GObject *source_object,
                                                          GAsyncResult *res,
                                                          void *user_data);
static void noise_generic_list_media_played (NoiseGenericList* self,
                                      NoiseMedia* m,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
static void noise_generic_list_media_played_finish (NoiseGenericList* self,
                                             GAsyncResult* _res_);
static gboolean noise_generic_list_media_played_co (NoiseGenericListMediaPlayedData* _data_);
static gboolean _noise_generic_list_media_played_co_gsource_func (gpointer self);
NoiseMedia* noise_playback_manager_get_current_media (NoisePlaybackManager* self);
static void noise_generic_list_set_is_current_list (NoiseGenericList* self,
                                             gboolean value);
NoisePlaylist* noise_generic_list_get_playlist (NoiseGenericList* self);
GType noise_local_library_get_type (void) G_GNUC_CONST;
GSettings* noise_app_get_saved_state (void);
static GeeList* noise_generic_list_start_at (NoiseGenericList* self,
                                      NoiseMedia* start,
                                      GeeList* media);
GeeBidirList* noise_generic_list_get_visible_table (NoiseGenericList* self);
void noise_playback_manager_clear_queue (NoisePlaybackManager* self);
void noise_playback_manager_queue_media (NoisePlaybackManager* self,
                                         GeeCollection* to_queue);
GType noise_history_playlist_get_type (void) G_GNUC_CONST;
GType noise_streamer_get_type (void) G_GNUC_CONST;
GType noise_list_view_get_type (void) G_GNUC_CONST;
NoiseListView* noise_view_wrapper_get_list_view (NoiseViewWrapper* self);
GType noise_music_list_view_get_type (void) G_GNUC_CONST;
NoiseMusicListView* noise_list_view_get_list_view (NoiseListView* self);
void noise_generic_list_set_sort_column_id (NoiseGenericList* self,
                                            gint sort_column_id,
                                            GtkSortType order);
NoiseTreeViewSetup* noise_generic_list_get_tvs (NoiseGenericList* self);
NoiseListColumn noise_tree_view_setup_get_sort_column_id (NoiseTreeViewSetup* self);
GtkSortType noise_tree_view_setup_get_sort_direction (NoiseTreeViewSetup* self);
GeeCollection* noise_generic_list_get_selected_medias (NoiseGenericList* self);
static GtkTreePath* _vala_GtkTreePath_copy (GtkTreePath* self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static void __vala_GtkTreePath_free0_ (gpointer var);
static inline void _g_list_free___vala_GtkTreePath_free0_ (GList* self);
GeeBidirList* noise_generic_list_get_table (NoiseGenericList* self);
gint noise_generic_list_get_index_from_iter (GtkTreeIter* iter);
void noise_generic_list_set_value_func (NoiseGenericList* self,
                                        NoiseFastModelValueReturnFunc func,
                                        gpointer func_target);
void noise_fast_model_set_value_func (NoiseFastModel* self,
                                      NoiseFastModelValueReturnFunc func,
                                      gpointer func_target);
void noise_generic_list_resort (NoiseGenericList* self);
void noise_generic_list_do_search (NoiseGenericList* self,
                                   const gchar* search);
void noise_generic_list_set_search_func (NoiseGenericList* self,
                                         NoiseGenericListViewSearchFunc func,
                                         gpointer func_target);
gboolean noise_generic_list_get_research_needed (NoiseGenericList* self);
void noise_generic_list_set_research_needed (NoiseGenericList* self,
                                             gboolean value);
void noise_fast_model_set_table (NoiseFastModel* self,
                                 GeeArrayList* table);
void noise_fast_model_remove (NoiseFastModel* self,
                              GtkTreeIter* iter);
void noise_fast_model_append (NoiseFastModel* self,
                              GtkTreeIter* iter);
static void noise_generic_list_reorder_requested (NoiseGenericList* self,
                                           gint column,
                                           GtkSortType direction);
static void noise_generic_list_quicksort (NoiseGenericList* self,
                                   gint start,
                                   gint end);
void noise_generic_list_set_compare_func (NoiseGenericList* self,
                                          NoiseGenericListSortCompareFunc func,
                                          gpointer func_target);
static void noise_generic_list_swap (NoiseGenericList* self,
                              gint a,
                              gint b);
static void noise_generic_list_on_drag_begin (NoiseGenericList* self,
                                       GtkWidget* sender,
                                       GdkDragContext* context);
static void noise_generic_list_on_drag_data_get (NoiseGenericList* self,
                                          GdkDragContext* context,
                                          GtkSelectionData* selection_data,
                                          guint info,
                                          guint time_);
static void _vala_array_add13 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void noise_generic_list_on_drag_end (NoiseGenericList* self,
                                     GtkWidget* sender,
                                     GdkDragContext* context);
GeeList* noise_generic_list_get_columns (NoiseGenericList* self);
void noise_generic_list_set_columns (NoiseGenericList* self,
                                     GeeList* value);
void noise_generic_list_set_playlist (NoiseGenericList* self,
                                      NoisePlaylist* value);
void noise_generic_list_set_tvs (NoiseGenericList* self,
                                 NoiseTreeViewSetup* value);
NoiseViewWrapperHint noise_tree_view_setup_get_hint (NoiseTreeViewSetup* self);
void noise_generic_list_set_hint (NoiseGenericList* self,
                                  NoiseViewWrapperHint value);
void noise_tree_view_setup_set_hint (NoiseTreeViewSetup* self,
                                     NoiseViewWrapperHint value);
void noise_generic_list_set_parent_wrapper (NoiseGenericList* self,
                                            NoiseViewWrapper* value);
NoisePlaylist* noise_view_wrapper_get_playlist (NoiseViewWrapper* self);
static GObject * noise_generic_list_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
GeeCollection* noise_list_column_get_all (void);
GType noise_list_column_get_data_type (NoiseListColumn self);
NoiseFastModel* noise_fast_model_new (GeeList* column_types);
NoiseFastModel* noise_fast_model_construct (GType object_type,
                                            GeeList* column_types);
static void _noise_generic_list_reorder_requested_noise_fast_model_reorder_requested (NoiseFastModel* _sender,
                                                                               gint column,
                                                                               GtkSortType direction,
                                                                               gpointer self);
NoiseCellDataFunctionHelper* noise_cell_data_function_helper_new (NoiseGenericList* view);
NoiseCellDataFunctionHelper* noise_cell_data_function_helper_construct (GType object_type,
                                                                        NoiseGenericList* view);
GeeCollection* noise_tree_view_setup_get_columns (NoiseTreeViewSetup* self);
NoiseListColumn* noise_tree_view_setup_get_column_type (GtkTreeViewColumn* column);
static void _noise_generic_list_on_rows_reordered_noise_generic_list_rows_reordered (NoiseGenericList* _sender,
                                                                              gpointer self);
static gboolean _noise_generic_list___lambda39_ (NoiseGenericList* self,
                                          GdkEventKey* event);
static gboolean __noise_generic_list___lambda39__gtk_widget_key_press_event (GtkWidget* _sender,
                                                                      GdkEventKey* event,
                                                                      gpointer self);
static void _noise_generic_list_on_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                              GdkDragContext* context,
                                                              gpointer self);
static void _noise_generic_list_on_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender,
                                                                    GdkDragContext* context,
                                                                    GtkSelectionData* selection_data,
                                                                    guint info,
                                                                    guint time_,
                                                                    gpointer self);
static void _noise_generic_list_on_drag_end_gtk_widget_drag_end (GtkWidget* _sender,
                                                          GdkDragContext* context,
                                                          gpointer self);
static void _gtk_widget_queue_draw_noise_library_media_updated (NoiseLibrary* _sender,
                                                         GeeCollection* medias,
                                                         gpointer self);
static void _noise_generic_list___lambda40_ (NoiseGenericList* self);
static void __noise_generic_list___lambda40__noise_playback_manager_queue_cleared (NoisePlaybackManager* _sender,
                                                                            gpointer self);
static void _noise_generic_list_media_played_noise_playback_manager_media_played (NoisePlaybackManager* _sender,
                                                                           NoiseMedia* played_media,
                                                                           gpointer self);
static void noise_generic_list_finalize (GObject * obj);
static void _vala_noise_generic_list_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_noise_generic_list_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
noise_generic_list_get_instance_private (NoiseGenericList* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseGenericList_private_offset);
}

NoiseGenericList*
noise_generic_list_construct (GType object_type,
                              NoiseViewWrapper* view_wrapper,
                              NoiseTreeViewSetup* tvs)
{
	NoiseGenericList * self = NULL;
	g_return_val_if_fail (view_wrapper != NULL, NULL);
	g_return_val_if_fail (tvs != NULL, NULL);
	self = (NoiseGenericList*) g_object_new (object_type, "parent-wrapper", view_wrapper, "tvs", tvs, NULL);
	return self;
}

static void
noise_generic_list_real_add_column (NoiseGenericList* self,
                                    GtkTreeViewColumn* column,
                                    NoiseListColumn type)
{
	g_critical ("Type `%s' does not implement abstract method `noise_generic_list_add_column'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
noise_generic_list_add_column (NoiseGenericList* self,
                               GtkTreeViewColumn* column,
                               NoiseListColumn type)
{
	g_return_if_fail (self != NULL);
	NOISE_GENERIC_LIST_GET_CLASS (self)->add_column (self, column, type);
}

static void
noise_generic_list_real_mediaRemoveClicked (NoiseGenericList* self)
{
	g_critical ("Type `%s' does not implement abstract method `noise_generic_list_mediaRemoveClicked'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
noise_generic_list_mediaRemoveClicked (NoiseGenericList* self)
{
	g_return_if_fail (self != NULL);
	NOISE_GENERIC_LIST_GET_CLASS (self)->mediaRemoveClicked (self);
}

void
noise_generic_list_set_media (NoiseGenericList* self,
                              GeeCollection* to_add)
{
	GeeArrayList* new_table = NULL;
	GeeArrayList* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (to_add != NULL);
	_tmp0_ = gee_array_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	new_table = _tmp0_;
	gee_array_list_add_all (new_table, to_add);
	noise_generic_list_set_table (self, new_table, TRUE);
	noise_generic_list_scroll_to_current_media (self, FALSE);
	_g_object_unref0 (new_table);
}

void
noise_generic_list_set_fixed_column_width (NoiseGenericList* self,
                                           GtkWidget* treeview,
                                           GtkTreeViewColumn* column,
                                           GtkCellRendererText* renderer,
                                           gchar** strings,
                                           gint strings_length1,
                                           gint padding)
{
	gint max_width = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (treeview != NULL);
	g_return_if_fail (column != NULL);
	g_return_if_fail (renderer != NULL);
	max_width = 0;
	{
		gchar** str_collection = NULL;
		gint str_collection_length1 = 0;
		gint _str_collection_size_ = 0;
		gint str_it = 0;
		str_collection = strings;
		str_collection_length1 = strings_length1;
		for (str_it = 0; str_it < str_collection_length1; str_it = str_it + 1) {
			const gchar* str = NULL;
			str = str_collection[str_it];
			{
				const gchar* _tmp0_;
				GtkRequisition natural_size = {0};
				GtkRequisition _tmp1_ = {0};
				GtkRequisition _tmp2_;
				_tmp0_ = str;
				g_object_set (renderer, "text", _tmp0_, NULL);
				gtk_cell_renderer_get_preferred_size ((GtkCellRenderer*) renderer, treeview, NULL, &_tmp1_);
				natural_size = _tmp1_;
				_tmp2_ = natural_size;
				if (_tmp2_.width > max_width) {
					GtkRequisition _tmp3_;
					_tmp3_ = natural_size;
					max_width = _tmp3_.width;
				}
			}
		}
	}
	gtk_tree_view_column_set_fixed_width (column, max_width + padding);
}

static NoiseMedia*
noise_generic_list_get_media_from_index (NoiseGenericList* self,
                                         gint index)
{
	NoiseMedia* result = NULL;
	NoiseMedia* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = noise_generic_list_get_object_from_index (self, index);
	result = _tmp0_;
	return result;
}

void
noise_generic_list_on_rating_cell_changed (NoiseGenericList* self,
                                           gint new_rating,
                                           GtkWidget* widget,
                                           const gchar* path)
{
	NoiseMedia* m = NULL;
	NoiseMedia* _tmp0_;
	GeeTreeSet* to_update = NULL;
	GeeTreeSet* _tmp1_;
	NoiseViewWrapper* _tmp2_;
	NoiseViewWrapper* _tmp3_;
	NoiseLibrary* _tmp4_;
	NoiseLibrary* _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	g_return_if_fail (path != NULL);
	_tmp0_ = noise_generic_list_get_media_from_index (self, atoi (path));
	m = _tmp0_;
	g_return_if_fail (m != NULL);
	noise_media_set_rating (m, (guint) new_rating);
	_tmp1_ = gee_tree_set_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	to_update = _tmp1_;
	gee_abstract_collection_add ((GeeAbstractCollection*) to_update, m);
	_tmp2_ = noise_generic_list_get_parent_wrapper (self);
	_tmp3_ = _tmp2_;
	_tmp4_ = noise_view_wrapper_get_library (_tmp3_);
	_tmp5_ = _tmp4_;
	noise_library_update_medias (_tmp5_, (GeeCollection*) to_update, TRUE, TRUE);
	_g_object_unref0 (to_update);
	_g_object_unref0 (m);
}

static void
noise_generic_list_on_rows_reordered (NoiseGenericList* self)
{
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	noise_generic_list_scroll_to_current_media (self, FALSE);
	_tmp0_ = self->priv->_is_current_list;
	if (_tmp0_) {
		noise_generic_list_set_as_current_list (self, NULL);
	}
}

static void
noise_generic_list_real_row_activated (GtkTreeView* base,
                                       GtkTreePath* path,
                                       GtkTreeViewColumn* column)
{
	NoiseGenericList * self;
	NoiseMedia* m = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	NoiseMedia* _tmp2_;
	NoiseMedia* _tmp3_;
	NoiseViewWrapperHint _tmp4_;
	NoiseViewWrapperHint _tmp5_;
	NoisePlaybackManager* _tmp11_;
	NoisePlaybackManager* _tmp12_;
	NoiseMedia* _tmp13_;
	NoisePlaybackManager* _tmp14_;
	NoisePlaybackManager* _tmp15_;
	gboolean _tmp16_;
	gboolean _tmp17_;
	self = (NoiseGenericList*) base;
	g_return_if_fail (path != NULL);
	g_return_if_fail (column != NULL);
	_tmp0_ = gtk_tree_path_to_string (path);
	_tmp1_ = _tmp0_;
	_tmp2_ = noise_generic_list_get_media_from_index (self, atoi (_tmp1_));
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	m = _tmp3_;
	_tmp4_ = noise_generic_list_get_hint (self);
	_tmp5_ = _tmp4_;
	if (_tmp5_ == NOISE_VIEW_WRAPPER_HINT_QUEUE) {
		NoisePlaybackManager* _tmp6_;
		NoisePlaybackManager* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		_tmp6_ = noise_app_get_player ();
		_tmp7_ = _tmp6_;
		_tmp8_ = gtk_tree_path_to_string (path);
		_tmp9_ = _tmp8_;
		noise_playback_manager_set_current_index (_tmp7_, atoi (_tmp9_));
		_g_free0 (_tmp9_);
	} else {
		NoiseMedia* _tmp10_;
		_tmp10_ = m;
		noise_generic_list_set_as_current_list (self, _tmp10_);
	}
	_tmp11_ = noise_app_get_player ();
	_tmp12_ = _tmp11_;
	_tmp13_ = m;
	noise_playback_manager_play_media (_tmp12_, _tmp13_);
	_tmp14_ = noise_app_get_player ();
	_tmp15_ = _tmp14_;
	_tmp16_ = noise_playback_manager_get_playing (_tmp15_);
	_tmp17_ = _tmp16_;
	if (!_tmp17_) {
		NoiseLibraryWindow* _tmp18_;
		NoiseLibraryWindow* _tmp19_;
		_tmp18_ = noise_app_get_main_window ();
		_tmp19_ = _tmp18_;
		noise_library_window_play_media (_tmp19_, FALSE);
	}
	_g_object_unref0 (m);
}

static void
noise_generic_list_media_played_data_free (gpointer _data)
{
	NoiseGenericListMediaPlayedData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->m);
	_g_object_unref0 (_data_->self);
	g_slice_free (NoiseGenericListMediaPlayedData, _data_);
}

static void
noise_generic_list_media_played_async_ready_wrapper (GObject *source_object,
                                                     GAsyncResult *res,
                                                     void *user_data)
{
	NoiseGenericListMediaPlayedData* _task_data_;
	_task_data_ = g_task_get_task_data (G_TASK (res));
	if (_task_data_->_callback_ != NULL) {
		_task_data_->_callback_ (source_object, res, user_data);
	}
	_task_data_->_task_complete_ = TRUE;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
noise_generic_list_media_played (NoiseGenericList* self,
                                 NoiseMedia* m,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	NoiseGenericListMediaPlayedData* _data_;
	NoiseGenericList* _tmp0_;
	NoiseMedia* _tmp1_;
	_data_ = g_slice_new0 (NoiseGenericListMediaPlayedData);
	_data_->_callback_ = _callback_;
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, noise_generic_list_media_played_async_ready_wrapper, _user_data_);
	if (_callback_ == NULL) {
		_data_->_task_complete_ = TRUE;
	}
	g_task_set_task_data (_data_->_async_result, _data_, noise_generic_list_media_played_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (m);
	_g_object_unref0 (_data_->m);
	_data_->m = _tmp1_;
	noise_generic_list_media_played_co (_data_);
}

static void
noise_generic_list_media_played_finish (NoiseGenericList* self,
                                        GAsyncResult* _res_)
{
	NoiseGenericListMediaPlayedData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static gboolean
_noise_generic_list_media_played_co_gsource_func (gpointer self)
{
	gboolean result;
	result = noise_generic_list_media_played_co (self);
	return result;
}

static gboolean
noise_generic_list_media_played_co (NoiseGenericListMediaPlayedData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	gtk_widget_queue_draw ((GtkWidget*) _data_->self);
	g_idle_add_full (G_PRIORITY_HIGH_IDLE + 10, _noise_generic_list_media_played_co_gsource_func, _data_, NULL);
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	noise_generic_list_scroll_to_current_media (_data_->self, FALSE);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!_data_->_task_complete_) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

void
noise_generic_list_set_as_current_list (NoiseGenericList* self,
                                        NoiseMedia* m)
{
	NoiseMedia* _tmp0_ = NULL;
	NoiseMedia* to_set = NULL;
	NoiseMedia* _tmp5_;
	NoiseSettingsMain* main_settings = NULL;
	NoiseSettingsMain* _tmp6_;
	NoiseSettingsMain* _tmp7_;
	GeeList* queue = NULL;
	NoiseMedia* _tmp43_;
	GeeBidirList* _tmp44_;
	GeeBidirList* _tmp45_;
	GeeList* _tmp46_;
	GeeList* _tmp47_;
	NoisePlaybackManager* _tmp58_;
	NoisePlaybackManager* _tmp59_;
	NoisePlaybackManager* _tmp60_;
	NoisePlaybackManager* _tmp61_;
	GeeList* _tmp62_;
	NoisePlaybackManager* _tmp63_;
	NoisePlaybackManager* _tmp64_;
	NoiseViewWrapper* view = NULL;
	NoiseLibraryWindow* _tmp65_;
	NoiseLibraryWindow* _tmp66_;
	GeeHashMap* _tmp67_;
	NoisePlaybackManager* _tmp68_;
	NoisePlaybackManager* _tmp69_;
	NoiseStaticPlaylist* _tmp70_;
	gpointer _tmp71_;
	NoiseListView* _tmp72_;
	NoiseListView* _tmp73_;
	NoiseMusicListView* _tmp74_;
	NoiseMusicListView* _tmp75_;
	NoiseTreeViewSetup* _tmp76_;
	NoiseListColumn _tmp77_;
	NoiseListColumn _tmp78_;
	NoiseTreeViewSetup* _tmp79_;
	GtkSortType _tmp80_;
	GtkSortType _tmp81_;
	NoisePlaybackManager* _tmp82_;
	NoisePlaybackManager* _tmp83_;
	NoiseMedia* _tmp84_;
	NoiseMedia* _tmp85_;
	g_return_if_fail (self != NULL);
	if (m == NULL) {
		NoisePlaybackManager* _tmp1_;
		NoisePlaybackManager* _tmp2_;
		NoiseMedia* _tmp3_;
		NoiseMedia* _tmp4_;
		_tmp1_ = noise_app_get_player ();
		_tmp2_ = _tmp1_;
		_tmp3_ = noise_playback_manager_get_current_media (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp0_ = _tmp4_;
	} else {
		_tmp0_ = m;
	}
	_tmp5_ = _g_object_ref0 (_tmp0_);
	to_set = _tmp5_;
	noise_generic_list_set_is_current_list (self, TRUE);
	_tmp6_ = noise_settings_main_get_default ();
	main_settings = _tmp6_;
	_tmp7_ = main_settings;
	if (!noise_settings_main_privacy_mode_enabled (_tmp7_)) {
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_ = FALSE;
		NoisePlaylist* _tmp10_;
		_tmp10_ = self->priv->_playlist;
		if (_tmp10_ == NULL) {
			_tmp9_ = TRUE;
		} else {
			NoisePlaylist* _tmp11_;
			NoiseLibrariesManager* _tmp12_;
			NoiseLibrary* _tmp13_;
			NoiseStaticPlaylist* _tmp14_;
			_tmp11_ = self->priv->_playlist;
			_tmp12_ = noise_libraries_manager;
			_tmp13_ = _tmp12_->local_library;
			_tmp14_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, NOISE_TYPE_LOCAL_LIBRARY, NoiseLocalLibrary)->p_music;
			_tmp9_ = _tmp11_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, NOISE_TYPE_PLAYLIST, NoisePlaylist);
		}
		if (_tmp9_) {
			_tmp8_ = TRUE;
		} else {
			NoiseViewWrapper* _tmp15_;
			NoiseViewWrapper* _tmp16_;
			NoiseLibrary* _tmp17_;
			NoiseLibrary* _tmp18_;
			NoiseLibrariesManager* _tmp19_;
			NoiseLibrary* _tmp20_;
			_tmp15_ = noise_generic_list_get_parent_wrapper (self);
			_tmp16_ = _tmp15_;
			_tmp17_ = noise_view_wrapper_get_library (_tmp16_);
			_tmp18_ = _tmp17_;
			_tmp19_ = noise_libraries_manager;
			_tmp20_ = _tmp19_->local_library;
			_tmp8_ = _tmp18_ != _tmp20_;
		}
		if (_tmp8_) {
			GSettings* _tmp21_;
			GSettings* _tmp22_;
			_tmp21_ = noise_app_get_saved_state ();
			_tmp22_ = _tmp21_;
			g_settings_set_string (_tmp22_, "last-playlist-playing", "");
		} else {
			NoisePlaylist* _tmp23_;
			_tmp23_ = self->priv->_playlist;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp23_, NOISE_TYPE_SMART_PLAYLIST)) {
				GSettings* _tmp24_;
				GSettings* _tmp25_;
				NoisePlaylist* _tmp26_;
				gint64 _tmp27_;
				gint64 _tmp28_;
				gchar* _tmp29_;
				gchar* _tmp30_;
				_tmp24_ = noise_app_get_saved_state ();
				_tmp25_ = _tmp24_;
				_tmp26_ = self->priv->_playlist;
				_tmp27_ = noise_playlist_get_rowid (_tmp26_);
				_tmp28_ = _tmp27_;
				_tmp29_ = g_strdup_printf ("s%lld", _tmp28_);
				_tmp30_ = _tmp29_;
				g_settings_set_string (_tmp25_, "last-playlist-playing", _tmp30_);
				_g_free0 (_tmp30_);
			} else {
				NoisePlaylist* _tmp31_;
				gboolean _tmp32_;
				gboolean _tmp33_;
				_tmp31_ = self->priv->_playlist;
				_tmp32_ = noise_static_playlist_get_read_only (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, NOISE_TYPE_STATIC_PLAYLIST, NoiseStaticPlaylist));
				_tmp33_ = _tmp32_;
				if (_tmp33_ == FALSE) {
					GSettings* _tmp34_;
					GSettings* _tmp35_;
					NoisePlaylist* _tmp36_;
					gint64 _tmp37_;
					gint64 _tmp38_;
					gchar* _tmp39_;
					gchar* _tmp40_;
					_tmp34_ = noise_app_get_saved_state ();
					_tmp35_ = _tmp34_;
					_tmp36_ = self->priv->_playlist;
					_tmp37_ = noise_playlist_get_rowid (_tmp36_);
					_tmp38_ = _tmp37_;
					_tmp39_ = g_strdup_printf ("p%lld", _tmp38_);
					_tmp40_ = _tmp39_;
					g_settings_set_string (_tmp35_, "last-playlist-playing", _tmp40_);
					_g_free0 (_tmp40_);
				} else {
					GSettings* _tmp41_;
					GSettings* _tmp42_;
					_tmp41_ = noise_app_get_saved_state ();
					_tmp42_ = _tmp41_;
					g_settings_set_string (_tmp42_, "last-playlist-playing", "");
				}
			}
		}
	}
	_tmp43_ = to_set;
	_tmp44_ = noise_generic_list_get_visible_table (self);
	_tmp45_ = _tmp44_;
	_tmp46_ = noise_generic_list_start_at (self, _tmp43_, (GeeList*) _tmp45_);
	_tmp47_ = _tmp46_;
	_g_object_unref0 (_tmp45_);
	queue = _tmp47_;
	{
		GeeList* _q_list = NULL;
		GeeList* _tmp48_;
		GeeList* _tmp49_;
		gint _q_size = 0;
		GeeList* _tmp50_;
		gint _tmp51_;
		gint _tmp52_;
		gint _q_index = 0;
		_tmp48_ = queue;
		_tmp49_ = _g_object_ref0 (_tmp48_);
		_q_list = _tmp49_;
		_tmp50_ = _q_list;
		_tmp51_ = gee_collection_get_size ((GeeCollection*) _tmp50_);
		_tmp52_ = _tmp51_;
		_q_size = _tmp52_;
		_q_index = -1;
		while (TRUE) {
			NoiseMedia* q = NULL;
			GeeList* _tmp53_;
			gpointer _tmp54_;
			NoiseMedia* _tmp55_;
			const gchar* _tmp56_;
			const gchar* _tmp57_;
			_q_index = _q_index + 1;
			if (!(_q_index < _q_size)) {
				break;
			}
			_tmp53_ = _q_list;
			_tmp54_ = gee_list_get (_tmp53_, _q_index);
			q = (NoiseMedia*) _tmp54_;
			_tmp55_ = q;
			_tmp56_ = noise_media_get_title (_tmp55_);
			_tmp57_ = _tmp56_;
			g_debug ("GenericList.vala:259: QUEING: %s", _tmp57_);
			_g_object_unref0 (q);
		}
		_g_object_unref0 (_q_list);
	}
	_tmp58_ = noise_app_get_player ();
	_tmp59_ = _tmp58_;
	noise_playback_manager_clear_queue (_tmp59_);
	_tmp60_ = noise_app_get_player ();
	_tmp61_ = _tmp60_;
	_tmp62_ = queue;
	noise_playback_manager_queue_media (_tmp61_, (GeeCollection*) _tmp62_);
	_tmp63_ = noise_app_get_player ();
	_tmp64_ = _tmp63_;
	noise_playback_manager_set_current_index (_tmp64_, 0);
	_tmp65_ = noise_app_get_main_window ();
	_tmp66_ = _tmp65_;
	_tmp67_ = _tmp66_->match_playlists;
	_tmp68_ = noise_app_get_player ();
	_tmp69_ = _tmp68_;
	_tmp70_ = _tmp69_->queue_playlist;
	_tmp71_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp67_, (NoisePlaylist*) _tmp70_);
	view = (NoiseViewWrapper*) _tmp71_;
	_tmp72_ = noise_view_wrapper_get_list_view (view);
	_tmp73_ = _tmp72_;
	_tmp74_ = noise_list_view_get_list_view (_tmp73_);
	_tmp75_ = _tmp74_;
	_tmp76_ = self->priv->_tvs;
	_tmp77_ = noise_tree_view_setup_get_sort_column_id (_tmp76_);
	_tmp78_ = _tmp77_;
	_tmp79_ = self->priv->_tvs;
	_tmp80_ = noise_tree_view_setup_get_sort_direction (_tmp79_);
	_tmp81_ = _tmp80_;
	noise_generic_list_set_sort_column_id ((NoiseGenericList*) _tmp75_, (gint) _tmp78_, _tmp81_);
	_tmp82_ = noise_app_get_player ();
	_tmp83_ = _tmp82_;
	_tmp84_ = noise_playback_manager_get_current_media (_tmp83_);
	_tmp85_ = _tmp84_;
	noise_generic_list_media_played (self, _tmp85_, NULL, NULL);
	_g_object_unref0 (view);
	_g_object_unref0 (queue);
	_g_object_unref0 (main_settings);
	_g_object_unref0 (to_set);
}

/**
    * Shift a list (of media) to make it start at a given element
    */
static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static GeeList*
noise_generic_list_start_at (NoiseGenericList* self,
                             NoiseMedia* start,
                             GeeList* media)
{
	GeeList* result = NULL;
	gint index = 0;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	GeeArrayList* res = NULL;
	GeeArrayList* _tmp26_;
	GeeArrayList* _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	GeeList* _tmp30_;
	GeeList* _tmp31_;
	GeeArrayList* _tmp32_;
	GeeList* _tmp33_;
	GeeList* _tmp34_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (start != NULL, NULL);
	g_return_val_if_fail (media != NULL, NULL);
	index = 0;
	{
		gboolean _tmp0_ = FALSE;
		_tmp0_ = TRUE;
		while (TRUE) {
			gboolean _tmp1_ = FALSE;
			gint _tmp2_;
			gint _tmp3_;
			if (!_tmp0_) {
				index = index + 1;
			}
			_tmp0_ = FALSE;
			_tmp2_ = gee_collection_get_size ((GeeCollection*) media);
			_tmp3_ = _tmp2_;
			if (index < _tmp3_) {
				gpointer _tmp4_;
				NoiseMedia* _tmp5_;
				gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				_tmp4_ = gee_list_get (media, index);
				_tmp5_ = (NoiseMedia*) _tmp4_;
				_tmp6_ = noise_media_get_uri (_tmp5_);
				_tmp7_ = _tmp6_;
				_tmp8_ = _tmp7_;
				_tmp9_ = noise_media_get_uri (start);
				_tmp10_ = _tmp9_;
				_tmp11_ = _tmp10_;
				_tmp1_ = g_strcmp0 (_tmp8_, _tmp11_) != 0;
				_g_free0 (_tmp11_);
				_g_free0 (_tmp8_);
				_g_object_unref0 (_tmp5_);
			} else {
				_tmp1_ = FALSE;
			}
			if (!_tmp1_) {
				break;
			}
		}
	}
	_tmp12_ = noise_media_get_title (start);
	_tmp13_ = _tmp12_;
	_tmp14_ = string_to_string (_tmp13_);
	_tmp15_ = gee_collection_get_size ((GeeCollection*) media);
	_tmp16_ = _tmp15_;
	_tmp17_ = g_strdup_printf ("%i", _tmp16_);
	_tmp18_ = _tmp17_;
	_tmp19_ = g_strdup_printf ("%i", index);
	_tmp20_ = _tmp19_;
	_tmp21_ = g_strconcat ("TO START: '", _tmp14_, "', size = ", _tmp18_, ", index: ", _tmp20_, NULL);
	_tmp22_ = _tmp21_;
	g_debug ("GenericList.vala:278: %s", _tmp22_);
	_g_free0 (_tmp22_);
	_g_free0 (_tmp20_);
	_g_free0 (_tmp18_);
	_tmp23_ = gee_collection_get_size ((GeeCollection*) media);
	_tmp24_ = _tmp23_;
	if (index == _tmp24_) {
		GeeList* _tmp25_;
		_tmp25_ = _g_object_ref0 (media);
		result = _tmp25_;
		return result;
	}
	_tmp26_ = gee_array_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	res = _tmp26_;
	_tmp27_ = res;
	_tmp28_ = gee_collection_get_size ((GeeCollection*) media);
	_tmp29_ = _tmp28_;
	_tmp30_ = gee_list_slice (media, index, _tmp29_);
	_tmp31_ = _tmp30_;
	gee_array_list_add_all (_tmp27_, (GeeCollection*) _tmp31_);
	_g_object_unref0 (_tmp31_);
	_tmp32_ = res;
	_tmp33_ = gee_list_slice (media, 0, index);
	_tmp34_ = _tmp33_;
	gee_array_list_add_all (_tmp32_, (GeeCollection*) _tmp34_);
	_g_object_unref0 (_tmp34_);
	result = (GeeList*) res;
	return result;
}

static GtkTreePath*
_vala_GtkTreePath_copy (GtkTreePath* self)
{
	return g_boxed_copy (gtk_tree_path_get_type (), self);
}

static gpointer
__vala_GtkTreePath_copy0 (gpointer self)
{
	return self ? _vala_GtkTreePath_copy (self) : NULL;
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
	g_boxed_free (gtk_tree_path_get_type (), self);
}

static void
__vala_GtkTreePath_free0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL));
}

static inline void
_g_list_free___vala_GtkTreePath_free0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) __vala_GtkTreePath_free0_);
}

GeeCollection*
noise_generic_list_get_selected_medias (NoiseGenericList* self)
{
	GeeCollection* result = NULL;
	GeeArrayQueue* rv = NULL;
	GeeArrayQueue* _tmp0_;
	GtkTreeModel* temp = NULL;
	GtkTreeSelection* _tmp1_;
	GtkTreeModel* _tmp2_ = NULL;
	GList* _tmp3_;
	GtkTreeModel* _tmp4_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gee_array_queue_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	rv = _tmp0_;
	_tmp1_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
	_tmp3_ = gtk_tree_selection_get_selected_rows (_tmp1_, &_tmp2_);
	_g_object_unref0 (temp);
	_tmp4_ = _g_object_ref0 (_tmp2_);
	temp = _tmp4_;
	{
		GList* path_collection = NULL;
		GList* path_it = NULL;
		path_collection = _tmp3_;
		for (path_it = path_collection; path_it != NULL; path_it = path_it->next) {
			GtkTreePath* _tmp5_;
			GtkTreePath* path = NULL;
			_tmp5_ = __vala_GtkTreePath_copy0 ((GtkTreePath*) path_it->data);
			path = _tmp5_;
			{
				NoiseMedia* m = NULL;
				GtkTreePath* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				NoiseMedia* _tmp9_;
				NoiseMedia* _tmp10_;
				GeeArrayQueue* _tmp11_;
				NoiseMedia* _tmp12_;
				_tmp6_ = path;
				_tmp7_ = gtk_tree_path_to_string (_tmp6_);
				_tmp8_ = _tmp7_;
				_tmp9_ = noise_generic_list_get_media_from_index (self, atoi (_tmp8_));
				_tmp10_ = _tmp9_;
				_g_free0 (_tmp8_);
				m = _tmp10_;
				_tmp11_ = rv;
				_tmp12_ = m;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, _tmp12_);
				_g_object_unref0 (m);
				__vala_GtkTreePath_free0 (path);
			}
		}
		(path_collection == NULL) ? NULL : (path_collection = (_g_list_free___vala_GtkTreePath_free0_ (path_collection), NULL));
	}
	result = (GeeCollection*) rv;
	_g_object_unref0 (temp);
	return result;
}

void
noise_generic_list_scroll_to_current_media (NoiseGenericList* self,
                                            gboolean unfilter_if_not_found)
{
	NoisePlaybackManager* _tmp0_;
	NoisePlaybackManager* _tmp1_;
	NoiseMedia* _tmp2_;
	NoiseMedia* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = noise_app_get_player ();
	_tmp1_ = _tmp0_;
	_tmp2_ = noise_playback_manager_get_current_media (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ == NULL) {
		return;
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				GeeBidirList* _tmp5_;
				GeeBidirList* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
				gboolean _tmp9_;
				NoiseMedia* m = NULL;
				NoiseMedia* _tmp10_;
				NoiseMedia* _tmp11_;
				NoisePlaybackManager* _tmp12_;
				NoisePlaybackManager* _tmp13_;
				NoiseMedia* _tmp14_;
				NoiseMedia* _tmp15_;
				if (!_tmp4_) {
					i = i + 1;
				}
				_tmp4_ = FALSE;
				_tmp5_ = noise_generic_list_get_visible_table (self);
				_tmp6_ = _tmp5_;
				_tmp7_ = gee_collection_get_size ((GeeCollection*) _tmp6_);
				_tmp8_ = _tmp7_;
				_tmp9_ = !(i < _tmp8_);
				_g_object_unref0 (_tmp6_);
				if (_tmp9_) {
					break;
				}
				_tmp10_ = noise_generic_list_get_media_from_index (self, i);
				m = _tmp10_;
				_tmp11_ = m;
				_tmp12_ = noise_app_get_player ();
				_tmp13_ = _tmp12_;
				_tmp14_ = noise_playback_manager_get_current_media (_tmp13_);
				_tmp15_ = _tmp14_;
				if (_tmp11_ == _tmp15_) {
					GtkTreePath* path = NULL;
					GtkTreePath* _tmp16_;
					gboolean center_cell = FALSE;
					GtkTreePath* start_path = NULL;
					GtkTreePath* end_path = NULL;
					GtkTreePath* _tmp17_ = NULL;
					GtkTreePath* _tmp18_ = NULL;
					gboolean _tmp19_;
					GtkTreePath* _tmp29_;
					GtkTreeViewColumn* column = NULL;
					GtkTreeViewColumn* _tmp30_;
					GtkTreeViewColumn* _tmp31_;
					GtkTreePath* _tmp32_;
					GtkTreeViewColumn* _tmp33_;
					GtkTreeViewColumn* _tmp34_;
					GList* _tmp35_;
					GList* _tmp36_;
					gconstpointer _tmp37_;
					_tmp16_ = gtk_tree_path_new_from_indices (i, -1, -1);
					path = _tmp16_;
					center_cell = FALSE;
					_tmp19_ = gtk_tree_view_get_visible_range ((GtkTreeView*) self, &_tmp17_, &_tmp18_);
					__vala_GtkTreePath_free0 (start_path);
					start_path = _tmp17_;
					__vala_GtkTreePath_free0 (end_path);
					end_path = _tmp18_;
					if (_tmp19_) {
						gint start_index = 0;
						GtkTreePath* _tmp20_;
						gint _tmp21_ = 0;
						gint* _tmp22_;
						gint _tmp23_;
						gint end_index = 0;
						GtkTreePath* _tmp24_;
						gint _tmp25_ = 0;
						gint* _tmp26_;
						gint _tmp27_;
						gboolean _tmp28_ = FALSE;
						_tmp20_ = start_path;
						_tmp22_ = gtk_tree_path_get_indices_with_depth (_tmp20_, &_tmp21_);
						_tmp23_ = _tmp22_[0];
						start_index = _tmp23_;
						_tmp24_ = end_path;
						_tmp26_ = gtk_tree_path_get_indices_with_depth (_tmp24_, &_tmp25_);
						_tmp27_ = _tmp26_[0];
						end_index = _tmp27_;
						if (i < (start_index - 1)) {
							_tmp28_ = TRUE;
						} else {
							_tmp28_ = i > (end_index + 1);
						}
						if (_tmp28_) {
							center_cell = TRUE;
						}
					}
					_tmp29_ = path;
					gtk_tree_view_scroll_to_cell ((GtkTreeView*) self, _tmp29_, NULL, center_cell, 0.5f, (gfloat) 0);
					_tmp30_ = gtk_tree_view_get_column ((GtkTreeView*) self, 0);
					_tmp31_ = _g_object_ref0 (_tmp30_);
					column = _tmp31_;
					_tmp32_ = path;
					_tmp33_ = column;
					_tmp34_ = column;
					_tmp35_ = gtk_cell_layout_get_cells ((GtkCellLayout*) _tmp34_);
					_tmp36_ = _tmp35_;
					_tmp37_ = g_list_nth_data (_tmp36_, (guint) 0);
					gtk_tree_view_set_cursor_on_cell ((GtkTreeView*) self, _tmp32_, _tmp33_, (GtkCellRenderer*) _tmp37_, FALSE);
					(_tmp36_ == NULL) ? NULL : (_tmp36_ = (g_list_free (_tmp36_), NULL));
					_g_object_unref0 (column);
					__vala_GtkTreePath_free0 (end_path);
					__vala_GtkTreePath_free0 (start_path);
					__vala_GtkTreePath_free0 (path);
					_g_object_unref0 (m);
					break;
				}
				_g_object_unref0 (m);
			}
		}
	}
}

/** Should not be manipulated by client */
GeeBidirList*
noise_generic_list_get_table (NoiseGenericList* self)
{
	GeeBidirList* result = NULL;
	GeeArrayList* _tmp0_;
	GeeBidirList* _tmp1_;
	GeeBidirList* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->table;
	_tmp1_ = gee_abstract_bidir_list_get_read_only_view ((GeeAbstractBidirList*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

/** Should not be manipulated by client */
GeeBidirList*
noise_generic_list_get_visible_table (NoiseGenericList* self)
{
	GeeBidirList* result = NULL;
	GeeArrayList* _tmp0_;
	GeeBidirList* _tmp1_;
	GeeBidirList* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->showing;
	_tmp1_ = gee_abstract_bidir_list_get_read_only_view ((GeeAbstractBidirList*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

gint
noise_generic_list_get_index_from_iter (GtkTreeIter* iter)
{
	gint result = 0;
	GtkTreeIter _tmp0_;
	void* _tmp1_;
	g_return_val_if_fail (iter != NULL, 0);
	_tmp0_ = *iter;
	_tmp1_ = _tmp0_.user_data;
	result = (gint) _tmp1_;
	return result;
}

NoiseMedia*
noise_generic_list_get_object_from_index (NoiseGenericList* self,
                                          gint index)
{
	NoiseMedia* result = NULL;
	NoiseMedia* _tmp0_ = NULL;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = self->showing;
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
	_tmp3_ = _tmp2_;
	if (index < _tmp3_) {
		GeeArrayList* _tmp4_;
		gpointer _tmp5_;
		_tmp4_ = self->showing;
		_tmp5_ = gee_abstract_list_get ((GeeAbstractList*) _tmp4_, index);
		_g_object_unref0 (_tmp0_);
		_tmp0_ = (NoiseMedia*) _tmp5_;
	} else {
		_g_object_unref0 (_tmp0_);
		_tmp0_ = NULL;
	}
	result = _tmp0_;
	return result;
}

void
noise_generic_list_set_value_func (NoiseGenericList* self,
                                   NoiseFastModelValueReturnFunc func,
                                   gpointer func_target)
{
	NoiseFastModel* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->fm;
	noise_fast_model_set_value_func (_tmp0_, func, func_target);
}

void
noise_generic_list_set_table (NoiseGenericList* self,
                              GeeArrayList* table,
                              gboolean do_resort)
{
	GeeArrayList* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (table != NULL);
	_tmp0_ = _g_object_ref0 (table);
	_g_object_unref0 (self->table);
	self->table = _tmp0_;
	if (do_resort) {
		noise_generic_list_resort (self);
	} else {
		noise_generic_list_do_search (self, NULL);
	}
}

void
noise_generic_list_set_search_func (NoiseGenericList* self,
                                    NoiseGenericListViewSearchFunc func,
                                    gpointer func_target)
{
	g_return_if_fail (self != NULL);
	self->priv->search_func = func;
	self->priv->search_func_target = func_target;
}

void
noise_generic_list_do_search (NoiseGenericList* self,
                              const gchar* search)
{
	gboolean _tmp0_ = FALSE;
	NoiseGenericListViewSearchFunc _tmp1_;
	gpointer _tmp1__target;
	gint old_size = 0;
	GeeArrayList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GeeArrayList* _tmp6_;
	const gchar* _tmp7_ = NULL;
	NoiseGenericListViewSearchFunc _tmp8_;
	gpointer _tmp8__target;
	GeeArrayList* _tmp9_;
	GeeArrayList* _tmp10_;
	GeeArrayList* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->search_func;
	_tmp1__target = self->priv->search_func_target;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp2_;
		_tmp2_ = self->priv->_research_needed;
		_tmp0_ = _tmp2_ == FALSE;
	}
	if (_tmp0_) {
		return;
	}
	noise_generic_list_set_research_needed (self, FALSE);
	_tmp3_ = self->showing;
	_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
	_tmp5_ = _tmp4_;
	old_size = _tmp5_;
	_tmp6_ = self->showing;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp6_);
	_tmp7_ = search;
	if (_tmp7_ == NULL) {
		_tmp7_ = "";
	}
	_tmp8_ = self->priv->search_func;
	_tmp8__target = self->priv->search_func_target;
	_tmp9_ = self->table;
	_tmp10_ = self->showing;
	_tmp8_ (_tmp7_, _tmp9_, _tmp10_, _tmp8__target);
	_tmp11_ = self->showing;
	_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
	_tmp13_ = _tmp12_;
	if (_tmp13_ == old_size) {
		NoiseFastModel* _tmp14_;
		GeeArrayList* _tmp15_;
		_tmp14_ = self->fm;
		_tmp15_ = self->showing;
		noise_fast_model_set_table (_tmp14_, _tmp15_);
		gtk_widget_queue_draw ((GtkWidget*) self);
	} else {
		if (old_size == 0) {
			NoiseFastModel* _tmp16_;
			GeeArrayList* _tmp17_;
			NoiseFastModel* _tmp18_;
			gtk_tree_view_set_model ((GtkTreeView*) self, NULL);
			_tmp16_ = self->fm;
			_tmp17_ = self->showing;
			noise_fast_model_set_table (_tmp16_, _tmp17_);
			_tmp18_ = self->fm;
			gtk_tree_view_set_model ((GtkTreeView*) self, (GtkTreeModel*) _tmp18_);
		} else {
			GeeArrayList* _tmp19_;
			gint _tmp20_;
			gint _tmp21_;
			_tmp19_ = self->showing;
			_tmp20_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp19_);
			_tmp21_ = _tmp20_;
			if (old_size > _tmp21_) {
				NoiseFastModel* _tmp31_;
				GeeArrayList* _tmp32_;
				while (TRUE) {
					NoiseFastModel* _tmp22_;
					GeeArrayList* _tmp23_;
					gint _tmp24_;
					gint _tmp25_;
					GtkTreeIter iter = {0};
					NoiseFastModel* _tmp26_;
					NoiseFastModel* _tmp27_;
					GtkTreeIter _tmp28_ = {0};
					NoiseFastModel* _tmp29_;
					GtkTreeIter _tmp30_;
					_tmp22_ = self->fm;
					_tmp23_ = self->showing;
					_tmp24_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp23_);
					_tmp25_ = _tmp24_;
					if (!(gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp22_, NULL) > _tmp25_)) {
						break;
					}
					_tmp26_ = self->fm;
					_tmp27_ = self->fm;
					gtk_tree_model_iter_nth_child ((GtkTreeModel*) _tmp26_, &_tmp28_, NULL, gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp27_, NULL) - 1);
					iter = _tmp28_;
					_tmp29_ = self->fm;
					_tmp30_ = iter;
					noise_fast_model_remove (_tmp29_, &_tmp30_);
				}
				_tmp31_ = self->fm;
				_tmp32_ = self->showing;
				noise_fast_model_set_table (_tmp31_, _tmp32_);
				gtk_widget_queue_draw ((GtkWidget*) self);
			} else {
				GeeArrayList* _tmp33_;
				gint _tmp34_;
				gint _tmp35_;
				_tmp33_ = self->showing;
				_tmp34_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp33_);
				_tmp35_ = _tmp34_;
				if (_tmp35_ > old_size) {
					GtkTreeIter iter = {0};
					NoiseFastModel* _tmp42_;
					GeeArrayList* _tmp43_;
					while (TRUE) {
						NoiseFastModel* _tmp36_;
						GeeArrayList* _tmp37_;
						gint _tmp38_;
						gint _tmp39_;
						NoiseFastModel* _tmp40_;
						GtkTreeIter _tmp41_ = {0};
						_tmp36_ = self->fm;
						_tmp37_ = self->showing;
						_tmp38_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp37_);
						_tmp39_ = _tmp38_;
						if (!(gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp36_, NULL) < _tmp39_)) {
							break;
						}
						_tmp40_ = self->fm;
						noise_fast_model_append (_tmp40_, &_tmp41_);
						iter = _tmp41_;
					}
					_tmp42_ = self->fm;
					_tmp43_ = self->showing;
					noise_fast_model_set_table (_tmp42_, _tmp43_);
					gtk_widget_queue_draw ((GtkWidget*) self);
				}
			}
		}
	}
}

void
noise_generic_list_set_sort_column_id (NoiseGenericList* self,
                                       gint sort_column_id,
                                       GtkSortType order)
{
	NoiseFastModel* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->fm;
	gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) _tmp0_, sort_column_id, order);
}

static void
noise_generic_list_reorder_requested (NoiseGenericList* self,
                                      gint column,
                                      GtkSortType direction)
{
	gboolean _tmp0_ = FALSE;
	GeeArrayList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	g_return_if_fail (self != NULL);
	if (column == self->sort_column_id) {
		GtkSortType _tmp1_;
		_tmp1_ = self->sort_direction;
		_tmp0_ = direction == _tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		return;
	}
	self->sort_column_id = column;
	self->sort_direction = direction;
	_tmp2_ = self->table;
	_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
	_tmp4_ = _tmp3_;
	noise_generic_list_quicksort (self, 0, _tmp4_ - 1);
	noise_generic_list_set_research_needed (self, TRUE);
	noise_generic_list_do_search (self, NULL);
	g_signal_emit (self, noise_generic_list_signals[NOISE_GENERIC_LIST_ROWS_REORDERED_SIGNAL], 0);
}

void
noise_generic_list_resort (NoiseGenericList* self)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->table;
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	noise_generic_list_quicksort (self, 0, _tmp2_ - 1);
	noise_generic_list_set_research_needed (self, TRUE);
	noise_generic_list_do_search (self, NULL);
}

void
noise_generic_list_set_compare_func (NoiseGenericList* self,
                                     NoiseGenericListSortCompareFunc func,
                                     gpointer func_target)
{
	g_return_if_fail (self != NULL);
	self->priv->compare_func = func;
	self->priv->compare_func_target = func_target;
}

static void
noise_generic_list_swap (NoiseGenericList* self,
                         gint a,
                         gint b)
{
	NoiseMedia* temp = NULL;
	GeeArrayList* _tmp0_;
	gpointer _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	gpointer _tmp4_;
	NoiseMedia* _tmp5_;
	GeeArrayList* _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->table;
	_tmp1_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, a);
	temp = (NoiseMedia*) _tmp1_;
	_tmp2_ = self->table;
	_tmp3_ = self->table;
	_tmp4_ = gee_abstract_list_get ((GeeAbstractList*) _tmp3_, b);
	_tmp5_ = (NoiseMedia*) _tmp4_;
	gee_abstract_list_set ((GeeAbstractList*) _tmp2_, a, _tmp5_);
	_g_object_unref0 (_tmp5_);
	_tmp6_ = self->table;
	gee_abstract_list_set ((GeeAbstractList*) _tmp6_, b, temp);
	_g_object_unref0 (temp);
}

static void
noise_generic_list_quicksort (NoiseGenericList* self,
                              gint start,
                              gint end)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint pivot_index = 0;
	NoiseMedia* pivot = NULL;
	GeeArrayList* _tmp3_;
	gpointer _tmp4_;
	gint i = 0;
	gint j = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->table;
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == 0) {
		return;
	}
	pivot_index = (start + end) / 2;
	_tmp3_ = self->table;
	_tmp4_ = gee_abstract_list_get ((GeeAbstractList*) _tmp3_, pivot_index);
	pivot = (NoiseMedia*) _tmp4_;
	i = start;
	j = end;
	while (TRUE) {
		if (!(i <= j)) {
			break;
		}
		while (TRUE) {
			gboolean _tmp5_ = FALSE;
			if (i < end) {
				NoiseGenericListSortCompareFunc _tmp6_;
				gpointer _tmp6__target;
				GtkSortType _tmp7_;
				GeeArrayList* _tmp8_;
				gpointer _tmp9_;
				NoiseMedia* _tmp10_;
				NoiseMedia* _tmp11_;
				_tmp6_ = self->priv->compare_func;
				_tmp6__target = self->priv->compare_func_target;
				_tmp7_ = self->sort_direction;
				_tmp8_ = self->table;
				_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, i);
				_tmp10_ = (NoiseMedia*) _tmp9_;
				_tmp11_ = pivot;
				_tmp5_ = _tmp6_ (self->sort_column_id, _tmp7_, _tmp10_, _tmp11_, i, pivot_index, _tmp6__target) < 0;
				_g_object_unref0 (_tmp10_);
			} else {
				_tmp5_ = FALSE;
			}
			if (!_tmp5_) {
				break;
			}
			i = i + 1;
		}
		while (TRUE) {
			gboolean _tmp12_ = FALSE;
			if (j > start) {
				NoiseGenericListSortCompareFunc _tmp13_;
				gpointer _tmp13__target;
				GtkSortType _tmp14_;
				GeeArrayList* _tmp15_;
				gpointer _tmp16_;
				NoiseMedia* _tmp17_;
				NoiseMedia* _tmp18_;
				_tmp13_ = self->priv->compare_func;
				_tmp13__target = self->priv->compare_func_target;
				_tmp14_ = self->sort_direction;
				_tmp15_ = self->table;
				_tmp16_ = gee_abstract_list_get ((GeeAbstractList*) _tmp15_, j);
				_tmp17_ = (NoiseMedia*) _tmp16_;
				_tmp18_ = pivot;
				_tmp12_ = _tmp13_ (self->sort_column_id, _tmp14_, _tmp17_, _tmp18_, j, pivot_index, _tmp13__target) > 0;
				_g_object_unref0 (_tmp17_);
			} else {
				_tmp12_ = FALSE;
			}
			if (!_tmp12_) {
				break;
			}
			j = j - 1;
		}
		if (i <= j) {
			noise_generic_list_swap (self, i, j);
			i = i + 1;
			j = j - 1;
		}
	}
	if (start < j) {
		noise_generic_list_quicksort (self, start, j);
	}
	if (i < end) {
		noise_generic_list_quicksort (self, i, end);
	}
	_g_object_unref0 (pivot);
}

/** **********************************************************
     * Drag and drop support. GenericList is a source for media and can
     * be dragged to a playlist in the sidebar. No support for reordering
     * is implemented yet.
    ***************************************************************/
static void
noise_generic_list_on_drag_begin (NoiseGenericList* self,
                                  GtkWidget* sender,
                                  GdkDragContext* context)
{
	gint selected_rows = 0;
	GtkTreeSelection* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (sender != NULL);
	g_return_if_fail (context != NULL);
	self->dragging = TRUE;
	g_debug ("GenericList.vala:492: drag begin");
	gdk_drag_abort (context, gtk_get_current_event_time ());
	_tmp0_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
	selected_rows = gtk_tree_selection_count_selected_rows (_tmp0_);
	if (selected_rows > 0) {
		gtk_drag_source_set_icon_name ((GtkWidget*) self, "audio-x-generic");
	}
}

static void
_vala_array_add13 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
noise_generic_list_on_drag_data_get (NoiseGenericList* self,
                                     GdkDragContext* context,
                                     GtkSelectionData* selection_data,
                                     guint info,
                                     guint time_)
{
	gchar** uris = NULL;
	gint uris_length1;
	gint _uris_size_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	g_return_if_fail (selection_data != NULL);
	uris = NULL;
	uris_length1 = 0;
	_uris_size_ = uris_length1;
	{
		GeeIterator* _m_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
		_tmp0_ = noise_generic_list_get_selected_medias (self);
		_tmp1_ = _tmp0_;
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
		_tmp3_ = _tmp2_;
		_g_object_unref0 (_tmp1_);
		_m_it = _tmp3_;
		while (TRUE) {
			GeeIterator* _tmp4_;
			NoiseMedia* m = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			gchar** _tmp7_;
			gint _tmp7__length1;
			NoiseMedia* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			_tmp4_ = _m_it;
			if (!gee_iterator_next (_tmp4_)) {
				break;
			}
			_tmp5_ = _m_it;
			_tmp6_ = gee_iterator_get (_tmp5_);
			m = (NoiseMedia*) _tmp6_;
			_tmp7_ = uris;
			_tmp7__length1 = uris_length1;
			_tmp8_ = m;
			_tmp9_ = noise_media_get_uri (_tmp8_);
			_tmp10_ = _tmp9_;
			_vala_array_add13 (&uris, &uris_length1, &_uris_size_, _tmp10_);
			_g_object_unref0 (m);
		}
		_g_object_unref0 (_m_it);
	}
	_tmp11_ = uris;
	_tmp11__length1 = uris_length1;
	if (_tmp11_ != NULL) {
		gchar** _tmp12_;
		gint _tmp12__length1;
		_tmp12_ = uris;
		_tmp12__length1 = uris_length1;
		gtk_selection_data_set_uris (selection_data, _tmp12_);
	}
	uris = (_vala_array_free (uris, uris_length1, (GDestroyNotify) g_free), NULL);
}

static void
noise_generic_list_on_drag_end (NoiseGenericList* self,
                                GtkWidget* sender,
                                GdkDragContext* context)
{
	GtkTargetEntry* _tmp0_;
	GtkTargetEntry* _tmp1_;
	gint _tmp1__length1;
	g_return_if_fail (self != NULL);
	g_return_if_fail (sender != NULL);
	g_return_if_fail (context != NULL);
	self->dragging = FALSE;
	g_debug ("GenericList.vala:515: drag end\n");
	_tmp0_ = g_new0 (GtkTargetEntry, 0);
	_tmp1_ = _tmp0_;
	_tmp1__length1 = 0;
	gtk_drag_dest_set ((GtkWidget*) self, GTK_DEST_DEFAULT_ALL, _tmp1_, (gint) 0, GDK_ACTION_COPY | GDK_ACTION_MOVE);
	_tmp1_ = (g_free (_tmp1_), NULL);
}

GeeList*
noise_generic_list_get_columns (NoiseGenericList* self)
{
	GeeList* result;
	GeeList* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_columns;
	result = _tmp0_;
	return result;
}

void
noise_generic_list_set_columns (NoiseGenericList* self,
                                GeeList* value)
{
	g_return_if_fail (self != NULL);
	if (noise_generic_list_get_columns (self) != value) {
		GeeList* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_columns);
		self->priv->_columns = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_generic_list_properties[NOISE_GENERIC_LIST_COLUMNS_PROPERTY]);
	}
}

gboolean
noise_generic_list_get_research_needed (NoiseGenericList* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_research_needed;
	return result;
}

void
noise_generic_list_set_research_needed (NoiseGenericList* self,
                                        gboolean value)
{
	g_return_if_fail (self != NULL);
	if (noise_generic_list_get_research_needed (self) != value) {
		self->priv->_research_needed = value;
		g_object_notify_by_pspec ((GObject *) self, noise_generic_list_properties[NOISE_GENERIC_LIST_RESEARCH_NEEDED_PROPERTY]);
	}
}

gboolean
noise_generic_list_get_is_current_list (NoiseGenericList* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_current_list;
	return result;
}

static void
noise_generic_list_set_is_current_list (NoiseGenericList* self,
                                        gboolean value)
{
	g_return_if_fail (self != NULL);
	if (noise_generic_list_get_is_current_list (self) != value) {
		self->priv->_is_current_list = value;
		g_object_notify_by_pspec ((GObject *) self, noise_generic_list_properties[NOISE_GENERIC_LIST_IS_CURRENT_LIST_PROPERTY]);
	}
}

NoisePlaylist*
noise_generic_list_get_playlist (NoiseGenericList* self)
{
	NoisePlaylist* result;
	NoisePlaylist* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_playlist;
	result = _tmp0_;
	return result;
}

void
noise_generic_list_set_playlist (NoiseGenericList* self,
                                 NoisePlaylist* value)
{
	g_return_if_fail (self != NULL);
	if (noise_generic_list_get_playlist (self) != value) {
		NoisePlaylist* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_playlist);
		self->priv->_playlist = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_generic_list_properties[NOISE_GENERIC_LIST_PLAYLIST_PROPERTY]);
	}
}

NoiseTreeViewSetup*
noise_generic_list_get_tvs (NoiseGenericList* self)
{
	NoiseTreeViewSetup* result;
	NoiseTreeViewSetup* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_tvs;
	result = _tmp0_;
	return result;
}

void
noise_generic_list_set_tvs (NoiseGenericList* self,
                            NoiseTreeViewSetup* value)
{
	g_return_if_fail (self != NULL);
	if (noise_generic_list_get_tvs (self) != value) {
		NoiseTreeViewSetup* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_tvs);
		self->priv->_tvs = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, noise_generic_list_properties[NOISE_GENERIC_LIST_TVS_PROPERTY]);
	}
}

NoiseViewWrapperHint
noise_generic_list_get_hint (NoiseGenericList* self)
{
	NoiseViewWrapperHint result;
	NoiseTreeViewSetup* _tmp0_;
	NoiseViewWrapperHint _tmp1_;
	NoiseViewWrapperHint _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_tvs;
	_tmp1_ = noise_tree_view_setup_get_hint (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

void
noise_generic_list_set_hint (NoiseGenericList* self,
                             NoiseViewWrapperHint value)
{
	NoiseTreeViewSetup* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_tvs;
	noise_tree_view_setup_set_hint (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, noise_generic_list_properties[NOISE_GENERIC_LIST_HINT_PROPERTY]);
}

NoiseViewWrapper*
noise_generic_list_get_parent_wrapper (NoiseGenericList* self)
{
	NoiseViewWrapper* result;
	NoiseViewWrapper* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_parent_wrapper;
	result = _tmp0_;
	return result;
}

void
noise_generic_list_set_parent_wrapper (NoiseGenericList* self,
                                       NoiseViewWrapper* value)
{
	NoiseViewWrapper* _tmp0_;
	NoisePlaylist* _tmp1_;
	NoisePlaylist* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_parent_wrapper);
	self->priv->_parent_wrapper = _tmp0_;
	_tmp1_ = noise_view_wrapper_get_playlist (value);
	_tmp2_ = _tmp1_;
	noise_generic_list_set_playlist (self, _tmp2_);
	g_object_notify_by_pspec ((GObject *) self, noise_generic_list_properties[NOISE_GENERIC_LIST_PARENT_WRAPPER_PROPERTY]);
}

static void
_noise_generic_list_reorder_requested_noise_fast_model_reorder_requested (NoiseFastModel* _sender,
                                                                          gint column,
                                                                          GtkSortType direction,
                                                                          gpointer self)
{
	noise_generic_list_reorder_requested ((NoiseGenericList*) self, column, direction);
}

static void
_noise_generic_list_on_rows_reordered_noise_generic_list_rows_reordered (NoiseGenericList* _sender,
                                                                         gpointer self)
{
	noise_generic_list_on_rows_reordered ((NoiseGenericList*) self);
}

static gboolean
_noise_generic_list___lambda39_ (NoiseGenericList* self,
                                 GdkEventKey* event)
{
	gboolean result = FALSE;
	g_return_val_if_fail (event != NULL, FALSE);
	if (event->keyval == GDK_KEY_Delete) {
		noise_generic_list_mediaRemoveClicked (self);
	}
	result = FALSE;
	return result;
}

static gboolean
__noise_generic_list___lambda39__gtk_widget_key_press_event (GtkWidget* _sender,
                                                             GdkEventKey* event,
                                                             gpointer self)
{
	gboolean result;
	result = _noise_generic_list___lambda39_ ((NoiseGenericList*) self, event);
	return result;
}

static void
_noise_generic_list_on_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                         GdkDragContext* context,
                                                         gpointer self)
{
	noise_generic_list_on_drag_begin ((NoiseGenericList*) self, _sender, context);
}

static void
_noise_generic_list_on_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender,
                                                               GdkDragContext* context,
                                                               GtkSelectionData* selection_data,
                                                               guint info,
                                                               guint time_,
                                                               gpointer self)
{
	noise_generic_list_on_drag_data_get ((NoiseGenericList*) self, context, selection_data, info, time_);
}

static void
_noise_generic_list_on_drag_end_gtk_widget_drag_end (GtkWidget* _sender,
                                                     GdkDragContext* context,
                                                     gpointer self)
{
	noise_generic_list_on_drag_end ((NoiseGenericList*) self, _sender, context);
}

static void
_gtk_widget_queue_draw_noise_library_media_updated (NoiseLibrary* _sender,
                                                    GeeCollection* medias,
                                                    gpointer self)
{
	gtk_widget_queue_draw ((GtkWidget*) self);
}

static void
_noise_generic_list___lambda40_ (NoiseGenericList* self)
{
	noise_generic_list_set_is_current_list (self, FALSE);
}

static void
__noise_generic_list___lambda40__noise_playback_manager_queue_cleared (NoisePlaybackManager* _sender,
                                                                       gpointer self)
{
	_noise_generic_list___lambda40_ ((NoiseGenericList*) self);
}

static void
_noise_generic_list_media_played_noise_playback_manager_media_played (NoisePlaybackManager* _sender,
                                                                      NoiseMedia* played_media,
                                                                      gpointer self)
{
	noise_generic_list_media_played ((NoiseGenericList*) self, played_media, NULL, NULL);
}

static GObject *
noise_generic_list_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NoiseGenericList * self;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeList* _tmp11_;
	NoiseFastModel* _tmp12_;
	NoiseFastModel* _tmp13_;
	GeeArrayList* _tmp14_;
	NoiseFastModel* _tmp15_;
	NoiseCellDataFunctionHelper* _tmp16_;
	NoiseTreeViewSetup* _tmp17_;
	NoiseListColumn _tmp18_;
	NoiseListColumn _tmp19_;
	NoiseTreeViewSetup* _tmp20_;
	GtkSortType _tmp21_;
	GtkSortType _tmp22_;
	GtkTreeSelection* _tmp35_;
	GtkTargetEntry te = {0};
	GtkTargetEntry _tmp36_ = {0};
	GtkTargetEntry _tmp37_;
	GtkTargetEntry* _tmp38_;
	GtkTargetEntry* _tmp39_;
	gint _tmp39__length1;
	NoiseViewWrapper* _tmp40_;
	NoiseViewWrapper* _tmp41_;
	NoiseLibrary* _tmp42_;
	NoiseLibrary* _tmp43_;
	NoisePlaybackManager* _tmp44_;
	NoisePlaybackManager* _tmp45_;
	NoisePlaybackManager* _tmp46_;
	NoisePlaybackManager* _tmp47_;
	parent_class = G_OBJECT_CLASS (noise_generic_list_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_GENERIC_LIST, NoiseGenericList);
	_tmp0_ = gee_array_list_new (G_TYPE_GTYPE, NULL, NULL, NULL, NULL, NULL);
	_tmp1_ = _tmp0_;
	noise_generic_list_set_columns (self, (GeeList*) _tmp1_);
	_g_object_unref0 (_tmp1_);
	{
		GeeIterator* _type_it = NULL;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
		_tmp2_ = noise_list_column_get_all ();
		_tmp3_ = _tmp2_;
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_type_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			NoiseListColumn type = 0;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GeeList* _tmp9_;
			NoiseListColumn _tmp10_;
			_tmp6_ = _type_it;
			if (!gee_iterator_next (_tmp6_)) {
				break;
			}
			_tmp7_ = _type_it;
			_tmp8_ = gee_iterator_get (_tmp7_);
			type = (NoiseListColumn) ((gintptr) _tmp8_);
			_tmp9_ = self->priv->_columns;
			_tmp10_ = type;
			gee_collection_add ((GeeCollection*) _tmp9_, (gpointer) ((gintptr) noise_list_column_get_data_type (_tmp10_)));
		}
		_g_object_unref0 (_type_it);
	}
	_tmp11_ = self->priv->_columns;
	_tmp12_ = noise_fast_model_new (_tmp11_);
	_g_object_unref0 (self->fm);
	self->fm = _tmp12_;
	self->sort_column_id = NOISE_GENERIC_LIST_OPTIMAL_COLUMN;
	self->sort_direction = GTK_SORT_ASCENDING;
	_tmp13_ = self->fm;
	g_signal_connect_object (_tmp13_, "reorder-requested", (GCallback) _noise_generic_list_reorder_requested_noise_fast_model_reorder_requested, self, 0);
	_tmp14_ = self->table;
	noise_generic_list_set_table (self, _tmp14_, TRUE);
	_tmp15_ = self->fm;
	gtk_tree_view_set_model ((GtkTreeView*) self, (GtkTreeModel*) _tmp15_);
	_tmp16_ = noise_cell_data_function_helper_new (self);
	_noise_cell_data_function_helper_unref0 (self->cell_data_helper);
	self->cell_data_helper = _tmp16_;
	_tmp17_ = self->priv->_tvs;
	_tmp18_ = noise_tree_view_setup_get_sort_column_id (_tmp17_);
	_tmp19_ = _tmp18_;
	_tmp20_ = self->priv->_tvs;
	_tmp21_ = noise_tree_view_setup_get_sort_direction (_tmp20_);
	_tmp22_ = _tmp21_;
	noise_generic_list_set_sort_column_id (self, (gint) _tmp19_, _tmp22_);
	gtk_tree_view_set_enable_search ((GtkTreeView*) self, FALSE);
	gtk_tree_view_set_fixed_height_mode ((GtkTreeView*) self, TRUE);
	gtk_tree_view_set_reorderable ((GtkTreeView*) self, FALSE);
	{
		GeeIterator* _tvc_it = NULL;
		NoiseTreeViewSetup* _tmp23_;
		GeeCollection* _tmp24_;
		GeeCollection* _tmp25_;
		GeeIterator* _tmp26_;
		GeeIterator* _tmp27_;
		_tmp23_ = self->priv->_tvs;
		_tmp24_ = noise_tree_view_setup_get_columns (_tmp23_);
		_tmp25_ = _tmp24_;
		_tmp26_ = gee_iterable_iterator ((GeeIterable*) _tmp25_);
		_tmp27_ = _tmp26_;
		_g_object_unref0 (_tmp25_);
		_tvc_it = _tmp27_;
		while (TRUE) {
			GeeIterator* _tmp28_;
			GtkTreeViewColumn* tvc = NULL;
			GeeIterator* _tmp29_;
			gpointer _tmp30_;
			GtkTreeViewColumn* _tmp31_;
			GtkTreeViewColumn* _tmp32_;
			NoiseListColumn* _tmp33_;
			NoiseListColumn* _tmp34_;
			_tmp28_ = _tvc_it;
			if (!gee_iterator_next (_tmp28_)) {
				break;
			}
			_tmp29_ = _tvc_it;
			_tmp30_ = gee_iterator_get (_tmp29_);
			tvc = (GtkTreeViewColumn*) _tmp30_;
			_tmp31_ = tvc;
			_tmp32_ = tvc;
			_tmp33_ = noise_tree_view_setup_get_column_type (_tmp32_);
			_tmp34_ = _tmp33_;
			noise_generic_list_add_column (self, _tmp31_, *_tmp34_);
			_g_free0 (_tmp34_);
			_g_object_unref0 (tvc);
		}
		_g_object_unref0 (_tvc_it);
	}
	_tmp35_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
	gtk_tree_selection_set_mode (_tmp35_, GTK_SELECTION_MULTIPLE);
	g_signal_connect_object (self, "rows-reordered", (GCallback) _noise_generic_list_on_rows_reordered_noise_generic_list_rows_reordered, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "key-press-event", (GCallback) __noise_generic_list___lambda39__gtk_widget_key_press_event, self, 0);
	_tmp36_.target = "text/uri-list";
	_tmp36_.flags = (guint) GTK_TARGET_SAME_APP;
	_tmp36_.info = (guint) 0;
	te = _tmp36_;
	_tmp37_ = te;
	_tmp38_ = g_new0 (GtkTargetEntry, 1);
	_tmp38_[0] = _tmp37_;
	_tmp39_ = _tmp38_;
	_tmp39__length1 = 1;
	gtk_drag_source_set ((GtkWidget*) self, GDK_BUTTON1_MASK, _tmp39_, (gint) 1, GDK_ACTION_COPY);
	_tmp39_ = (g_free (_tmp39_), NULL);
	g_signal_connect_object ((GtkWidget*) self, "drag-begin", (GCallback) _noise_generic_list_on_drag_begin_gtk_widget_drag_begin, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "drag-data-get", (GCallback) _noise_generic_list_on_drag_data_get_gtk_widget_drag_data_get, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "drag-end", (GCallback) _noise_generic_list_on_drag_end_gtk_widget_drag_end, self, 0);
	_tmp40_ = noise_generic_list_get_parent_wrapper (self);
	_tmp41_ = _tmp40_;
	_tmp42_ = noise_view_wrapper_get_library (_tmp41_);
	_tmp43_ = _tmp42_;
	g_signal_connect_object (_tmp43_, "media-updated", (GCallback) _gtk_widget_queue_draw_noise_library_media_updated, (GtkWidget*) self, 0);
	_tmp44_ = noise_app_get_player ();
	_tmp45_ = _tmp44_;
	g_signal_connect_object (_tmp45_, "queue-cleared", (GCallback) __noise_generic_list___lambda40__noise_playback_manager_queue_cleared, self, 0);
	_tmp46_ = noise_app_get_player ();
	_tmp47_ = _tmp46_;
	g_signal_connect_object (_tmp47_, "media-played", (GCallback) _noise_generic_list_media_played_noise_playback_manager_media_played, self, 0);
	return obj;
}

static void
noise_generic_list_class_init (NoiseGenericListClass * klass,
                               gpointer klass_data)
{
	noise_generic_list_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NoiseGenericList_private_offset);
	((NoiseGenericListClass *) klass)->add_column = (void (*) (NoiseGenericList*, GtkTreeViewColumn*, NoiseListColumn)) noise_generic_list_real_add_column;
	((NoiseGenericListClass *) klass)->mediaRemoveClicked = (void (*) (NoiseGenericList*)) noise_generic_list_real_mediaRemoveClicked;
	((GtkTreeViewClass *) klass)->row_activated = (void (*) (GtkTreeView*, GtkTreePath*, GtkTreeViewColumn*)) noise_generic_list_real_row_activated;
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_generic_list_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_generic_list_set_property;
	G_OBJECT_CLASS (klass)->constructor = noise_generic_list_constructor;
	G_OBJECT_CLASS (klass)->finalize = noise_generic_list_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_GENERIC_LIST_COLUMNS_PROPERTY, noise_generic_list_properties[NOISE_GENERIC_LIST_COLUMNS_PROPERTY] = g_param_spec_object ("columns", "columns", "columns", GEE_TYPE_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_GENERIC_LIST_RESEARCH_NEEDED_PROPERTY, noise_generic_list_properties[NOISE_GENERIC_LIST_RESEARCH_NEEDED_PROPERTY] = g_param_spec_boolean ("research-needed", "research-needed", "research-needed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_GENERIC_LIST_IS_CURRENT_LIST_PROPERTY, noise_generic_list_properties[NOISE_GENERIC_LIST_IS_CURRENT_LIST_PROPERTY] = g_param_spec_boolean ("is-current-list", "is-current-list", "is-current-list", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_GENERIC_LIST_PLAYLIST_PROPERTY, noise_generic_list_properties[NOISE_GENERIC_LIST_PLAYLIST_PROPERTY] = g_param_spec_object ("playlist", "playlist", "playlist", NOISE_TYPE_PLAYLIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_GENERIC_LIST_TVS_PROPERTY, noise_generic_list_properties[NOISE_GENERIC_LIST_TVS_PROPERTY] = g_param_spec_object ("tvs", "tvs", "tvs", NOISE_TYPE_TREE_VIEW_SETUP, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_GENERIC_LIST_HINT_PROPERTY, noise_generic_list_properties[NOISE_GENERIC_LIST_HINT_PROPERTY] = g_param_spec_enum ("hint", "hint", "hint", NOISE_VIEW_WRAPPER_TYPE_HINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_GENERIC_LIST_PARENT_WRAPPER_PROPERTY, noise_generic_list_properties[NOISE_GENERIC_LIST_PARENT_WRAPPER_PROPERTY] = g_param_spec_object ("parent-wrapper", "parent-wrapper", "parent-wrapper", NOISE_TYPE_VIEW_WRAPPER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	noise_generic_list_signals[NOISE_GENERIC_LIST_IMPORT_REQUESTED_SIGNAL] = g_signal_new ("import-requested", NOISE_TYPE_GENERIC_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	noise_generic_list_signals[NOISE_GENERIC_LIST_ROWS_REORDERED_SIGNAL] = g_signal_new ("rows-reordered", NOISE_TYPE_GENERIC_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
noise_generic_list_instance_init (NoiseGenericList * self,
                                  gpointer klass)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	self->priv = noise_generic_list_get_instance_private (self);
	self->priv->_research_needed = FALSE;
	self->priv->_playlist = NULL;
	_tmp0_ = gee_array_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	self->table = _tmp0_;
	_tmp1_ = gee_array_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	self->showing = _tmp1_;
}

static void
noise_generic_list_finalize (GObject * obj)
{
	NoiseGenericList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_GENERIC_LIST, NoiseGenericList);
	_g_object_unref0 (self->priv->_columns);
	_g_object_unref0 (self->priv->_playlist);
	_g_object_unref0 (self->priv->_tvs);
	_g_object_unref0 (self->priv->_parent_wrapper);
	_g_object_unref0 (self->fm);
	_g_object_unref0 (self->table);
	_g_object_unref0 (self->showing);
	_noise_cell_data_function_helper_unref0 (self->cell_data_helper);
	G_OBJECT_CLASS (noise_generic_list_parent_class)->finalize (obj);
}

GType
noise_generic_list_get_type (void)
{
	static volatile gsize noise_generic_list_type_id__volatile = 0;
	if (g_once_init_enter (&noise_generic_list_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseGenericListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_generic_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseGenericList), 0, (GInstanceInitFunc) noise_generic_list_instance_init, NULL };
		GType noise_generic_list_type_id;
		noise_generic_list_type_id = g_type_register_static (gtk_tree_view_get_type (), "NoiseGenericList", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		NoiseGenericList_private_offset = g_type_add_instance_private (noise_generic_list_type_id, sizeof (NoiseGenericListPrivate));
		g_once_init_leave (&noise_generic_list_type_id__volatile, noise_generic_list_type_id);
	}
	return noise_generic_list_type_id__volatile;
}

static void
_vala_noise_generic_list_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	NoiseGenericList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_GENERIC_LIST, NoiseGenericList);
	switch (property_id) {
		case NOISE_GENERIC_LIST_COLUMNS_PROPERTY:
		g_value_set_object (value, noise_generic_list_get_columns (self));
		break;
		case NOISE_GENERIC_LIST_RESEARCH_NEEDED_PROPERTY:
		g_value_set_boolean (value, noise_generic_list_get_research_needed (self));
		break;
		case NOISE_GENERIC_LIST_IS_CURRENT_LIST_PROPERTY:
		g_value_set_boolean (value, noise_generic_list_get_is_current_list (self));
		break;
		case NOISE_GENERIC_LIST_PLAYLIST_PROPERTY:
		g_value_set_object (value, noise_generic_list_get_playlist (self));
		break;
		case NOISE_GENERIC_LIST_TVS_PROPERTY:
		g_value_set_object (value, noise_generic_list_get_tvs (self));
		break;
		case NOISE_GENERIC_LIST_HINT_PROPERTY:
		g_value_set_enum (value, noise_generic_list_get_hint (self));
		break;
		case NOISE_GENERIC_LIST_PARENT_WRAPPER_PROPERTY:
		g_value_set_object (value, noise_generic_list_get_parent_wrapper (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_noise_generic_list_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	NoiseGenericList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_GENERIC_LIST, NoiseGenericList);
	switch (property_id) {
		case NOISE_GENERIC_LIST_COLUMNS_PROPERTY:
		noise_generic_list_set_columns (self, g_value_get_object (value));
		break;
		case NOISE_GENERIC_LIST_RESEARCH_NEEDED_PROPERTY:
		noise_generic_list_set_research_needed (self, g_value_get_boolean (value));
		break;
		case NOISE_GENERIC_LIST_IS_CURRENT_LIST_PROPERTY:
		noise_generic_list_set_is_current_list (self, g_value_get_boolean (value));
		break;
		case NOISE_GENERIC_LIST_PLAYLIST_PROPERTY:
		noise_generic_list_set_playlist (self, g_value_get_object (value));
		break;
		case NOISE_GENERIC_LIST_TVS_PROPERTY:
		noise_generic_list_set_tvs (self, g_value_get_object (value));
		break;
		case NOISE_GENERIC_LIST_HINT_PROPERTY:
		noise_generic_list_set_hint (self, g_value_get_enum (value));
		break;
		case NOISE_GENERIC_LIST_PARENT_WRAPPER_PROPERTY:
		noise_generic_list_set_parent_wrapper (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

