/* ViewSelector.c generated by valac 0.44.7, the Vala compiler
 * generated from ViewSelector.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <granite.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>

#define NOISE_WIDGETS_TYPE_VIEW_SELECTOR (noise_widgets_view_selector_get_type ())
#define NOISE_WIDGETS_VIEW_SELECTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_WIDGETS_TYPE_VIEW_SELECTOR, NoiseWidgetsViewSelector))
#define NOISE_WIDGETS_VIEW_SELECTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_WIDGETS_TYPE_VIEW_SELECTOR, NoiseWidgetsViewSelectorClass))
#define NOISE_WIDGETS_IS_VIEW_SELECTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_WIDGETS_TYPE_VIEW_SELECTOR))
#define NOISE_WIDGETS_IS_VIEW_SELECTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_WIDGETS_TYPE_VIEW_SELECTOR))
#define NOISE_WIDGETS_VIEW_SELECTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_WIDGETS_TYPE_VIEW_SELECTOR, NoiseWidgetsViewSelectorClass))

typedef struct _NoiseWidgetsViewSelector NoiseWidgetsViewSelector;
typedef struct _NoiseWidgetsViewSelectorClass NoiseWidgetsViewSelectorClass;
typedef struct _NoiseWidgetsViewSelectorPrivate NoiseWidgetsViewSelectorPrivate;
typedef enum  {
	NOISE_WIDGETS_VIEW_SELECTOR_MODE_GRID = 0,
	NOISE_WIDGETS_VIEW_SELECTOR_MODE_LIST = 1,
	NOISE_WIDGETS_VIEW_SELECTOR_MODE_COLUMN = 2
} NoiseWidgetsViewSelectorMode;

#define NOISE_WIDGETS_VIEW_SELECTOR_TYPE_MODE (noise_widgets_view_selector_mode_get_type ())
enum  {
	NOISE_WIDGETS_VIEW_SELECTOR_0_PROPERTY,
	NOISE_WIDGETS_VIEW_SELECTOR_SELECTED_PROPERTY,
	NOISE_WIDGETS_VIEW_SELECTOR_SENSITIVE_PROPERTY,
	NOISE_WIDGETS_VIEW_SELECTOR_NUM_PROPERTIES
};
static GParamSpec* noise_widgets_view_selector_properties[NOISE_WIDGETS_VIEW_SELECTOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define NOISE_TYPE_LIBRARY_WINDOW (noise_library_window_get_type ())
#define NOISE_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindow))
#define NOISE_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))
#define NOISE_IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LIBRARY_WINDOW))
#define NOISE_LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LIBRARY_WINDOW, NoiseLibraryWindowClass))

typedef struct _NoiseLibraryWindow NoiseLibraryWindow;
typedef struct _NoiseLibraryWindowClass NoiseLibraryWindowClass;
enum  {
	NOISE_WIDGETS_VIEW_SELECTOR_MODE_CHANGED_SIGNAL,
	NOISE_WIDGETS_VIEW_SELECTOR_COLUMN_BROWSER_TOGGLED_SIGNAL,
	NOISE_WIDGETS_VIEW_SELECTOR_NUM_SIGNALS
};
static guint noise_widgets_view_selector_signals[NOISE_WIDGETS_VIEW_SELECTOR_NUM_SIGNALS] = {0};

struct _NoiseWidgetsViewSelector {
	GtkToolItem parent_instance;
	NoiseWidgetsViewSelectorPrivate * priv;
};

struct _NoiseWidgetsViewSelectorClass {
	GtkToolItemClass parent_class;
};

struct _NoiseWidgetsViewSelectorPrivate {
	GraniteWidgetsModeButton* mode_button;
	NoiseWidgetsViewSelectorMode mode;
};

static gint NoiseWidgetsViewSelector_private_offset;
static gpointer noise_widgets_view_selector_parent_class = NULL;

GType noise_widgets_view_selector_get_type (void) G_GNUC_CONST;
GType noise_widgets_view_selector_mode_get_type (void) G_GNUC_CONST;
NoiseWidgetsViewSelector* noise_widgets_view_selector_new (void);
NoiseWidgetsViewSelector* noise_widgets_view_selector_construct (GType object_type);
#define NOISE_LIBRARY_WINDOW_ACTION_PREFIX "win."
#define NOISE_LIBRARY_WINDOW_ACTION_VIEW_ALBUMS "action_view_albums"
#define NOISE_LIBRARY_WINDOW_ACTION_VIEW_LIST "action_view_list"
#define NOISE_LIBRARY_WINDOW_ACTION_VIEW_COLUMNS "action_view_columns"
static void __lambda57_ (NoiseWidgetsViewSelector* self);
void noise_widgets_view_selector_set_selected (NoiseWidgetsViewSelector* self,
                                               NoiseWidgetsViewSelectorMode value);
static void ___lambda57__granite_widgets_mode_button_mode_changed (GraniteWidgetsModeButton* _sender,
                                                            GtkWidget* widget,
                                                            gpointer self);
gboolean noise_widgets_view_selector_get_column_browser_toggle_active (NoiseWidgetsViewSelector* self);
void noise_widgets_view_selector_set_column_browser_toggle_active (NoiseWidgetsViewSelector* self,
                                                                   gboolean active);
NoiseWidgetsViewSelectorMode noise_widgets_view_selector_get_selected (NoiseWidgetsViewSelector* self);
gboolean noise_widgets_view_selector_get_sensitive (NoiseWidgetsViewSelector* self);
void noise_widgets_view_selector_set_sensitive (NoiseWidgetsViewSelector* self,
                                                gboolean value);
GType noise_library_window_get_type (void) G_GNUC_CONST;
NoiseLibraryWindow* noise_app_get_main_window (void);
GSimpleActionGroup* noise_library_window_get_actions (NoiseLibraryWindow* self);
static void noise_widgets_view_selector_finalize (GObject * obj);
static void _vala_noise_widgets_view_selector_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_noise_widgets_view_selector_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static inline gpointer
noise_widgets_view_selector_get_instance_private (NoiseWidgetsViewSelector* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseWidgetsViewSelector_private_offset);
}

GType
noise_widgets_view_selector_mode_get_type (void)
{
	static volatile gsize noise_widgets_view_selector_mode_type_id__volatile = 0;
	if (g_once_init_enter (&noise_widgets_view_selector_mode_type_id__volatile)) {
		static const GEnumValue values[] = {{NOISE_WIDGETS_VIEW_SELECTOR_MODE_GRID, "NOISE_WIDGETS_VIEW_SELECTOR_MODE_GRID", "grid"}, {NOISE_WIDGETS_VIEW_SELECTOR_MODE_LIST, "NOISE_WIDGETS_VIEW_SELECTOR_MODE_LIST", "list"}, {NOISE_WIDGETS_VIEW_SELECTOR_MODE_COLUMN, "NOISE_WIDGETS_VIEW_SELECTOR_MODE_COLUMN", "column"}, {0, NULL, NULL}};
		GType noise_widgets_view_selector_mode_type_id;
		noise_widgets_view_selector_mode_type_id = g_enum_register_static ("NoiseWidgetsViewSelectorMode", values);
		g_once_init_leave (&noise_widgets_view_selector_mode_type_id__volatile, noise_widgets_view_selector_mode_type_id);
	}
	return noise_widgets_view_selector_mode_type_id__volatile;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
__lambda57_ (NoiseWidgetsViewSelector* self)
{
	gint new_mode = 0;
	GraniteWidgetsModeButton* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	_tmp0_ = self->priv->mode_button;
	_tmp1_ = granite_widgets_mode_button_get_selected (_tmp0_);
	_tmp2_ = _tmp1_;
	new_mode = _tmp2_;
	if (new_mode <= 2) {
		noise_widgets_view_selector_set_selected (self, (NoiseWidgetsViewSelectorMode) new_mode);
	} else {
		GraniteWidgetsModeButton* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
		_tmp3_ = self->priv->mode_button;
		_tmp4_ = gtk_widget_get_sensitive ((GtkWidget*) _tmp3_);
		_tmp5_ = _tmp4_;
		if (_tmp5_) {
			NoiseWidgetsViewSelectorMode _tmp6_;
			_tmp6_ = self->priv->mode;
			noise_widgets_view_selector_set_selected (self, _tmp6_);
		}
	}
}

static void
___lambda57__granite_widgets_mode_button_mode_changed (GraniteWidgetsModeButton* _sender,
                                                       GtkWidget* widget,
                                                       gpointer self)
{
	__lambda57_ ((NoiseWidgetsViewSelector*) self);
}

NoiseWidgetsViewSelector*
noise_widgets_view_selector_construct (GType object_type)
{
	NoiseWidgetsViewSelector * self = NULL;
	GtkApplication* application_instance = NULL;
	GApplication* _tmp0_;
	GtkApplication* _tmp1_;
	GtkImage* image = NULL;
	GtkImage* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GtkImage* list = NULL;
	GtkImage* _tmp8_;
	gchar** _tmp9_;
	gchar** _tmp10_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GtkImage* column = NULL;
	GtkImage* _tmp14_;
	gchar** _tmp15_;
	gchar** _tmp16_;
	gchar** _tmp17_;
	gint _tmp17__length1;
	gchar* _tmp18_;
	gchar* _tmp19_;
	GraniteWidgetsModeButton* _tmp20_;
	GraniteWidgetsModeButton* _tmp21_;
	GraniteWidgetsModeButton* _tmp22_;
	GraniteWidgetsModeButton* _tmp23_;
	GraniteWidgetsModeButton* _tmp24_;
	GraniteWidgetsModeButton* _tmp25_;
	self = (NoiseWidgetsViewSelector*) g_object_new (object_type, NULL);
	_tmp0_ = g_application_get_default ();
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_application_get_type (), GtkApplication));
	application_instance = _tmp1_;
	_tmp2_ = (GtkImage*) gtk_image_new_from_icon_name ("view-grid-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp2_);
	image = _tmp2_;
	_tmp4_ = _tmp3_ = gtk_application_get_accels_for_action (application_instance, NOISE_LIBRARY_WINDOW_ACTION_PREFIX NOISE_LIBRARY_WINDOW_ACTION_VIEW_ALBUMS);
	_tmp5_ = _tmp4_;
	_tmp5__length1 = _vala_array_length (_tmp3_);
	_tmp6_ = granite_markup_accel_tooltip (_tmp5_, (gint) _vala_array_length (_tmp3_), _ ("View as albums"));
	_tmp7_ = _tmp6_;
	gtk_widget_set_tooltip_markup ((GtkWidget*) image, _tmp7_);
	_g_free0 (_tmp7_);
	_tmp5_ = (_vala_array_free (_tmp5_, _tmp5__length1, (GDestroyNotify) g_free), NULL);
	_tmp8_ = (GtkImage*) gtk_image_new_from_icon_name ("view-list-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp8_);
	list = _tmp8_;
	_tmp10_ = _tmp9_ = gtk_application_get_accels_for_action (application_instance, NOISE_LIBRARY_WINDOW_ACTION_PREFIX NOISE_LIBRARY_WINDOW_ACTION_VIEW_LIST);
	_tmp11_ = _tmp10_;
	_tmp11__length1 = _vala_array_length (_tmp9_);
	_tmp12_ = granite_markup_accel_tooltip (_tmp11_, (gint) _vala_array_length (_tmp9_), _ ("View as list"));
	_tmp13_ = _tmp12_;
	gtk_widget_set_tooltip_markup ((GtkWidget*) list, _tmp13_);
	_g_free0 (_tmp13_);
	_tmp11_ = (_vala_array_free (_tmp11_, _tmp11__length1, (GDestroyNotify) g_free), NULL);
	_tmp14_ = (GtkImage*) gtk_image_new_from_icon_name ("view-column-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp14_);
	column = _tmp14_;
	_tmp16_ = _tmp15_ = gtk_application_get_accels_for_action (application_instance, NOISE_LIBRARY_WINDOW_ACTION_PREFIX NOISE_LIBRARY_WINDOW_ACTION_VIEW_COLUMNS);
	_tmp17_ = _tmp16_;
	_tmp17__length1 = _vala_array_length (_tmp15_);
	_tmp18_ = granite_markup_accel_tooltip (_tmp17_, (gint) _vala_array_length (_tmp15_), _ ("View in columns"));
	_tmp19_ = _tmp18_;
	gtk_widget_set_tooltip_markup ((GtkWidget*) column, _tmp19_);
	_g_free0 (_tmp19_);
	_tmp17_ = (_vala_array_free (_tmp17_, _tmp17__length1, (GDestroyNotify) g_free), NULL);
	_tmp20_ = granite_widgets_mode_button_new ();
	g_object_ref_sink (_tmp20_);
	_g_object_unref0 (self->priv->mode_button);
	self->priv->mode_button = _tmp20_;
	_tmp21_ = self->priv->mode_button;
	granite_widgets_mode_button_append (_tmp21_, (GtkWidget*) image);
	_tmp22_ = self->priv->mode_button;
	granite_widgets_mode_button_append (_tmp22_, (GtkWidget*) list);
	_tmp23_ = self->priv->mode_button;
	granite_widgets_mode_button_append (_tmp23_, (GtkWidget*) column);
	_tmp24_ = self->priv->mode_button;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp24_);
	_tmp25_ = self->priv->mode_button;
	g_signal_connect_object (_tmp25_, "mode-changed", (GCallback) ___lambda57__granite_widgets_mode_button_mode_changed, self, 0);
	_g_object_unref0 (column);
	_g_object_unref0 (list);
	_g_object_unref0 (image);
	_g_object_unref0 (application_instance);
	return self;
}

NoiseWidgetsViewSelector*
noise_widgets_view_selector_new (void)
{
	return noise_widgets_view_selector_construct (NOISE_WIDGETS_TYPE_VIEW_SELECTOR);
}

gboolean
noise_widgets_view_selector_get_column_browser_toggle_active (NoiseWidgetsViewSelector* self)
{
	gboolean result = FALSE;
	NoiseWidgetsViewSelectorMode _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->mode;
	result = _tmp0_ == NOISE_WIDGETS_VIEW_SELECTOR_MODE_COLUMN;
	return result;
}

void
noise_widgets_view_selector_set_column_browser_toggle_active (NoiseWidgetsViewSelector* self,
                                                              gboolean active)
{
	g_return_if_fail (self != NULL);
	if (active) {
		noise_widgets_view_selector_set_selected (self, NOISE_WIDGETS_VIEW_SELECTOR_MODE_COLUMN);
	} else {
		if (noise_widgets_view_selector_get_column_browser_toggle_active (self)) {
			noise_widgets_view_selector_set_selected (self, NOISE_WIDGETS_VIEW_SELECTOR_MODE_LIST);
		}
	}
}

NoiseWidgetsViewSelectorMode
noise_widgets_view_selector_get_selected (NoiseWidgetsViewSelector* self)
{
	NoiseWidgetsViewSelectorMode result;
	NoiseWidgetsViewSelectorMode _tmp0_ = 0;
	NoiseWidgetsViewSelectorMode _tmp1_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp1_ = self->priv->mode;
	if (_tmp1_ != NOISE_WIDGETS_VIEW_SELECTOR_MODE_COLUMN) {
		NoiseWidgetsViewSelectorMode _tmp2_;
		_tmp2_ = self->priv->mode;
		_tmp0_ = _tmp2_;
	} else {
		_tmp0_ = NOISE_WIDGETS_VIEW_SELECTOR_MODE_LIST;
	}
	result = _tmp0_;
	return result;
}

void
noise_widgets_view_selector_set_selected (NoiseWidgetsViewSelector* self,
                                          NoiseWidgetsViewSelectorMode value)
{
	NoiseWidgetsViewSelectorMode _tmp0_;
	GraniteWidgetsModeButton* _tmp1_;
	gboolean is_column_mode = FALSE;
	NoiseWidgetsViewSelectorMode _tmp2_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->mode;
	if (_tmp0_ == value) {
		return;
	}
	self->priv->mode = value;
	_tmp1_ = self->priv->mode_button;
	granite_widgets_mode_button_set_selected (_tmp1_, (gint) value);
	is_column_mode = value == NOISE_WIDGETS_VIEW_SELECTOR_MODE_COLUMN;
	g_signal_emit (self, noise_widgets_view_selector_signals[NOISE_WIDGETS_VIEW_SELECTOR_COLUMN_BROWSER_TOGGLED_SIGNAL], 0, is_column_mode);
	if (is_column_mode) {
		_tmp2_ = NOISE_WIDGETS_VIEW_SELECTOR_MODE_LIST;
	} else {
		_tmp2_ = value;
	}
	g_signal_emit (self, noise_widgets_view_selector_signals[NOISE_WIDGETS_VIEW_SELECTOR_MODE_CHANGED_SIGNAL], 0, _tmp2_);
	g_object_notify_by_pspec ((GObject *) self, noise_widgets_view_selector_properties[NOISE_WIDGETS_VIEW_SELECTOR_SELECTED_PROPERTY]);
}

gboolean
noise_widgets_view_selector_get_sensitive (NoiseWidgetsViewSelector* self)
{
	gboolean result;
	GraniteWidgetsModeButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->mode_button;
	_tmp1_ = gtk_widget_get_sensitive ((GtkWidget*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

void
noise_widgets_view_selector_set_sensitive (NoiseWidgetsViewSelector* self,
                                           gboolean value)
{
	GraniteWidgetsModeButton* _tmp0_;
	gint _tmp1_ = 0;
	GraniteWidgetsModeButton* _tmp3_;
	NoiseLibraryWindow* _tmp4_;
	NoiseLibraryWindow* _tmp5_;
	GSimpleActionGroup* _tmp6_;
	GSimpleActionGroup* _tmp7_;
	GAction* _tmp8_;
	NoiseLibraryWindow* _tmp9_;
	NoiseLibraryWindow* _tmp10_;
	GSimpleActionGroup* _tmp11_;
	GSimpleActionGroup* _tmp12_;
	GAction* _tmp13_;
	NoiseLibraryWindow* _tmp14_;
	NoiseLibraryWindow* _tmp15_;
	GSimpleActionGroup* _tmp16_;
	GSimpleActionGroup* _tmp17_;
	GAction* _tmp18_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->mode_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, value);
	if (value) {
		NoiseWidgetsViewSelectorMode _tmp2_;
		_tmp2_ = self->priv->mode;
		_tmp1_ = (gint) _tmp2_;
	} else {
		_tmp1_ = -1;
	}
	_tmp3_ = self->priv->mode_button;
	granite_widgets_mode_button_set_active (_tmp3_, _tmp1_);
	_tmp4_ = noise_app_get_main_window ();
	_tmp5_ = _tmp4_;
	_tmp6_ = noise_library_window_get_actions (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = g_action_map_lookup_action ((GActionMap*) _tmp7_, NOISE_LIBRARY_WINDOW_ACTION_VIEW_ALBUMS);
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, g_simple_action_get_type (), GSimpleAction), value);
	_tmp9_ = noise_app_get_main_window ();
	_tmp10_ = _tmp9_;
	_tmp11_ = noise_library_window_get_actions (_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = g_action_map_lookup_action ((GActionMap*) _tmp12_, NOISE_LIBRARY_WINDOW_ACTION_VIEW_LIST);
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, g_simple_action_get_type (), GSimpleAction), value);
	_tmp14_ = noise_app_get_main_window ();
	_tmp15_ = _tmp14_;
	_tmp16_ = noise_library_window_get_actions (_tmp15_);
	_tmp17_ = _tmp16_;
	_tmp18_ = g_action_map_lookup_action ((GActionMap*) _tmp17_, NOISE_LIBRARY_WINDOW_ACTION_VIEW_COLUMNS);
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, g_simple_action_get_type (), GSimpleAction), value);
	g_object_notify_by_pspec ((GObject *) self, noise_widgets_view_selector_properties[NOISE_WIDGETS_VIEW_SELECTOR_SENSITIVE_PROPERTY]);
}

static void
noise_widgets_view_selector_class_init (NoiseWidgetsViewSelectorClass * klass,
                                        gpointer klass_data)
{
	noise_widgets_view_selector_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NoiseWidgetsViewSelector_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_widgets_view_selector_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_widgets_view_selector_set_property;
	G_OBJECT_CLASS (klass)->finalize = noise_widgets_view_selector_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_WIDGETS_VIEW_SELECTOR_SELECTED_PROPERTY, noise_widgets_view_selector_properties[NOISE_WIDGETS_VIEW_SELECTOR_SELECTED_PROPERTY] = g_param_spec_enum ("selected", "selected", "selected", NOISE_WIDGETS_VIEW_SELECTOR_TYPE_MODE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_WIDGETS_VIEW_SELECTOR_SENSITIVE_PROPERTY, noise_widgets_view_selector_properties[NOISE_WIDGETS_VIEW_SELECTOR_SENSITIVE_PROPERTY] = g_param_spec_boolean ("sensitive", "sensitive", "sensitive", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	noise_widgets_view_selector_signals[NOISE_WIDGETS_VIEW_SELECTOR_MODE_CHANGED_SIGNAL] = g_signal_new ("mode-changed", NOISE_WIDGETS_TYPE_VIEW_SELECTOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__ENUM, G_TYPE_NONE, 1, NOISE_WIDGETS_VIEW_SELECTOR_TYPE_MODE);
	noise_widgets_view_selector_signals[NOISE_WIDGETS_VIEW_SELECTOR_COLUMN_BROWSER_TOGGLED_SIGNAL] = g_signal_new ("column-browser-toggled", NOISE_WIDGETS_TYPE_VIEW_SELECTOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
}

static void
noise_widgets_view_selector_instance_init (NoiseWidgetsViewSelector * self,
                                           gpointer klass)
{
	self->priv = noise_widgets_view_selector_get_instance_private (self);
}

static void
noise_widgets_view_selector_finalize (GObject * obj)
{
	NoiseWidgetsViewSelector * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_WIDGETS_TYPE_VIEW_SELECTOR, NoiseWidgetsViewSelector);
	_g_object_unref0 (self->priv->mode_button);
	G_OBJECT_CLASS (noise_widgets_view_selector_parent_class)->finalize (obj);
}

GType
noise_widgets_view_selector_get_type (void)
{
	static volatile gsize noise_widgets_view_selector_type_id__volatile = 0;
	if (g_once_init_enter (&noise_widgets_view_selector_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseWidgetsViewSelectorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_widgets_view_selector_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseWidgetsViewSelector), 0, (GInstanceInitFunc) noise_widgets_view_selector_instance_init, NULL };
		GType noise_widgets_view_selector_type_id;
		noise_widgets_view_selector_type_id = g_type_register_static (gtk_tool_item_get_type (), "NoiseWidgetsViewSelector", &g_define_type_info, 0);
		NoiseWidgetsViewSelector_private_offset = g_type_add_instance_private (noise_widgets_view_selector_type_id, sizeof (NoiseWidgetsViewSelectorPrivate));
		g_once_init_leave (&noise_widgets_view_selector_type_id__volatile, noise_widgets_view_selector_type_id);
	}
	return noise_widgets_view_selector_type_id__volatile;
}

static void
_vala_noise_widgets_view_selector_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	NoiseWidgetsViewSelector * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_WIDGETS_TYPE_VIEW_SELECTOR, NoiseWidgetsViewSelector);
	switch (property_id) {
		case NOISE_WIDGETS_VIEW_SELECTOR_SELECTED_PROPERTY:
		g_value_set_enum (value, noise_widgets_view_selector_get_selected (self));
		break;
		case NOISE_WIDGETS_VIEW_SELECTOR_SENSITIVE_PROPERTY:
		g_value_set_boolean (value, noise_widgets_view_selector_get_sensitive (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_noise_widgets_view_selector_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	NoiseWidgetsViewSelector * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_WIDGETS_TYPE_VIEW_SELECTOR, NoiseWidgetsViewSelector);
	switch (property_id) {
		case NOISE_WIDGETS_VIEW_SELECTOR_SELECTED_PROPERTY:
		noise_widgets_view_selector_set_selected (self, g_value_get_enum (value));
		break;
		case NOISE_WIDGETS_VIEW_SELECTOR_SENSITIVE_PROPERTY:
		noise_widgets_view_selector_set_sensitive (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

