/* CDRomDeviceManager.c generated by valac 0.44.7, the Vala compiler
 * generated from CDRomDeviceManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <gee.h>
#include "io.elementary.music-core.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#define NOISE_PLUGINS_TYPE_CD_ROM_DEVICE_MANAGER (noise_plugins_cd_rom_device_manager_get_type ())
#define NOISE_PLUGINS_CD_ROM_DEVICE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_PLUGINS_TYPE_CD_ROM_DEVICE_MANAGER, NoisePluginsCDRomDeviceManager))
#define NOISE_PLUGINS_CD_ROM_DEVICE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_PLUGINS_TYPE_CD_ROM_DEVICE_MANAGER, NoisePluginsCDRomDeviceManagerClass))
#define NOISE_PLUGINS_IS_CD_ROM_DEVICE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_PLUGINS_TYPE_CD_ROM_DEVICE_MANAGER))
#define NOISE_PLUGINS_IS_CD_ROM_DEVICE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_PLUGINS_TYPE_CD_ROM_DEVICE_MANAGER))
#define NOISE_PLUGINS_CD_ROM_DEVICE_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_PLUGINS_TYPE_CD_ROM_DEVICE_MANAGER, NoisePluginsCDRomDeviceManagerClass))

typedef struct _NoisePluginsCDRomDeviceManager NoisePluginsCDRomDeviceManager;
typedef struct _NoisePluginsCDRomDeviceManagerClass NoisePluginsCDRomDeviceManagerClass;
typedef struct _NoisePluginsCDRomDeviceManagerPrivate NoisePluginsCDRomDeviceManagerPrivate;

#define NOISE_PLUGINS_TYPE_CD_ROM_DEVICE (noise_plugins_cd_rom_device_get_type ())
#define NOISE_PLUGINS_CD_ROM_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_PLUGINS_TYPE_CD_ROM_DEVICE, NoisePluginsCDRomDevice))
#define NOISE_PLUGINS_CD_ROM_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_PLUGINS_TYPE_CD_ROM_DEVICE, NoisePluginsCDRomDeviceClass))
#define NOISE_PLUGINS_IS_CD_ROM_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_PLUGINS_TYPE_CD_ROM_DEVICE))
#define NOISE_PLUGINS_IS_CD_ROM_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_PLUGINS_TYPE_CD_ROM_DEVICE))
#define NOISE_PLUGINS_CD_ROM_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_PLUGINS_TYPE_CD_ROM_DEVICE, NoisePluginsCDRomDeviceClass))

typedef struct _NoisePluginsCDRomDevice NoisePluginsCDRomDevice;
typedef struct _NoisePluginsCDRomDeviceClass NoisePluginsCDRomDeviceClass;
enum  {
	NOISE_PLUGINS_CD_ROM_DEVICE_MANAGER_0_PROPERTY,
	NOISE_PLUGINS_CD_ROM_DEVICE_MANAGER_NUM_PROPERTIES
};
static GParamSpec* noise_plugins_cd_rom_device_manager_properties[NOISE_PLUGINS_CD_ROM_DEVICE_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _NoisePluginsCDRomDeviceManager {
	GObject parent_instance;
	NoisePluginsCDRomDeviceManagerPrivate * priv;
};

struct _NoisePluginsCDRomDeviceManagerClass {
	GObjectClass parent_class;
	void (*mount_added) (NoisePluginsCDRomDeviceManager* self, GMount* mount);
	void (*mount_changed) (NoisePluginsCDRomDeviceManager* self, GMount* mount);
	void (*mount_pre_unmount) (NoisePluginsCDRomDeviceManager* self, GMount* mount);
	void (*mount_removed) (NoisePluginsCDRomDeviceManager* self, GMount* mount);
};

struct _NoisePluginsCDRomDeviceManagerPrivate {
	GeeArrayList* devices;
};

static gint NoisePluginsCDRomDeviceManager_private_offset;
static gpointer noise_plugins_cd_rom_device_manager_parent_class = NULL;
static GType noise_plugins_cd_rom_device_manager_type_id = 0;

GType noise_plugins_cd_rom_device_manager_register_type (GTypeModule * module);
GType noise_plugins_cd_rom_device_manager_get_type (void) G_GNUC_CONST;
GType noise_plugins_cd_rom_device_register_type (GTypeModule * module);
GType noise_plugins_cd_rom_device_get_type (void) G_GNUC_CONST;
NoisePluginsCDRomDeviceManager* noise_plugins_cd_rom_device_manager_new (void);
NoisePluginsCDRomDeviceManager* noise_plugins_cd_rom_device_manager_construct (GType object_type);
void noise_plugins_cd_rom_device_manager_mount_added (NoisePluginsCDRomDeviceManager* self,
                                                      GMount* mount);
static void _noise_plugins_cd_rom_device_manager_mount_added_noise_device_manager_mount_added (NoiseDeviceManager* _sender,
                                                                                        GMount* mount,
                                                                                        gpointer self);
void noise_plugins_cd_rom_device_manager_mount_removed (NoisePluginsCDRomDeviceManager* self,
                                                        GMount* mount);
static void _noise_plugins_cd_rom_device_manager_mount_removed_noise_device_manager_mount_removed (NoiseDeviceManager* _sender,
                                                                                            GMount* mount,
                                                                                            gpointer self);
void noise_plugins_cd_rom_device_manager_remove_all (NoisePluginsCDRomDeviceManager* self);
static void noise_plugins_cd_rom_device_manager_real_mount_added (NoisePluginsCDRomDeviceManager* self,
                                                           GMount* mount);
NoisePluginsCDRomDevice* noise_plugins_cd_rom_device_new (GMount* mount);
NoisePluginsCDRomDevice* noise_plugins_cd_rom_device_construct (GType object_type,
                                                                GMount* mount);
static void ____lambda9_ (NoisePluginsCDRomDeviceManager* self,
                   NoiseDevice* d);
static void _____lambda9__noise_device_initialized (NoiseDevice* _sender,
                                             NoiseDevice* d,
                                             gpointer self);
void noise_plugins_cd_rom_device_manager_mount_changed (NoisePluginsCDRomDeviceManager* self,
                                                        GMount* mount);
static void noise_plugins_cd_rom_device_manager_real_mount_changed (NoisePluginsCDRomDeviceManager* self,
                                                             GMount* mount);
void noise_plugins_cd_rom_device_manager_mount_pre_unmount (NoisePluginsCDRomDeviceManager* self,
                                                            GMount* mount);
static void noise_plugins_cd_rom_device_manager_real_mount_pre_unmount (NoisePluginsCDRomDeviceManager* self,
                                                                 GMount* mount);
static void noise_plugins_cd_rom_device_manager_real_mount_removed (NoisePluginsCDRomDeviceManager* self,
                                                             GMount* mount);
static void noise_plugins_cd_rom_device_manager_finalize (GObject * obj);

static inline gpointer
noise_plugins_cd_rom_device_manager_get_instance_private (NoisePluginsCDRomDeviceManager* self)
{
	return G_STRUCT_MEMBER_P (self, NoisePluginsCDRomDeviceManager_private_offset);
}

static void
_noise_plugins_cd_rom_device_manager_mount_added_noise_device_manager_mount_added (NoiseDeviceManager* _sender,
                                                                                   GMount* mount,
                                                                                   gpointer self)
{
	noise_plugins_cd_rom_device_manager_mount_added ((NoisePluginsCDRomDeviceManager*) self, mount);
}

static void
_noise_plugins_cd_rom_device_manager_mount_removed_noise_device_manager_mount_removed (NoiseDeviceManager* _sender,
                                                                                       GMount* mount,
                                                                                       gpointer self)
{
	noise_plugins_cd_rom_device_manager_mount_removed ((NoisePluginsCDRomDeviceManager*) self, mount);
}

NoisePluginsCDRomDeviceManager*
noise_plugins_cd_rom_device_manager_construct (GType object_type)
{
	NoisePluginsCDRomDeviceManager * self = NULL;
	GeeArrayList* _tmp0_;
	NoiseDeviceManager* device_manager = NULL;
	NoiseDeviceManager* _tmp1_;
	NoiseDeviceManager* _tmp2_;
	NoiseDeviceManager* _tmp3_;
	self = (NoisePluginsCDRomDeviceManager*) g_object_new (object_type, NULL);
	_tmp0_ = gee_array_list_new (NOISE_PLUGINS_TYPE_CD_ROM_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->devices);
	self->priv->devices = _tmp0_;
	_tmp1_ = noise_device_manager_get_default ();
	device_manager = _tmp1_;
	_tmp2_ = device_manager;
	g_signal_connect_object (_tmp2_, "mount-added", (GCallback) _noise_plugins_cd_rom_device_manager_mount_added_noise_device_manager_mount_added, self, 0);
	_tmp3_ = device_manager;
	g_signal_connect_object (_tmp3_, "mount-removed", (GCallback) _noise_plugins_cd_rom_device_manager_mount_removed_noise_device_manager_mount_removed, self, 0);
	{
		GeeIterator* _mount_it = NULL;
		NoiseDeviceManager* _tmp4_;
		GeeCollection* _tmp5_;
		GeeCollection* _tmp6_;
		GeeIterator* _tmp7_;
		GeeIterator* _tmp8_;
		_tmp4_ = device_manager;
		_tmp5_ = noise_device_manager_get_available_mounts (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = gee_iterable_iterator ((GeeIterable*) _tmp6_);
		_tmp8_ = _tmp7_;
		_g_object_unref0 (_tmp6_);
		_mount_it = _tmp8_;
		while (TRUE) {
			GeeIterator* _tmp9_;
			GMount* mount = NULL;
			GeeIterator* _tmp10_;
			gpointer _tmp11_;
			GMount* _tmp12_;
			_tmp9_ = _mount_it;
			if (!gee_iterator_next (_tmp9_)) {
				break;
			}
			_tmp10_ = _mount_it;
			_tmp11_ = gee_iterator_get (_tmp10_);
			mount = (GMount*) _tmp11_;
			_tmp12_ = mount;
			noise_plugins_cd_rom_device_manager_mount_added (self, _tmp12_);
		}
		_g_object_unref0 (_mount_it);
	}
	_g_object_unref0 (device_manager);
	return self;
}

NoisePluginsCDRomDeviceManager*
noise_plugins_cd_rom_device_manager_new (void)
{
	return noise_plugins_cd_rom_device_manager_construct (NOISE_PLUGINS_TYPE_CD_ROM_DEVICE_MANAGER);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
noise_plugins_cd_rom_device_manager_remove_all (NoisePluginsCDRomDeviceManager* self)
{
	NoiseDeviceManager* device_manager = NULL;
	NoiseDeviceManager* _tmp0_;
	GeeArrayList* _tmp10_;
	g_return_if_fail (self != NULL);
	_tmp0_ = noise_device_manager_get_default ();
	device_manager = _tmp0_;
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp1_;
		GeeArrayList* _tmp2_;
		gint _dev_size = 0;
		GeeArrayList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _dev_index = 0;
		_tmp1_ = self->priv->devices;
		_tmp2_ = _g_object_ref0 (_tmp1_);
		_dev_list = _tmp2_;
		_tmp3_ = _dev_list;
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
		_tmp5_ = _tmp4_;
		_dev_size = _tmp5_;
		_dev_index = -1;
		while (TRUE) {
			NoisePluginsCDRomDevice* dev = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			NoiseDeviceManager* _tmp8_;
			NoisePluginsCDRomDevice* _tmp9_;
			_dev_index = _dev_index + 1;
			if (!(_dev_index < _dev_size)) {
				break;
			}
			_tmp6_ = _dev_list;
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _dev_index);
			dev = (NoisePluginsCDRomDevice*) _tmp7_;
			_tmp8_ = device_manager;
			_tmp9_ = dev;
			g_signal_emit_by_name (_tmp8_, "device-removed", G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, NOISE_TYPE_DEVICE, NoiseDevice));
			_g_object_unref0 (dev);
		}
		_g_object_unref0 (_dev_list);
	}
	_tmp10_ = gee_array_list_new (NOISE_PLUGINS_TYPE_CD_ROM_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->devices);
	self->priv->devices = _tmp10_;
	_g_object_unref0 (device_manager);
}

static void
____lambda9_ (NoisePluginsCDRomDeviceManager* self,
              NoiseDevice* d)
{
	NoiseDeviceManager* _tmp0_;
	NoiseDeviceManager* _tmp1_;
	g_return_if_fail (d != NULL);
	_tmp0_ = noise_device_manager_get_default ();
	_tmp1_ = _tmp0_;
	noise_device_manager_device_initialized (_tmp1_, G_TYPE_CHECK_INSTANCE_CAST (d, NOISE_TYPE_DEVICE, NoiseDevice));
	_g_object_unref0 (_tmp1_);
}

static void
_____lambda9__noise_device_initialized (NoiseDevice* _sender,
                                        NoiseDevice* d,
                                        gpointer self)
{
	____lambda9_ ((NoisePluginsCDRomDeviceManager*) self, d);
}

static void
noise_plugins_cd_rom_device_manager_real_mount_added (NoisePluginsCDRomDeviceManager* self,
                                                      GMount* mount)
{
	gboolean _tmp15_ = FALSE;
	GFile* _tmp16_;
	GFile* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gboolean _tmp20_;
	g_return_if_fail (mount != NULL);
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp0_;
		GeeArrayList* _tmp1_;
		gint _dev_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _dev_index = 0;
		_tmp0_ = self->priv->devices;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_dev_list = _tmp1_;
		_tmp2_ = _dev_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_dev_size = _tmp4_;
		_dev_index = -1;
		while (TRUE) {
			NoisePluginsCDRomDevice* dev = NULL;
			GeeArrayList* _tmp5_;
			gpointer _tmp6_;
			NoisePluginsCDRomDevice* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			GFile* _tmp10_;
			GFile* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			gboolean _tmp14_;
			_dev_index = _dev_index + 1;
			if (!(_dev_index < _dev_size)) {
				break;
			}
			_tmp5_ = _dev_list;
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _dev_index);
			dev = (NoisePluginsCDRomDevice*) _tmp6_;
			_tmp7_ = dev;
			_tmp8_ = noise_device_get_uri ((NoiseDevice*) _tmp7_);
			_tmp9_ = _tmp8_;
			_tmp10_ = g_mount_get_default_location (mount);
			_tmp11_ = _tmp10_;
			_tmp12_ = g_file_get_uri (_tmp11_);
			_tmp13_ = _tmp12_;
			_tmp14_ = g_strcmp0 (_tmp9_, _tmp13_) == 0;
			_g_free0 (_tmp13_);
			_g_object_unref0 (_tmp11_);
			_g_free0 (_tmp9_);
			if (_tmp14_) {
				_g_object_unref0 (dev);
				_g_object_unref0 (_dev_list);
				return;
			}
			_g_object_unref0 (dev);
		}
		_g_object_unref0 (_dev_list);
	}
	_tmp16_ = g_mount_get_default_location (mount);
	_tmp17_ = _tmp16_;
	_tmp18_ = g_file_get_uri (_tmp17_);
	_tmp19_ = _tmp18_;
	_tmp20_ = g_str_has_prefix (_tmp19_, "cdda://");
	_g_free0 (_tmp19_);
	_g_object_unref0 (_tmp17_);
	if (_tmp20_) {
		GVolume* _tmp21_;
		GVolume* _tmp22_;
		_tmp21_ = g_mount_get_volume (mount);
		_tmp22_ = _tmp21_;
		_tmp15_ = _tmp22_ != NULL;
		_g_object_unref0 (_tmp22_);
	} else {
		_tmp15_ = FALSE;
	}
	if (_tmp15_) {
		NoisePluginsCDRomDevice* added = NULL;
		NoisePluginsCDRomDevice* _tmp23_;
		NoisePluginsCDRomDevice* _tmp24_;
		GeeArrayList* _tmp25_;
		NoisePluginsCDRomDevice* _tmp26_;
		NoisePluginsCDRomDevice* _tmp27_;
		g_debug ("CDRomDeviceManager.vala:60: Adding CD to list");
		_tmp23_ = noise_plugins_cd_rom_device_new (mount);
		added = _tmp23_;
		_tmp24_ = added;
		noise_device_set_mount ((NoiseDevice*) _tmp24_, mount);
		_tmp25_ = self->priv->devices;
		_tmp26_ = added;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp25_, _tmp26_);
		_tmp27_ = added;
		if (noise_device_start_initialization ((NoiseDevice*) _tmp27_)) {
			NoisePluginsCDRomDevice* _tmp28_;
			NoisePluginsCDRomDevice* _tmp29_;
			_tmp28_ = added;
			noise_device_finish_initialization ((NoiseDevice*) _tmp28_);
			_tmp29_ = added;
			g_signal_connect_object ((NoiseDevice*) _tmp29_, "initialized", (GCallback) _____lambda9__noise_device_initialized, self, 0);
		} else {
			NoisePluginsCDRomDevice* _tmp30_;
			GMount* _tmp31_;
			GMount* _tmp32_;
			_tmp30_ = added;
			_tmp31_ = noise_device_get_mount ((NoiseDevice*) _tmp30_);
			_tmp32_ = _tmp31_;
			noise_plugins_cd_rom_device_manager_mount_removed (self, _tmp32_);
			_g_object_unref0 (_tmp32_);
		}
		_g_object_unref0 (added);
	} else {
		GFile* _tmp33_;
		GFile* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		_tmp33_ = g_mount_get_default_location (mount);
		_tmp34_ = _tmp33_;
		_tmp35_ = g_file_get_parse_name (_tmp34_);
		_tmp36_ = _tmp35_;
		g_debug ("CDRomDeviceManager.vala:74: Found device at %s is not an Audio CD. Not" \
" using it", _tmp36_);
		_g_free0 (_tmp36_);
		_g_object_unref0 (_tmp34_);
		return;
	}
}

void
noise_plugins_cd_rom_device_manager_mount_added (NoisePluginsCDRomDeviceManager* self,
                                                 GMount* mount)
{
	g_return_if_fail (self != NULL);
	NOISE_PLUGINS_CD_ROM_DEVICE_MANAGER_GET_CLASS (self)->mount_added (self, mount);
}

static void
noise_plugins_cd_rom_device_manager_real_mount_changed (NoisePluginsCDRomDeviceManager* self,
                                                        GMount* mount)
{
	g_return_if_fail (mount != NULL);
}

void
noise_plugins_cd_rom_device_manager_mount_changed (NoisePluginsCDRomDeviceManager* self,
                                                   GMount* mount)
{
	g_return_if_fail (self != NULL);
	NOISE_PLUGINS_CD_ROM_DEVICE_MANAGER_GET_CLASS (self)->mount_changed (self, mount);
}

static void
noise_plugins_cd_rom_device_manager_real_mount_pre_unmount (NoisePluginsCDRomDeviceManager* self,
                                                            GMount* mount)
{
	g_return_if_fail (mount != NULL);
}

void
noise_plugins_cd_rom_device_manager_mount_pre_unmount (NoisePluginsCDRomDeviceManager* self,
                                                       GMount* mount)
{
	g_return_if_fail (self != NULL);
	NOISE_PLUGINS_CD_ROM_DEVICE_MANAGER_GET_CLASS (self)->mount_pre_unmount (self, mount);
}

static void
noise_plugins_cd_rom_device_manager_real_mount_removed (NoisePluginsCDRomDeviceManager* self,
                                                        GMount* mount)
{
	NoiseDeviceManager* device_manager = NULL;
	NoiseDeviceManager* _tmp0_;
	g_return_if_fail (mount != NULL);
	_tmp0_ = noise_device_manager_get_default ();
	device_manager = _tmp0_;
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp1_;
		GeeArrayList* _tmp2_;
		gint _dev_size = 0;
		GeeArrayList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _dev_index = 0;
		_tmp1_ = self->priv->devices;
		_tmp2_ = _g_object_ref0 (_tmp1_);
		_dev_list = _tmp2_;
		_tmp3_ = _dev_list;
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
		_tmp5_ = _tmp4_;
		_dev_size = _tmp5_;
		_dev_index = -1;
		while (TRUE) {
			NoisePluginsCDRomDevice* dev = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			NoisePluginsCDRomDevice* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			GFile* _tmp11_;
			GFile* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			gboolean _tmp15_;
			_dev_index = _dev_index + 1;
			if (!(_dev_index < _dev_size)) {
				break;
			}
			_tmp6_ = _dev_list;
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _dev_index);
			dev = (NoisePluginsCDRomDevice*) _tmp7_;
			_tmp8_ = dev;
			_tmp9_ = noise_device_get_uri ((NoiseDevice*) _tmp8_);
			_tmp10_ = _tmp9_;
			_tmp11_ = g_mount_get_default_location (mount);
			_tmp12_ = _tmp11_;
			_tmp13_ = g_file_get_uri (_tmp12_);
			_tmp14_ = _tmp13_;
			_tmp15_ = g_strcmp0 (_tmp10_, _tmp14_) == 0;
			_g_free0 (_tmp14_);
			_g_object_unref0 (_tmp12_);
			_g_free0 (_tmp10_);
			if (_tmp15_) {
				NoiseDeviceManager* _tmp16_;
				NoisePluginsCDRomDevice* _tmp17_;
				GeeArrayList* _tmp18_;
				NoisePluginsCDRomDevice* _tmp19_;
				_tmp16_ = device_manager;
				_tmp17_ = dev;
				g_signal_emit_by_name (_tmp16_, "device-removed", G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, NOISE_TYPE_DEVICE, NoiseDevice));
				_tmp18_ = self->priv->devices;
				_tmp19_ = dev;
				gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp18_, _tmp19_);
				_g_object_unref0 (dev);
				_g_object_unref0 (_dev_list);
				_g_object_unref0 (device_manager);
				return;
			}
			_g_object_unref0 (dev);
		}
		_g_object_unref0 (_dev_list);
	}
	_g_object_unref0 (device_manager);
}

void
noise_plugins_cd_rom_device_manager_mount_removed (NoisePluginsCDRomDeviceManager* self,
                                                   GMount* mount)
{
	g_return_if_fail (self != NULL);
	NOISE_PLUGINS_CD_ROM_DEVICE_MANAGER_GET_CLASS (self)->mount_removed (self, mount);
}

static void
noise_plugins_cd_rom_device_manager_class_init (NoisePluginsCDRomDeviceManagerClass * klass,
                                                gpointer klass_data)
{
	noise_plugins_cd_rom_device_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NoisePluginsCDRomDeviceManager_private_offset);
	((NoisePluginsCDRomDeviceManagerClass *) klass)->mount_added = (void (*) (NoisePluginsCDRomDeviceManager*, GMount*)) noise_plugins_cd_rom_device_manager_real_mount_added;
	((NoisePluginsCDRomDeviceManagerClass *) klass)->mount_changed = (void (*) (NoisePluginsCDRomDeviceManager*, GMount*)) noise_plugins_cd_rom_device_manager_real_mount_changed;
	((NoisePluginsCDRomDeviceManagerClass *) klass)->mount_pre_unmount = (void (*) (NoisePluginsCDRomDeviceManager*, GMount*)) noise_plugins_cd_rom_device_manager_real_mount_pre_unmount;
	((NoisePluginsCDRomDeviceManagerClass *) klass)->mount_removed = (void (*) (NoisePluginsCDRomDeviceManager*, GMount*)) noise_plugins_cd_rom_device_manager_real_mount_removed;
	G_OBJECT_CLASS (klass)->finalize = noise_plugins_cd_rom_device_manager_finalize;
}

static void
noise_plugins_cd_rom_device_manager_instance_init (NoisePluginsCDRomDeviceManager * self,
                                                   gpointer klass)
{
	self->priv = noise_plugins_cd_rom_device_manager_get_instance_private (self);
}

static void
noise_plugins_cd_rom_device_manager_finalize (GObject * obj)
{
	NoisePluginsCDRomDeviceManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_PLUGINS_TYPE_CD_ROM_DEVICE_MANAGER, NoisePluginsCDRomDeviceManager);
	_g_object_unref0 (self->priv->devices);
	G_OBJECT_CLASS (noise_plugins_cd_rom_device_manager_parent_class)->finalize (obj);
}

GType
noise_plugins_cd_rom_device_manager_get_type (void)
{
	return noise_plugins_cd_rom_device_manager_type_id;
}

GType
noise_plugins_cd_rom_device_manager_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (NoisePluginsCDRomDeviceManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_plugins_cd_rom_device_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoisePluginsCDRomDeviceManager), 0, (GInstanceInitFunc) noise_plugins_cd_rom_device_manager_instance_init, NULL };
	noise_plugins_cd_rom_device_manager_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "NoisePluginsCDRomDeviceManager", &g_define_type_info, 0);
	NoisePluginsCDRomDeviceManager_private_offset = sizeof (NoisePluginsCDRomDeviceManagerPrivate);
	return noise_plugins_cd_rom_device_manager_type_id;
}

